package Klava;

import java.io.IOException;

public class AcceptNetNode extends NetNode {
  protected AcceptNodeCoordinator accept_nodecoord;
  protected DisconnectedNodeCoordinator disconnected_nodecoord;

  public AcceptNetNode( String loc, int my_port, String NetHostName, int NetPort )
      throws IOException, KlavaException {
    super(loc, my_port, NetHostName, NetPort);
    accept_nodecoord = newAcceptNodeCoordinator();
    addProcess(accept_nodecoord);
    disconnected_nodecoord = newDisconnectedNodeCoordinator();
    addProcess(disconnected_nodecoord);
  }

  public AcceptNetNode( String loc, int my_port ) throws IOException, KlavaException {
    this(loc, my_port, null, -1);
  }

  protected AcceptNodeCoordinator newAcceptNodeCoordinator() {
    return new AcceptNodeCoordinator();
  }

  protected DisconnectedNodeCoordinator newDisconnectedNodeCoordinator() {
    return new DisconnectedNodeCoordinator();
  }

  public void logAccept() {
    setProcessMessagePrinter(accept_nodecoord);
  }

  public void logDisconnected() {
    setProcessMessagePrinter(disconnected_nodecoord);
  }

  public static void main( String args[] ) throws java.io.IOException, KlavaException {
    if ( args.length < 2 || args.length > 5 ||
          (args.length > 2 && args.length < 4 ) )
      throw new
      java.io.IOException
      ( "Syntax : AcceptNetNode <name> <my_port> {<hostname> <port> {DirConnect}}" ) ;

    NetNode n;
    if (args.length > 2)
      n = new AcceptNetNode( args[0], Integer.parseInt(args[1]),
        args[2], Integer.parseInt( args[3] ) ) ;
    else
      n = new AcceptNetNode( args[0], Integer.parseInt(args[1]));

    if ( args.length == 5 )
      n.setDirectConnections() ;

    n.start() ;
  }
}