/**
 * Base class for a generic NodeCoordinator that waits for connections
 */

package Klava;

public class AcceptNodeCoordinator extends NodeCoordinator {
  protected boolean one_time;

  public AcceptNodeCoordinator() {
    this(false);
  }

  public AcceptNodeCoordinator(boolean one_time) {
    this.one_time = one_time;
  }

  public void execute() throws Klava.KlavaException {
    PhysicalLocality loc;
    while (true) {
      loc = new PhysicalLocality();
      accept(loc);
      connection_tookplace(loc);
      if (one_time)
        break;
    }
  }

  protected void connection_tookplace(PhysicalLocality loc) {
    Print("New locality: " + loc);
  }
}