/**
 * Base class for a generic NodeCoordinator that waits for disconnections;
 * also deals with logical localities
 */

package Klava;

public class DisconnectedLogLocNodeCoordinator extends NodeCoordinator {
  public void execute() throws Klava.KlavaException {
    LogicalLocality lloc;
    PhysicalLocality loc;
    while (true) {
      lloc = new LogicalLocality();
      loc = new PhysicalLocality();
      disconnected(loc, lloc);
      disconnection_tookplace(lloc, loc);
    }
  }

  protected void disconnection_tookplace(LogicalLocality lloc,
                                         PhysicalLocality loc) {
    Print("Disconnection: " + lloc + " ~ " + loc);
  }
}