package Klava;

import java.util.*;
import java.io.FileNotFoundException;
import java.io.IOException;

public class FileMessagePrinterFactory extends MessagePrinterFactory {
  // ( name, MessagePrinter )
  protected Hashtable files = new Hashtable();

  public MessagePrinter createMessagePrinter(String name, MessagePrinter p) {
    FileMessagePrinter printer = new FileMessagePrinter
      (name, prefix, suffix, p);

    files.put(printer.getFileName(), printer);

    return printer;
  }

  public void closeAllFiles() throws java.io.IOException {
    Enumeration en = files.elements();

    while (en.hasMoreElements())
      ((FileMessagePrinter) (en.nextElement())).close();
  }

  public void sortFiles(Vector names) throws FileNotFoundException,
                                             IOException {
    Enumeration filenames = names.elements();
    String filename;
    FileMessagePrinter printer;

    while (filenames.hasMoreElements()) {
      filename = (String) filenames.nextElement();
      printer = (FileMessagePrinter) files.get(filename);
      if (printer == null)
        throw new FileNotFoundException(filename);

      printer.sort();
    }
  }

  public void sortFiles(String pattern) throws FileNotFoundException,
                                               IOException {
    Vector names = new Vector();
    Enumeration en = files.keys();
    String name;

    while (en.hasMoreElements()) {
      name = (String) en.nextElement();
      if ( name.indexOf(pattern) != -1 )
        names.addElement(name);
    }

    sortFiles(names);
  }
}