package Klava ;

public class InReadThread extends Thread {
  NetNode parentNode ;
  NodeMessage message ;

  public InReadThread( NetNode n, NodeMessage m ) {
    super() ;
    parentNode = n ;
    message = m ;
  }

  public void run() {
    int response = NodeMessage.RESPONSE;

    parentNode.Print( "InReadThread " + message.ProcessName + " waiting..." ) ;
    try {
      if( message.OpCode == NodeMessage.IN ) {
        parentNode._in( (Tuple) message.Content, message.TimeOut ) ;
        response = NodeMessage.RESPONSEIN ;
      } else if ( message.OpCode == NodeMessage.READ ) {
        parentNode._read( (Tuple) message.Content, message.TimeOut ) ;
      } else {
        return ;
      }
      parentNode.Print( "InReadThread " + message.ProcessName + " OK" ) ;

      parentNode.SendMessage( parentNode.ThisLocality(),
                              message.Source, message.ProcessName,
                              response, (Tuple) message.Content,
                              message.TimeOut, true, false ) ;
    } catch ( KlavaTimeOutException toe ) {
      parentNode.Print( "InReadThread " + message.ProcessName + " TIMEOUT" );
    }
  }
}
