package Klava ;

// Customized String

public class KString implements TupleItem {

  public String string ;

  public KString() { string = null ; }
  public KString( char[] s ) { string = new String(s) ; }
  public KString( String s ) { string = new String(s) ; }
  public KString( KString s ) {
      string = ( s.isFormal () ?
                 null :
                 new String( s.toString() )) ;
  }

  public String toString() {
    if ( string != null )
      return string ;
    else
      return "!KString" ;
  }

  public int hashCode() {
    return string.hashCode() ;
  }

  // TupleItem methods
  public boolean isFormal() { return (string==null) ; }

  public void setFormal() { string = null ; }

  public void setValue( Object o ) {
    try {
      if ( o != null ) {
        String s = ((KString)o).string ;
        if ( s == null )
            string = null;
        else
            string = new String( s ) ;
      }
    } catch ( ClassCastException e ) {
      System.err.println( "KString : " + e ) ;
    }
  }

  public boolean equals( Object o ) {
    return string.equals( o.toString() ) ;
  }

  public boolean equalsIgnoreCase( Object o ) {
    if ( o instanceof String )
      return string.equalsIgnoreCase( (String)o ) ;
    else
      return string.equalsIgnoreCase( ((KString)o).string ) ;
  }

  public int compareTo( String s ) {
      if (string == null)
	  return -1;

      if (s == null)
	  return +1;

      return string.compareTo (s);
  }

  public int compareTo(KString s) {
    if (s == null)
      return +1;

    return compareTo (s.string);
  }

  public String concat(String s) {
    if (string == null)
      string = new String();

    return string.concat(s);
  }

  public String concat(KString s) {
    return concat(s.string);
  }

  public Object duplicate() {
    return new KString( this ) ;
  }
}
