
//Title:       Klava
//Version:
//Copyright:   Copyright (c) 1998
//Author:      Lorenzo Bettini
//Company:     Dipartimento di Sistemi e Informatica, Univ. di Firenze
//Description: a Java Framework for Mobile Code
package Klava;

import java.awt.*;
import java.awt.event.*;
import java.applet.*;

//import com.sun.java.swing.UIManager;
public class KlavaApplet extends Applet
{
  protected NodeAppletInt node = null;

  protected boolean isStandalone = false;
  Panel login_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  GridLayout gridLayout1 = new GridLayout();
  Panel button_panel = new Panel();
  Button login_button = new Button();
  Label label2 = new Label();
  TextField server_text = new TextField();
  Button disconnect_button = new Button();
  Panel message_panel = new Panel();
  KlavaMonitorPanel MessageArea =
    new KlavaMonitorPanel( "System Messages", new KlavaMonitorTextAreaPanel() );
  BorderLayout borderLayout2 = new BorderLayout();
  Panel server_panel = new Panel();
  GridLayout gridLayout2 = new GridLayout();
  Label label3 = new Label();
  TextField port_text = new TextField();
  Panel loginname_panel = new Panel();
  GridLayout gridLayout3 = new GridLayout();
  TextField login_text = new TextField();
  Label label1 = new Label();

//Get a parameter value

  public String getParameter(String key, String def)
  {
    return isStandalone ? System.getProperty(key, def) :
      (getParameter(key) != null ? getParameter(key) : def);
  }

  //Construct the applet

  public KlavaApplet()
  {
  }
//Initialize the applet

  public void init()
  {
    try
    {
    jbInit();
    }
    catch (Exception e)
    {
    e.printStackTrace();
    }
  }
  //static {
  //  try {
  //    //UIManager.setLookAndFeel(new com.sun.java.swing.plaf.metal.MetalLookAndFeel());
  //    //UIManager.setLookAndFeel(new com.sun.java.swing.plaf.motif.MotifLookAndFeel());
  //    UIManager.setLookAndFeel(new com.sun.java.swing.plaf.windows.WindowsLookAndFeel());
  //  }
  //  catch (Exception e) {}
  //}
//Component initialization

  private void jbInit() throws Exception
  {
    this.setSize(400,300);
    this.setLayout(borderLayout1);
    login_panel.setLayout(gridLayout1);
    gridLayout1.setRows(3);
    gridLayout1.setColumns(1);
    login_button.setLabel("login");
    label2.setText("Klava Net Server");
    disconnect_button.setLabel("disconnect");
    gridLayout2.setRows(2);
    gridLayout2.setColumns(2);
    label3.setText("port number");
    port_text.setText("9999");
    gridLayout3.setRows(2);
    gridLayout3.setColumns(1);
    label1.setText("local port number, or physical locality");
    loginname_panel.setLayout(gridLayout3);
    server_panel.setLayout(gridLayout2);
    message_panel.setLayout(borderLayout2);
    disconnect_button.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        disconnect_button_actionPerformed(e);
      }
    });
    login_button.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        login_button_actionPerformed(e);
      }
    });
    this.add(login_panel, BorderLayout.NORTH);
    login_panel.add(loginname_panel, null);
    login_panel.add(server_panel, null);
    login_panel.add(button_panel, null);
    button_panel.add(login_button, null);
    button_panel.add(disconnect_button, null);

    loginname_panel.add(label1, null);
    loginname_panel.add(login_text, null);

    server_panel.add(label2, null);
    server_panel.add(label3, null);
    server_panel.add(server_text, null);
    server_panel.add(port_text, null);
    this.add(message_panel, BorderLayout.CENTER);
    message_panel.add(MessageArea, BorderLayout.CENTER);
  }
//Start the applet

  public void start()
  {
    System.out.println ("Klava Applet Started" );
    server_text.setText (getCodeBase().getHost());
  }
//Stop the applet

  public void stop()
  {
    stopNode ();
    System.out.println ("KlavaApplet stopped");
  }
//Destroy the applet

  public void destroy()
  {
  }
//Get Applet information

  public String getAppletInfo()
  {
    return "Applet Information";
  }
//Get parameter info

  public String[][] getParameterInfo()
  {
    return null;
  }
//Main method

  public static void main(String[] args)
  {
    KlavaApplet applet = new KlavaApplet();
    applet.isStandalone = true;
    Frame frame = new Frame();
    frame.setTitle("Applet Frame");
    frame.add(applet, BorderLayout.CENTER);
    applet.init();
    applet.start();
    frame.setSize(400,320);
    Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
    frame.setLocation((d.width - frame.getSize().width) / 2, (d.height - frame.getSize().height) / 2);
    frame.setVisible(true);
  }

  protected void startNode( String login_name, PhysicalLocality ploc,
                            String server_name, int port )
    throws java.io.IOException, KlavaException
  {
    node = newNodeApplet (login_name, ploc, server_name, port);
    node.setKlavaApplet(this);

    node.start ();
  }

  protected NodeAppletInt newNodeApplet(String login_name, PhysicalLocality ploc,
                                        String server_name,
                                        int port)
      throws java.io.IOException, KlavaException {
    return new NodeApplet(login_name, ploc.toString(), server_name, port,
                          MessageArea, MessageArea);
  }

  void login_button_actionPerformed(ActionEvent e)
  {
    int port ;
    try
      {
        port = Integer.parseInt (port_text.getText ());
        String login_name = login_text.getText ();
        String server_name = server_text.getText ();

        if ( login_name.length () == 0 )
          {
            PrintErrorMessage
            ("You must specify a local port number, or physical locality");
            return ;
          }

        if ( server_name.length () == 0 )
          {
            PrintErrorMessage ("You must specify a server name");
            return ;
          }

        try
          {
            PrintMessage ("Starting Node " + login_name + " ..." ) ;
            startNode (login_name, NetUtils.buildMyPhyLoc(login_name),
                       server_name, port);
          }
        catch ( java.io.IOException ex ) { ex.printStackTrace (); }
      }
    catch ( NumberFormatException ne )
    {
        ne.printStackTrace();
        PrintErrorMessage ("Invalid port number");
    }
    catch (KlavaMalformedPhyLocalityException mfl)
    {
        mfl.printStackTrace();
        PrintErrorMessage ("Malformed physical locality");
    }
    catch (KlavaException ke) {
        ke.printStackTrace();
        PrintErrorMessage ("KlavaException: " + ke.getMessage());
    }
  }

  void disconnect_button_actionPerformed(ActionEvent e)
  {
    stopNode ();
  }

  protected void stopNode()
  {
    if ( node != null && node.isAlive () )
      node.Close ();
  }

  protected void PrintErrorMessage(String s)
  {
    PrintMessage ("ERROR: *** " + s + " ***");
  }

  protected void PrintMessage(String s)
  {
    MessageArea.addElem (s + "\n");
  }

  public KlavaMonitorPanel getMessageArea()
  {
    return MessageArea;
  }
}

