/**
 * Generic frame that can be closed and connected to a NetNode
 */

package Klava;

import java.awt.*;
import java.awt.event.*;

public class KlavaFrame extends Frame {

  protected NetNode node ;

  public KlavaFrame( String title ) { this( title, (NetNode)null ) ;  }
  public KlavaFrame( String title, NetNode n ) {
    super(title) ;
    node = n ;
    try  {
      jbInit();
      if ( n instanceof withPanel )
          add( ((withPanel)n).getPanel() ) ;
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public KlavaFrame( String title, Component c ) {
    super(title) ;
    try  {
      jbInit();
      add( c ) ;
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  public void setNode( NetNode n ) { node = n ; }

  private void jbInit() throws Exception {
    this.addWindowListener(new java.awt.event.WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        this_windowClosing(e);
      }
    });
  }

  void this_windowClosing(WindowEvent e) {
    close_frame ();
  }

  protected void close_frame()
  {
    if ( node != null ) {
      node.Close () ;
      dispose() ;
    } else
      System.exit(0) ;
  }
}

