
//Title:        Klava
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Lorenzo Bettini
//Company:      University of Florence
//Description:  Your description

package Klava;

import java.awt.*;
import java.util.Enumeration ;
import java.util.Vector ;

public class KlavaMonitorListPanel extends Panel implements KlavaMonitor {
  BorderLayout borderLayout1 = new BorderLayout();
  List list = new List();


  public KlavaMonitorListPanel() {
    try  {
      jbInit();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

  // KlavaMonitor interface
  public Component getArea() { return this ; }

  // public void setVisible( boolean b ) ; implemented by Base class

  public void addElem( Object o ) {
    Tuple t;
    boolean done = false;

    if (o instanceof Tuple) {
      t = (Tuple) o;
      Object string = t.getItem (0);

      if (string instanceof KString &&
          ((KString)string).equalsIgnoreCase("COMMAND"))
        return; // we don't show commands

      /*
      if (t.length() == 1 &&
          ( string instanceof String || string instanceof KString )) {
        list.add (string.toString ());
        done = true;
      }
      */
    }

    if (! done)
      list.add( o.toString() ) ;
  }

  public void removeElem( Object o ) {
    String s = o.toString() ;
    synchronized ( list ) {
      for ( int i = 0 ; i < list.getItemCount() ; ++i ) {
        if ( list.getItem( i ).equals( s ) ) {
	        list.remove( i ) ;
          break ;
        }
      }
    }
  }
  public void removeAll() { list.removeAll() ; }
  public Enumeration getElements() {
    synchronized ( list ) {
      Vector v = new Vector( list.getItemCount() ) ;
      for ( int i = 0 ; i < list.getItemCount() ; ++i ) {
        v.addElement( list.getItem( i ) ) ;
      }
      return v.elements() ;
    }
  }
  public void setMonitor( KlavaMonitor m ) {
    add( m.getArea() ) ;
  }
  // public boolean isVisible() ; implemented by Base class

  void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    this.add(list, BorderLayout.CENTER);
  }
}


