package Klava;

import java.awt.*;
import java.util.Enumeration ;
import java.awt.event.*;

/**
 *
 * @author  Lorenzo Bettini
 * @version
 */
public class KlavaMonitorPanel extends java.awt.Panel implements KlavaMonitor {
  Panel panel1 = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  BorderLayout borderLayout1 = new BorderLayout();
  Label monitorLabel = new Label();
  Checkbox monitorCheck = new Checkbox();

  protected KlavaMonitor monitor ;

  /** Initializes the Form */
  public KlavaMonitorPanel( String label, KlavaMonitor m ) {
    try  {
      jbInit();
      monitorLabel.setText( label ) ;
      setMonitor( m ) ;
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }
  public KlavaMonitorPanel( String label ) { this( label, null ) ; }

  // KlavaMonitor interface
  public Component getArea() { return this ; }
  // setVisible is implemented by Component class
  public void addElem( Object o ) { monitor.addElem( o ) ; }
  public void removeElem( Object o ) { monitor.removeElem( o ) ; }
  public void removeAll() { monitor.removeAll() ; }
  public Enumeration getElements() { return monitor.getElements() ; }
  public void setMonitor( KlavaMonitor m ) {
    if ( m != null ) {
      monitor = m ;
      add( monitor.getArea() ) ;
    }
  }
  // isVisible is implemented by Component class

  private void jbInit() throws Exception {
    this.setLayout(borderLayout1);
    panel1.setLayout(gridLayout1);
    gridLayout1.setColumns(2);
    monitorCheck.setState(true);
    monitorCheck.addItemListener(new java.awt.event.ItemListener() {
      public void itemStateChanged(ItemEvent e) {
        monitorCheck_itemStateChanged(e);
      }
    });
    monitorCheck.setLabel("visible");
    this.add(panel1, BorderLayout.NORTH);
    panel1.add(monitorLabel, null);
    panel1.add(monitorCheck, null);
  }

  void monitorCheck_itemStateChanged(ItemEvent e) {
    if ( monitorCheck.getState() ) {
      monitor.setVisible( true ) ;
      //add( monitor.getArea() ) ;
      monitorCheck.setLabel( "visible" ) ;
    } else {
      monitor.setVisible( false ) ;
      //remove( monitor.getArea() ) ;
      monitorCheck.setLabel( "hidden" ) ;
    }
    repack() ;
  }

    protected void repack() {
        Component p = getParent() ;
        while ( !(p instanceof Frame) ) 
            p = p.getParent() ;
        if (p!=null)
            ((Frame)p).pack() ;    
    }
}
