
//Title:        Klava
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Lorenzo Bettini
//Company:      University of Florence
//Description:  Your description


package Klava;

import java.util.Vector ;
import java.util.Enumeration ;
import java.io.Serializable ;

public class KlavaMonitorableDefault implements KlavaMonitorable, Serializable {
  protected Vector monitors ;

  public KlavaMonitorableDefault() {
    monitors = new Vector() ;
  }

  public synchronized void addMonitor( KlavaMonitor m )
    { if ( m != null ) monitors.addElement( m ) ; }
  public synchronized void removeMonitor( KlavaMonitor m )
    { if ( m != null ) monitors.removeElement( m ) ; }

  public synchronized void notifyAddElement( Object o ) {
    if ( monitors.size() == 1 ) { // for efficiency
      (( KlavaMonitor )monitors.elementAt(0)).addElem(o) ;
      return ;
    }

    Enumeration en = monitors.elements() ;
    while ( en.hasMoreElements() )
      (( KlavaMonitor )en.nextElement()).addElem( o ) ;
  }

  public synchronized void notifyRemoveElement( Object o ) {
    KlavaMonitor monitor;
    if ( monitors.size() == 1 ) { // for efficiency
      monitor = ( KlavaMonitor )monitors.elementAt(0);
      monitor.removeElem(o) ;
      return ;
    }

    Enumeration en = monitors.elements() ;
    while ( en.hasMoreElements() )
      (( KlavaMonitor )en.nextElement()).removeElem( o ) ;
  }

  public synchronized void notifyRemoveAll() {
    if ( monitors.size() == 1 ) { // for efficiency
      (( KlavaMonitor )monitors.elementAt(0)).removeAll() ;
      return ;
    }

    Enumeration en = monitors.elements() ;
    while ( en.hasMoreElements() )
      (( KlavaMonitor )en.nextElement()).removeAll() ;
  }
}
