/*
  data structure to record a process together with its class
  it's used to send a process
*/

package Klava ;

import java.io.* ;
import java.util.Vector ;
import java.util.Enumeration ;
import org.mikado.imc.mobility.JavaMigratingPacket;

public class KlavaProcessPacket extends JavaMigratingPacket implements Callable {

    public Vector environment = null ;
    public Object mutex = null ;
    public KlavaProcess otherProcess = null ;
    public transient KlavaProcess caller = null;

    public KlavaProcessPacket( KlavaProcess P,
                               Environment nodeEnv, Vector procEnv )
    throws IOException {
      super( P ) ;
      if ( nodeEnv != null ) {
        P.setEnvironment( procEnv ) ;
        P.setEnvironment( nodeEnv ) ;
        environment = P.getEnvironment() ;
      }
      store_serialized_object(P);
    }

    final public void setMutex( Object mutex, KlavaProcess oP ) {
      this.mutex = mutex ;
      otherProcess = oP ;
    }

    final public void setEnvironment( Environment env ) {
      if ( env != null ) {
        environment.addElement( env ) ;
      }
    }
    final public void setEnvironment( Vector env ) {
      if ( env == null )
        return ;
      Enumeration en = env.elements() ;
      while ( en.hasMoreElements() )
        setEnvironment( (Environment)(en.nextElement()) ) ;
    }

    final public void setCaller( KlavaProcess P ) {
      caller = P;
    }

    final public KlavaProcess getCaller() {
      return caller;
    }

    public String toString() {
      return "KlavaProcessPacket : " + className ;
    }
}
