// A Variable representing a Process

package Klava ;

import java.util.Vector ;

public class KlavaProcessVar implements TupleItem, Callable {

  protected KlavaProcessPacket procPack = null ;
  protected KlavaProcess P = null ;

  public KlavaProcessVar() {}
  public KlavaProcessVar(KlavaProcessPacket p) { procPack = p ; }
  public KlavaProcessVar(KlavaProcess p) { P = p ; }
  public KlavaProcessVar(KlavaProcessVar v ) {
    if ( v.P != null ) 
      P = v.P ;
    else
      procPack = v.procPack ;
  }
  
  public KlavaProcessPacket getProcPacket() { return procPack ; }
  public KlavaProcess getProc() { return P ; }
  public void setProcPack( KlavaProcessPacket p ) { 
    procPack = p ;
    P = null ;
  }
  public void setMutex( Object mutex, KlavaProcess oP ) { 
    if ( P != null ) {
      P.mutex = mutex ;
      P.otherProcess = oP ;
    } else if ( procPack != null ) {
      procPack.setMutex( mutex, oP ) ;
    }
  }
  
  // TupleItem interface methods

  // it's always a formal
  public boolean isFormal() { return true ; }
  
  public void setFormal() { }
  
  public void setValue( Object o ) {
    try {
      if ( o != null )
	procPack = ((KlavaProcessVar)o).procPack ;
    } catch (ClassCastException e ) {
      e.printStackTrace() ;
    }
  }

  public Object duplicate() { return new KlavaProcessVar(this) ; }

  public String toString() {
    if ( P != null )
      return P.toString() ;
    else if ( procPack != null )
      return procPack.toString() ;
    return "!Process" ;
  }

  // interface Callable
  final public void setEnvironment( Environment env ) {
    if ( env != null ) {
      if ( P != null )
        P.setEnvironment( env ) ;
      else if ( procPack != null )
        procPack.setEnvironment( env ) ;
    }
  }
  final public void setEnvironment( Vector env ) {
    if ( env == null )
      return ;
    if ( P != null )
      P.setEnvironment( env ) ;
    else if ( procPack != null )
      procPack.setEnvironment( env ) ;
  }

  final public void setCaller( KlavaProcess caller ) {
    if ( P != null ) 
      P.setCaller( caller );
    else if ( procPack != null )
	procPack.setCaller( caller );							 
  }

  final public KlavaProcess getCaller() {
    KlavaProcess caller = null;
    if ( P != null )
	caller = P.getCaller();
    else if ( procPack != null )
	caller = procPack.getCaller();
    
    return caller;
  }				 	


}
