// base class for localities

package Klava ;

abstract public class Locality implements java.io.Serializable, TupleItem {
  protected Object locality ;

  public Locality() { locality = null ; }

  public Locality( Object l ) {
    locality = l ;
  }

  public Locality( Locality l ) {
    locality = l.locality ;
  }

  public Locality(KString s) {
    if (s != null)
      locality = s.toString();
  }

  // to be implemented in derived classes
  abstract public Object getLocality() ;

  public abstract String toString();

  // TupleItem
  public boolean isFormal() { return (locality == null) ; }

  // setValue is implemented in sub classes
  // duplicate is implemented in sub classes

  public boolean equals( Object o ) {
    return locality.equals( ((Locality)o).locality ) ;
  }

  public int hashCode() {
    return locality.hashCode() ;
  }

  public void setValue( Object o ) {
    try {
      if( o !=  null && ((Locality)o).locality != null )
	locality = new String( (String)((Locality)o).locality ) ;
    } catch ( ClassCastException e ) {
      e.printStackTrace() ;
    }
  }
}

