
//Title:        Klava
//Version:      
//Copyright:    Copyright (c) 2000
//Author:       Lorenzo Bettini
//Company:      Dipartimento di Sistemi e Informatica, Univ. di Firenze
//Description:  a Java Framework for Mobile Code

package Klava;

import java.awt.*;
import java.awt.event.*;

public class MessageBox extends Dialog
{
  Panel dialog_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Panel message_panel = new Panel();
  Panel button_panel = new Panel();
  Button OK_button = new Button();
  Label message_label = new Label();
  BorderLayout borderLayout2 = new BorderLayout();

  public MessageBox(Frame frame, String title, String message, boolean modal)
  {
    this (frame, title, modal);
    message_label.setText (message);
    pack ();
  }

  public MessageBox(Frame frame, String title, boolean modal)
  {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try 
    {
      jbInit();
      add(dialog_panel);
      pack();
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }

  
  public MessageBox(Frame frame)
  {
    this(frame, "", false);
  }

  
  public MessageBox(Frame frame, boolean modal)
  {
    this(frame, "", modal);
  }

  
  public MessageBox(Frame frame, String title)
  {
    this(frame, title, false);
  }

  void jbInit() throws Exception
  {
    dialog_panel.setLayout(borderLayout1);
    message_panel.setLayout(borderLayout2);
    OK_button.setLabel("OK");
    OK_button.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        OK_button_actionPerformed(e);
      }
    });
    message_label.setAlignment(1);
    dialog_panel.add(message_panel, BorderLayout.CENTER);
    message_panel.add(message_label, BorderLayout.CENTER);
    dialog_panel.add(button_panel, BorderLayout.SOUTH);
    button_panel.add(OK_button, null);
  }

  protected void processWindowEvent(WindowEvent e)
  {
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel()
  {
    dispose();
  }

  void OK_button_actionPerformed(ActionEvent e)
  {
    cancel();
  }
}

 
