package Klava;

import java.io.*;

public class MessageReceiver extends Thread {
  protected Thread sibling;
  protected Queue messageQueue ;
  protected ObjectInputStream iObjStream ;
  protected Locality loc ; // if we are connected directly to a node
  // if null it means that we are connected to a Net
  protected boolean closing_connection = false;

  public MessageReceiver (Thread sibling, Queue q, ObjectInputStream i,
                          Locality l ) {
    super ();
    this.sibling = sibling;
    messageQueue = q ;
    iObjStream = i ;
    loc = l ;
  }

  public void run () {
    NodeMessage message ;

    try {
      while ( true ) {
        message = (NodeMessage) iObjStream.readObject() ;
        messageQueue.add( message ) ;
      }
    } catch ( ClassNotFoundException ce ) {
      ce.printStackTrace() ;
    } catch (IOException ex) {
      if ( ! closing_connection )
      {
        // it's a stream problem
        ex.printStackTrace() ;
        if( sibling != null && sibling instanceof NetNode ) {
          if ( loc != null )
            ((NetNode)sibling).lostConnection( loc ) ;
          else
            ((NetNode)sibling).lostNetConnection ();
        }
      }
    } finally {
      System.err.println("MessageReceiver (" +
        (sibling != null ? sibling.getName() : "null") + ") stopped.");
    }
  }

  public void close_connection()
  {
    closing_connection = true;
    try {
      iObjStream.close ();
    } catch (IOException ioe) { ioe.printStackTrace (); }
  }
}

