
//Title:        Klava
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Lorenzo Bettini
//Company:      University of Florence
//Description:  Your description

package Klava;

import java.awt.*;
import java.awt.event.*;

public class MonitorableKeyboardPanel extends Panel
    implements KlavaMonitorable, withPanel {
  TextField textField = new TextField();
  Panel panel1 = new Panel();
  Button buttonOK = new Button();
  Button buttonCancel = new Button();
  FlowLayout flowLayout1 = new FlowLayout();
  BorderLayout borderLayout1 = new BorderLayout();

  protected KlavaMonitorable monitorable ;
  Label labelKeyboard = new Label();

  public MonitorableKeyboardPanel() { this( new KlavaMonitorableDefault() ) ; }
  public MonitorableKeyboardPanel( KlavaMonitorable km  ) { this( km, "" ) ; }
  public MonitorableKeyboardPanel( String label )
    { this( new KlavaMonitorableDefault(), label ) ; }
  public MonitorableKeyboardPanel( KlavaMonitorable km, String label ) {
    try  {
      jbInit();
      monitorable = km ;
      labelKeyboard.setText( label ) ;
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }

    // withPanel interface
    public Panel getPanel() { return this ; }

    // KlavaMonitorable interface
  public void addMonitor( KlavaMonitor m ) { monitorable.addMonitor( m ) ; }
  public void removeMonitor( KlavaMonitor m ) { monitorable.removeMonitor( m ) ; }
  public void notifyAddElement( Object o ) { monitorable.notifyAddElement( o ) ; }
  public void notifyRemoveElement( Object o ) {} // nothing for now
  public void notifyRemoveAll() {} // nothing for now

  void jbInit() throws Exception {
    this.setSize(new Dimension(398, 90));
    textField.addKeyListener(new java.awt.event.KeyAdapter() {
      public void keyPressed(KeyEvent e) {
        textField_keyPressed(e);
      }
    });
    buttonOK.setLabel("OK");
    buttonOK.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        buttonOK_mouseClicked(e);
      }
    });
    buttonCancel.setLabel("Cancel");
    buttonCancel.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        buttonCancel_mouseClicked(e);
      }
    });
    panel1.setLayout(flowLayout1);
    this.setLayout(borderLayout1);
    this.add(textField, BorderLayout.CENTER);
    this.add(panel1, BorderLayout.SOUTH);
    panel1.add(buttonOK, null);
    panel1.add(buttonCancel, null);
    this.add(labelKeyboard, BorderLayout.WEST);
  }

  void buttonOK_mouseClicked(MouseEvent e) {
    notifyAddElement( textField.getText() ) ;
  }

  void buttonCancel_mouseClicked(MouseEvent e) {
    clearText() ;
  }

  void clearText() { textField.setText( "" ) ; }

  void textField_keyPressed(KeyEvent e) {
    switch ( e.getKeyCode() ) {
      case KeyEvent.VK_ENTER :
        notifyAddElement( textField.getText() ) ;
        break ;
      case KeyEvent.VK_ESCAPE :
        clearText() ;
        break ;
    }
  }
}


