package Klava;

import java.io.*;

public class Net extends AcceptNetNode {
  public Net( String loc, int my_port ) throws IOException, KlavaException {
    super(loc, my_port);
    setAutomaticLocalityEvaluation(true);
    setNoLogonServer(true);
    acceptRemoteProcesses(false);
    // for backward compatibility
  }

  public Net() throws IOException, KlavaException {
    this("Net", NetNode.defaultPort);
  }

  public Net(int port) throws IOException, KlavaException {
  this("Net", port);
  }

  protected void PrintNewNode( Locality l ) {
    Print( "New Node at locality : " + l ) ;
  }

  protected void PrintRemovedNode( Locality l ) {
    Print( "Node at " + l + " removed." ) ;
  }

  protected AcceptNodeCoordinator newAcceptNodeCoordinator() {
    return new NetAcceptNodeCoordinator(this);
  }

  protected DisconnectedNodeCoordinator newDisconnectedNodeCoordinator() {
    return new NetDisconnectedNodeCoordinator(this);
  }

  public static void main( String args[] ) throws java.io.IOException, KlavaException {
    if ( args.length > 2 )
      throw new
      java.io.IOException
      ( "Syntax : Net {<my_port>, default=9999} {<name>}" ) ;

    NetNode n;

    String name = (args.length > 1 ? args[1] : "Net");
    int port =
        (args.length > 0 ? Integer.parseInt(args[0]) : NetNode.defaultPort);

    n = new Net( name, port ) ;

    n.start() ;
  }
}