// a Net with graphical interface

package Klava ;

import java.io.* ;

public class NetG extends Net {

  protected NetFrame frame ;

  public NetG( int port ) throws IOException, KlavaException {
    super( port ) ;
    frame = new NetFrame( "Net on port " + port ) ;

    frame.pack() ;
    frame.show() ;
  }

  public void Print( String s ) {
    if (frame == null) // during the constructor
      super.Print(s);
    else
      frame.print( s + "\n" ) ;
  }

  protected void PrintNewNode( PhysicalLocality l ) {
    super.PrintNewNode( l ) ;
    frame.printNewNode(l);
  }

  protected void PrintRemovedNode( PhysicalLocality l ) {
    super.PrintRemovedNode( l ) ;
    frame.printRemovedNode(l);
  }

  public static void main( String args[] ) throws IOException, KlavaException {
    if ( args.length > 1 )
      throw new IOException( "Syntax : Net {port}" ) ;
    int port = Net.defaultPort ;
    if ( args.length == 1 )
      port = Integer.parseInt( args[ 0 ] ) ;
    System.out.println( "Starting Net on port " + port ) ;
    NetG net = new NetG( port ) ;
    net.start() ;
  }
}
