package Klava;

public class NetNodeProxy extends NodeProxy implements NetNodeInterface {
  protected NetNodeInterface netnode;
  // this is a repetition, but it's useful to avoid many casts

  public NetNodeProxy(NetNodeInterface node) {
    super(node);
    netnode = node;
  }

  public void accept(PhysicalLocality loc) {
    netnode.accept(loc);
  }

  public boolean login(Locality loc) throws KlavaException {
    return netnode.login(loc);
  }

  public boolean register(PhysicalLocality ploc, LogicalLocality lloc) {
    return netnode.register(ploc, lloc);
  }

  public boolean subscribe(PhysicalLocality ploc, LogicalLocality lloc)
     throws KlavaException {
    return netnode.subscribe(ploc, lloc);
  }

  public void logout(Locality loc) {
    netnode.logout(loc);
  }

  public void unsubscribe(Locality loc, LogicalLocality myloc)
        throws KlavaException{
    netnode.unsubscribe(loc, myloc);
  }

  public void unregister(LogicalLocality loc) {
    netnode.unregister(loc);
  }

  public void disconnected(PhysicalLocality loc) {
    netnode.disconnected(loc);
  }

  public void disconnected(PhysicalLocality loc, LogicalLocality lloc) {
    netnode.disconnected(loc, lloc);
  }

  public void bindloc(LogicalLocality ll, PhysicalLocality pl)
      throws KlavaException {
    netnode.bindloc(ll, pl);
  }

  public void unbindloc(LogicalLocality ll) throws KlavaException {
    netnode.unbindloc(ll);
  }

  public void acceptconn(PhysicalLocality loc) {
    netnode.acceptconn(loc);
  }

  public boolean dirconnect(Locality loc) throws KlavaException {
    return netnode.dirconnect(loc);
  }
}