package Klava;

import java.io.IOException ;
import org.mikado.imc.mobility.NodeClassLoader;

public class NodeApplet extends NodeConsole implements NodeAppletInt
{
  protected KlavaApplet klava_applet;
  InfoMessages system_out_messages = null;
  InfoMessages system_err_messages = null;

  public NodeApplet( String Name, String Here, String NetHostName, int NetPort )
    throws IOException, KlavaException {
      this( Name, Here, NetHostName, NetPort, null, null ) ;
  }
  public NodeApplet( String Name, String Here, String NetHostName, int NetPort,
                     KlavaMonitor o, KlavaMonitor e )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort  ) ;
      if ( o != null )
        {
          system_out_messages = new InfoMessages ();
          system_out_messages.addMonitor (o);
        }
      if ( e != null )
        {
          system_err_messages = new InfoMessages ();
          system_err_messages.addMonitor (e);
        }
  }

  public void setKlavaApplet(KlavaApplet app) {
    klava_applet = app;
  }

  public void lostNetConnection() {
    klava_applet.stopNode();
  }

  // factory method
  protected Environment newEnvironment( String name )
  {
      try {
          return new Environment ();
          // we don't read any file
      } catch (KlavaMalformedPhyLocalityException mfl) {
          mfl.printStackTrace();
          return null;
      }
  }

  // factory method
  protected NodeClassLoader newNodeClassLoader()
  {
    //return new NodeClassLoader ();
    return null ; // due to Security
  }

  synchronized protected void PrintSystemOutMessage( String s )
  {
    super.PrintSystemOutMessage (s);
    if ( system_out_messages != null )
      system_out_messages.PrintMessage (s + "\n");
  }

  synchronized protected void PrintSystemErrMessage( String s )
  {
    super.PrintSystemErrMessage (s);
    if ( system_err_messages != null )
      system_err_messages.PrintMessage (s + "\n");
  }

  public static void main(String[] args) throws IOException, KlavaException
  {
    NodeApplet nodeApplet = new NodeApplet( "NodeApplet", "9998",
      "localhost", 9999);
    nodeApplet.invokedStandalone = true;
  }
  private boolean invokedStandalone = false;
}