package Klava;

public abstract class NodeCoordinator extends KlavaProcess {
  protected void accept(PhysicalLocality loc) {
    ((NetNodeProxy)node).accept(loc);
  }

  protected boolean register(PhysicalLocality pl, LogicalLocality ll) {
    return ((NetNodeProxy)node).register(pl, ll);
  }

  protected boolean login(Locality loc) throws KlavaException {
    return ((NetNodeProxy)node).login(loc);
  }

  protected boolean subscribe(PhysicalLocality ploc, LogicalLocality lloc)
     throws KlavaException {
    return ((NetNodeProxy)node).subscribe(ploc, lloc);
  }

  protected void logout(Locality loc) {
    ((NetNodeProxy)node).logout(loc);
  }

  protected void unsubscribe(Locality loc, LogicalLocality myloc)
        throws KlavaException {
    ((NetNodeProxy)node).unsubscribe(loc, myloc);
  }

  protected void unregister(LogicalLocality loc) {
    ((NetNodeProxy)node).unregister(loc);
  }

  protected void disconnected(PhysicalLocality loc) {
    ((NetNodeProxy)node).disconnected(loc);
  }

  protected void disconnected(PhysicalLocality loc, LogicalLocality lloc) {
    ((NetNodeProxy)node).disconnected(loc, lloc);
  }

  protected PhysicalLocality newloc(int port) throws KlavaException {
    return node.newloc(port);
  }

  protected PhysicalLocality newloc(NodeCoordinator P) throws KlavaException {
    return node.newloc(P);
  }

  protected PhysicalLocality newloc(NodeCoordinator P, int port,
                                    String classname) throws KlavaException {
    return node.newloc(P, port, classname);
  }

  protected void bindloc(LogicalLocality ll, PhysicalLocality pl)
      throws KlavaException {
    ((NetNodeProxy)node).bindloc(ll, pl);
  }

  protected void unbindloc(LogicalLocality ll) throws KlavaException {
    ((NetNodeProxy)node).unbindloc(ll);
  }

  protected void acceptconn(PhysicalLocality loc) {
    ((NetNodeProxy)node).acceptconn(loc);
  }

  protected boolean dirconnect(Locality loc) throws KlavaException {
    return ((NetNodeProxy)node).dirconnect(loc);
  }
}