
//Title:        Your Product Name
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Your Name
//Company:      Your Company
//Description:  Your description

package Klava;

import java.awt.*;
import java.awt.event.*;
import java.net.InetAddress;

public class NodeFrame extends KlavaFrame 
    implements withNodeMonitors, withPanel {

  protected NodePanel nodePanel ;
  MenuBar menu_bar = new MenuBar();
  Menu menu_file = new Menu();
  MenuItem menuItem1 = new MenuItem();
  MenuItem menuItem2 = new MenuItem();
  Menu menu1 = new Menu();
  MenuItem menuItem3 = new MenuItem();

  public NodeFrame( String title, Node n, TupleSpaceG TS ) {
    super( title, n ) ;
    try  {
      nodePanel = newNodePanel() ;
      jbInit();
      nodePanel.addTSPanel( TS.getPanel() ) ;
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    menu_file.setLabel("File");
    menuItem1.setLabel("Load Process");
    menuItem1.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        menuItem1_actionPerformed(e);
      }
    });
    menuItem2.setLabel("Exit");
    menu1.setLabel("Info");
    menuItem3.setLabel("Connection");
    menuItem3.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        menuItem3_actionPerformed(e);
      }
    });
    menuItem2.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        menuItem2_actionPerformed(e);
      }
    });
    add( nodePanel ) ;
    menu_bar.add(menu_file);
    menu_bar.add(menu1);
    menu_file.add(menuItem1);
    menu_file.addSeparator();
    menu_file.add(menuItem2);
    menu1.add(menuItem3);
    this.setMenuBar(menu_bar);
  }

    // withNodeMonitors interface
    public KlavaMonitor getMessageMonitor()
    { return nodePanel.getMessageMonitor() ; }
    public KlavaMonitor getProcMonitor()
    { return nodePanel.getProcMonitor() ; }
    public KlavaMonitor getEnvMonitor()
    { return nodePanel.getEnvMonitor() ;  }

    // withPanel interface
    public Panel getPanel() { return nodePanel ; }

  protected NodePanel newNodePanel() { return new NodePanel() ; }

  public void addRow( Component c ) { nodePanel.addRow( c ) ; }

  public void addRow( Component c, Object pos ) {
    add( c, pos ) ;
  }

  synchronized public void addMessage( String s ) {
    nodePanel.addMessage( s ) ;
  }

  void menuItem2_actionPerformed(ActionEvent e)
  {
    close_frame ();
  }

  void menuItem1_actionPerformed(ActionEvent e)
  {
    load_process ();
  }

  protected void load_process()
  {
    FileDialog file_dialog =
      new FileDialog (this, "Choose a process", FileDialog.LOAD);

    file_dialog.show ();

    String directory = file_dialog.getDirectory ();
    String file = file_dialog.getFile ();

    if ( directory == null || file == null )
      return;

    System.out.println ("Chosen " + directory + file);

    (new MessageBox (this, "Warning", "Feature not yet implemented!", true)).
      show ();
  }

  void menuItem3_actionPerformed(ActionEvent e)
  {
    InetAddress addr = node.getLocalAddress ();
    if ( addr == null )
      return;

    NodeNetInformationDialog dialog =
      new NodeNetInformationDialog(this, "Node Connection");

    dialog.setInformation (addr, node.getLocalPort (),
                           node.getNetHostName (), node.getNetPort (),
                           node.getHereLoc().toString ());

    dialog.show ();
  }
}
