// graphycal version of Node

package Klava ;

import java.io.* ;

public class NodeG extends Node {
  protected NodeFrame nodeFrame ;

  public NodeG( String Name, String Here, String NetHostName, int NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort  ) ;
      InitGraphNode() ;
  }

  public NodeG( String Name, int Here, String NetHostName, int NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort  ) ;
      InitGraphNode() ;
  }

  public NodeG( String Name, String Here, String NetHostName, Integer NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort ) ;
      InitGraphNode() ;
  }

  public NodeG( String Name, PhysicalLocality Here, String NetHostName, int NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort  ) ;
      InitGraphNode() ;
  }

  protected void InitGraphNode() {
    nodeFrame = newNodeFrame( "Node " + name + " on locality " + here, this,
        (TupleSpaceG)TS ) ;
    addMonitors() ;
  }

  protected NodeFrame newNodeFrame( String title, Node node, TupleSpaceG TS) {
    return new NodeFrame( title, node, TS ) ;
  } // factory method

  protected void addMonitors() {
      environment.addMonitor( nodeFrame.getEnvMonitor() ) ;
      processes.addMonitor( nodeFrame.getProcMonitor() ) ;
      infoMessages.addMonitor( nodeFrame.getMessageMonitor() ) ;
  } // template method

  protected void show() {
    if (nodeFrame == null)
      return; // during the initialization

    nodeFrame.pack() ;
    nodeFrame.show() ;
  }

  protected TupleSpace newTupleSpace() {
    return new TupleSpaceG(  ) ;
  }

  protected void releaseResources()
  {
    super.releaseResources ();
    if ( nodeFrame != null )
    {
      System.out.println ("Releasing system resources");
      nodeFrame.dispose ();
      nodeFrame = null ;
      System.out.println ("System resources released");
    }
  }

  public static void main( String args[] ) throws IOException, KlavaException {
    if ( args.length < 4 || args.length > 5 )
      throw new IOException( "Syntax : Node <name> <physLocHere> <hostname> <port> {DirConnect}" ) ;

    NodeG n = new NodeG( args[0], args[1], args[2], Integer.parseInt( args[3] ) ) ;
    if ( args.length == 5 )
      n.setDirectConnections() ;

    KlavaApplication app = new KlavaApplication ();
    app.addNode (n);
    app.startNodes ();

    app.waitForNodesAndTerminate();
  }
}
