package Klava;


public interface NodeInterface {

// KLAIM ACTIONS

    // out action
    public void out( Tuple t ) throws KlavaException ;
    public void out( Tuple t, Locality l ) throws KlavaException ;


    // in action
    public void in(Tuple t) throws  KlavaException ;
    public void in(Tuple t,Locality l) throws  KlavaException ;
    // time out versions
    public void in( Tuple t, long TimeOut ) throws KlavaException;
    public void in( Tuple t, Locality l, long TimeOut ) throws KlavaException;
    public boolean in_t(Tuple t, Locality l, long TimeOut) throws KlavaException;
    // non blocking versions
    public boolean in_nb(Tuple t,Locality l) throws  KlavaException ;


    // read action
    public void read( Tuple t ) throws KlavaException ;
    public void read( Tuple t, Locality l ) throws KlavaException ;
    // time out versions
    public void read( Tuple t, long TimeOut )  throws KlavaException ;
    public void read( Tuple t, Locality l, long TimeOut )
	throws KlavaException ;
    public boolean read_t(Tuple t, Locality l, long TimeOut) throws KlavaException;
    // non blocking versions
    public boolean read_nb( Tuple t, Locality l ) throws KlavaException ;


    // eval action
    public void eval( KlavaProcess P ) throws KlavaException ;
    public void eval( KlavaProcess P, Locality loc ) throws KlavaException ;
    public void eval( KlavaProcessVar P ) throws KlavaException ;
    public void eval( KlavaProcessVar P, Locality loc ) throws KlavaException ;


    // newloc action
    public PhysicalLocality newloc() throws KlavaException ;
    public PhysicalLocality newloc(int port) throws KlavaException ;
    PhysicalLocality newloc(NodeCoordinator P) throws KlavaException;
    PhysicalLocality newloc(NodeCoordinator P, int port,
                            String classname) throws KlavaException;

    public void removeloc( Locality l ) throws KlavaException ;

    // END KLAIM ACTIONS


    // ND choice
    public void or( KlavaProcess P1, KlavaProcess P2 ) ;


    // blocking process call
    public void procCall( Callable P ) throws KlavaException ;


    //  fork/kill  system call
    public void addProcess( KlavaProcess P ) ;
    public void removeProcess( KlavaProcess P ) ;


    // utility methods
    public void requestLocality( Locality l, Tuple t)
	throws KlavaException ;

    public PhysicalLocality ThisLocality();

    public PhysicalLocality getPhysicalLocality( Locality loc )
        throws KlavaLogicalLocalityException;

    public KlavaProcess closeProcess(KlavaProcess P);
    public KlavaProcessVar closeProcess(KlavaProcessVar P);

    public void Print( String s ) ;

}


