package Klava ;

import java.awt.* ;
import java.io.* ;
import org.mikado.imc.mobility.NodeClassLoader;

public class NodeKeyboard extends Node implements withPanel {

  protected boolean visible = true ;
  protected MonitorableKeyboardPanel keybPanel ;

  public NodeKeyboard( String Name, String Here, String NetHostName, int NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort  ) ;
  }

  public NodeKeyboard( String Name, String Here, String NetHostName, Integer NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort ) ;
  }

  public NodeKeyboard( String Name, PhysicalLocality Here, String NetHostName, int NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort  ) ;
  }

  protected TupleSpace newTupleSpace() {
    keybPanel = new MonitorableKeyboardPanel( name ) ;
    return new TupleSpaceKeyboard( keybPanel ) ;
  }

  // factory method
  protected Environment newEnvironment( String name )
  {
      try {
          return new Environment ();
          // we don't read any file
      } catch (KlavaMalformedPhyLocalityException mfl) {
          mfl.printStackTrace();
          return null;
      }
  }

  // factory method
  protected NodeClassLoader newNodeClassLoader()
  {
    //return new NodeClassLoader ();
    return null ; // due to Security
  }

  // withPanel interface
  public Panel getPanel() { return keybPanel ; }

  public void setVisible( boolean vis ) { visible = vis ; }

  protected void show() {
    if ( visible )
      TS.show()  ;
  }

  public static void main( String args[] ) throws IOException, KlavaException {
    if ( args.length < 4 || args.length > 5 )
      throw new IOException( "Syntax : Node <name> <physLocHere> <hostname> <port> {DirConnect}" ) ;

    NodeKeyboard n =
      new NodeKeyboard( args[0], args[1], args[2], Integer.parseInt( args[3] ) ) ;
    if ( args.length == 5 )
      n.setDirectConnections() ;
    KlavaFrame kf = new KlavaFrame( args[0], n ) ;
    n.start() ;
    kf.add( n.getPanel() ) ;
    kf.pack() ;
    kf.show() ;
  }
}
