
//Title:        Klava
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Lorenzo Bettini
//Company:      University of Florence
//Description:  Your description


package Klava;

import java.io.IOException ;

public class NodeKeyboardWFrame extends NodeKeyboard {

  public NodeKeyboardWFrame( String Name, String Here, String NetHostName, int NetPort )
    throws IOException, KlavaException {
      super( Name, Here, NetHostName, NetPort  ) ;
  }

  protected TupleSpace newTupleSpace() {
    keybPanel = new MonitorableKeyboardPanel( name ) ;
    return new TupleSpaceKeyboardWFrame( keybPanel, new KlavaFrame( name, this ) ) ;
  }

  protected void show() {
    TS.show() ;
  }

  public static void main(String[] args) throws IOException, KlavaException {
    if ( args.length < 4 || args.length > 5 )
      throw new IOException( "Syntax : Node <name> <physLocHere> <hostname> <port> {DirConnect}" ) ;

    NodeKeyboardWFrame n =
      new NodeKeyboardWFrame( args[0], args[1], args[2], Integer.parseInt( args[3] ) ) ;
    if ( args.length == 5 )
      n.setDirectConnections() ;
    n.start() ;
    n.invokedStandalone = true;
  }
  private boolean invokedStandalone = false;
}