package Klava ;

public class NodeMessage implements java.io.Serializable {
  // message constant
  public static final int IN = 0 ;
  public static final int OUT = 1 ;
  public static final int EVAL = 2 ;
  public static final int READ = 3 ;
  public static final int RESPONSE = 4 ;
  public static final int NEWLOC = 5 ;
  public static final int RESPONSEIN = 6 ;

  public static final int NOPHYSLOC = 7 ;
  public static final int REQUESTLOC = 8 ;
  public static final int COMMUNICATEPORT = 9 ;
  public static final int TUPLE_ABSENT = 10;

  public static final int RESPONSEOUT = 11;
  public static final int RESPONSEEVAL = 12;

  public static final int EVALUATE_LOCALITY = 13;
  public static final int RESPONSE_LOCALITY = 14;

  public static final int UNSUBSCRIBE = 15;
  public static final int UNREGISTERED = 16;

  public static final int PROPAGATE_LOCALITY = 17;
  public static final int PROPAGATE_REMOVE_LOCALITY = 18;

  public static final int MAX_OPCODE = 18;

  private static final String[] message_codes = {
    "IN", "OUT", "EVAL", "READ", "RESPONSE", "NEWLOC", "RESPONSEIN",
    "NOPHYSLOC", "REQUESTLOC", "COMMUNICATEPORT", "TUPLE_ABSENT",
    "RESPONSEOUT", "RESPONSEEVAL", "EVALUATE_LOCALITY", "RESPONSE_LOCALITY",
    "UNSUBSCRIBE", "UNREGISTERED", "PROPAGATE_LOCALITY",
    "PROPAGATE_REMOVE_LOCALITY"
  };

  public Locality Source ; // loc of the sender
  public Locality Dest ; // loc of the target
  public String ProcessName ; // sending process name
  public int OpCode ; // operation op code
  public Object Content ; // the content
  public long TimeOut ; // time out in millisecs
  public boolean blocking; // whether it is a blocking request
  public boolean ack_requested; // only for non-blocking operations (e.g. out)

  public NodeMessage( Locality source, Locality dest,
		      String processname, int opcode, Object content,
                      long timeout, boolean block, boolean ack ) {
    Source = source ;
    Dest = dest ;
    ProcessName = processname ;
    OpCode = opcode ;
    Content = content ;
    TimeOut = timeout ;
    blocking = block;
    ack_requested = ack;
  }

  public String toString() {
    return "< " + Source + ", " + Dest + ", " + ProcessName +
      ", " + OpCodeToString() + ", " + Content + ", " + TimeOut + ", " +
      blocking + " >" ;
  }

  public final String OpCodeToString() {
    if (OpCode <= MAX_OPCODE)
      return message_codes[OpCode];
    else
      return "" + OpCode;
  }
}



