
//Title:        Klava
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Lorenzo Bettini
//Company:      Dipartimento di Sistemi e Informatica, Univ. di Firenze
//Description:  a Java Framework for Mobile Code

package Klava;

import java.awt.*;
import java.awt.event.*;
import java.net.InetAddress;

public class NodeNetInformationDialog extends Dialog
{
  Panel dialog_panel = new Panel();
  BorderLayout borderLayout1 = new BorderLayout();
  Panel ok_panel = new Panel();
  Button ok_button = new Button();
  Panel info_panel = new Panel();
  GridLayout gridLayout1 = new GridLayout();
  Panel net_panel = new Panel();
  GridLayout gridLayout2 = new GridLayout();
  Label label1 = new Label();
  Label label2 = new Label();
  TextField net_address_text = new TextField();
  TextField net_port_text = new TextField();
  Label label3 = new Label();
  Label label4 = new Label();
  Label label5 = new Label();
  TextField node_address_text = new TextField();
  TextField node_port_text = new TextField();
  TextField node_ip_text = new TextField();
  Label label6 = new Label();
  TextField loc_text = new TextField();

  
  public NodeNetInformationDialog(Frame frame, String title, boolean modal)
  {
    super(frame, title, modal);
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try 
    {
      jbInit();
      add(dialog_panel);
      pack();
    }
    catch (Exception ex)
    {
      ex.printStackTrace();
    }
  }

  
  public NodeNetInformationDialog(Frame frame)
  {
    this(frame, "", false);
  }

  
  public NodeNetInformationDialog(Frame frame, boolean modal)
  {
    this(frame, "", modal);
  }

  
  public NodeNetInformationDialog(Frame frame, String title)
  {
    this(frame, title, false);
  }

  public void setInformation( InetAddress node_address, int node_port,
                              String net_address, int net_port,
                              String phy_loc)
  {
    net_address_text.setText (net_address);
    net_port_text.setText (Integer.toString(net_port));

    node_address_text.setText (node_address.getHostName ());
    node_ip_text.setText (node_address.getHostAddress ());
    node_port_text.setText (Integer.toString (node_port));
    loc_text.setText (phy_loc);
  }

  void jbInit() throws Exception
  {
    dialog_panel.setLayout(borderLayout1);
    ok_button.setLabel("OK");
    gridLayout2.setRows(6);
    gridLayout2.setHgap(5);
    gridLayout2.setColumns(2);
    gridLayout2.setVgap(5);
    label1.setAlignment(2);
    label1.setText("Net server address");
    label2.setAlignment(2);
    label2.setText("Net server port");
    label3.setAlignment(2);
    label3.setText("Node Address");
    label4.setAlignment(2);
    label4.setText("Node IP");
    label5.setAlignment(2);
    label5.setText("Node port");
    label6.setAlignment(2);
    label6.setText("Physical locality");
    net_panel.setLayout(gridLayout2);
    info_panel.setLayout(gridLayout1);
    ok_button.addActionListener(new java.awt.event.ActionListener()
    {
      public void actionPerformed(ActionEvent e)
      {
        ok_button_actionPerformed(e);
      }
    });
    dialog_panel.add(ok_panel, BorderLayout.SOUTH);
    ok_panel.add(ok_button, null);
    dialog_panel.add(info_panel, BorderLayout.CENTER);
    info_panel.add(net_panel, null);
    net_panel.add(label1, null);
    net_panel.add(net_address_text, null);
    net_panel.add(label2, null);
    net_panel.add(net_port_text, null);
    net_panel.add(label3, null);
    net_panel.add(node_address_text, null);
    net_panel.add(label4, null);
    net_panel.add(node_ip_text, null);
    net_panel.add(label5, null);
    net_panel.add(node_port_text, null);
    net_panel.add(label6, null);
    net_panel.add(loc_text, null);
  }

  protected void processWindowEvent(WindowEvent e)
  {
    if (e.getID() == WindowEvent.WINDOW_CLOSING)
    {
      cancel();
    }
    super.processWindowEvent(e);
  }

  void cancel()
  {
    dispose();
  }

  void ok_button_actionPerformed(ActionEvent e)
  {
    cancel ();
  }
}


