package Klava;

public class NodeProxy implements NodeInterface {
    protected NodeInterface node;

    public NodeProxy(NodeInterface node) {
      this.node = node;
    }

      // out action
    public void out( Tuple t ) throws KlavaException {
      node.out(t);
    }
    public void out( Tuple t, Locality l ) throws KlavaException {
      node.out(t, l);
    }


    // in action
    public void in(Tuple t) throws  KlavaException {
      node.in(t);
    }
    public void in(Tuple t,Locality l) throws  KlavaException {
      node.in(t, l);
    }
    // time out versions
    public void in( Tuple t, long TimeOut ) throws KlavaException {
      node.in(t, TimeOut);
    }
    public void in( Tuple t, Locality l, long TimeOut ) throws KlavaException {
      node.in(t, l, TimeOut);
    }
    public boolean in_t(Tuple t, Locality l, long TimeOut) throws KlavaException {
      return node.in_t(t, l, TimeOut);
    }
    // non blocking versions
    public boolean in_nb(Tuple t,Locality l) throws  KlavaException {
      return node.in_nb(t, l);
    }


    // read action
    public void read( Tuple t ) throws KlavaException {
      node.read(t);
    }
    public void read( Tuple t, Locality l ) throws KlavaException {
      node.read(t, l);
    }
    // time out versions
    public void read( Tuple t, long TimeOut )  throws KlavaException {
      node.read(t, TimeOut);
    }
    public void read( Tuple t, Locality l, long TimeOut )
	throws KlavaException {
      node.read(t, l, TimeOut);
    }
    public boolean read_t(Tuple t, Locality l, long TimeOut)
      throws KlavaException {
      return node.read_t(t, l, TimeOut);
    }
    // non blocking versions
    public boolean read_nb( Tuple t, Locality l ) throws KlavaException {
      return node.read_nb(t, l);
    }


    // eval action
    public void eval( KlavaProcess P ) throws KlavaException {
      node.eval(P);
    }
    public void eval( KlavaProcess P, Locality loc ) throws KlavaException {
      node.eval(P, loc);
    }
    public void eval( KlavaProcessVar P ) throws KlavaException {
      node.eval(P);
    }
    public void eval( KlavaProcessVar P, Locality loc ) throws KlavaException {
      node.eval(P, loc);
    }


    // newloc action
    public PhysicalLocality newloc() throws KlavaException {
      return node.newloc();
    }

    public PhysicalLocality newloc(int port) throws KlavaException {
          return node.newloc(port);
    }

    public PhysicalLocality newloc(NodeCoordinator P) throws KlavaException {
      return node.newloc(P);
    }

    public PhysicalLocality newloc(NodeCoordinator P, int port,
                                   String classname) throws KlavaException {
      return node.newloc(P, port, classname);
    }

    public void removeloc( Locality l ) throws KlavaException {
      node.removeloc(l);
    }

    // END KLAIM ACTIONS


    // ND choice
    public void or( KlavaProcess P1, KlavaProcess P2 ) {
      node.or(P1, P2);
    }


    // blocking process call
    public void procCall( Callable P ) throws KlavaException {
      node.procCall(P);
    }


    //  fork/kill  system call
    public void addProcess( KlavaProcess P ) {
      node.addProcess(P);
    }
    public void removeProcess( KlavaProcess P ) {
      node.removeProcess(P);
    }


    // utility methods
    public void requestLocality( Locality l, Tuple t)
	throws KlavaException {
      node.requestLocality(l, t);
    }

    public PhysicalLocality ThisLocality() {
      return node.ThisLocality();
    }

    public PhysicalLocality getPhysicalLocality( Locality loc )
        throws KlavaLogicalLocalityException {
      return node.getPhysicalLocality(loc);
    }

    public KlavaProcess closeProcess(KlavaProcess P) {
      return node.closeProcess(P);
    }

    public KlavaProcessVar closeProcess(KlavaProcessVar P) {
      return node.closeProcess(P);
    }

    public void Print( String s ) { node.Print(s); }

}