// A Node with a visible TupleSpace

package Klava ;

import java.awt.* ;
import java.io.* ;

public class NodeTupleSpaceG extends Node implements withPanel
{
    protected Panel tsPanel;

    public NodeTupleSpaceG( String Name, String Here, String NetHostName, int NetPort )
        throws IOException, KlavaException {
        super( Name, Here, NetHostName, NetPort  ) ;
    }

    public NodeTupleSpaceG( String Name, String Here, String NetHostName, Integer NetPort )
        throws IOException, KlavaException {
        super( Name, Here, NetHostName, NetPort ) ;
    }

    public NodeTupleSpaceG( String Name, PhysicalLocality Here, String NetHostName, int NetPort )
        throws IOException, KlavaException {
        super( Name, Here, NetHostName, NetPort  ) ;
    }

    protected TupleSpace newTupleSpace() {
        TupleSpaceG ts = new TupleSpaceG ();
        tsPanel = ts.getPanel ();
        return ts;
    }

    // withPanel interface
    public Panel getPanel() { return tsPanel ; }

    public static void main( String args[] ) throws IOException, KlavaException {
        if ( args.length < 4 || args.length > 5 )
            throw new IOException
                ( "Syntax : Node <name> <physLocHere> <hostname> <port> {DirConnect}" ) ;

        NodeTupleSpaceG n = new NodeTupleSpaceG
            ( args[0], args[1], args[2], Integer.parseInt( args[3] ) ) ;

        KlavaFrame frame = new KlavaFrame( "Node TS", n ) ;

        if ( args.length == 5 )
            n.setDirectConnections() ;

        frame.pack ();
        frame.show ();

        n.start() ;
        try
            {
                n.join ();
                System.exit (0);
            }
        catch ( InterruptedException e ) { e.printStackTrace (); }
    }
}
