// NodeWScreen (a Node with a screen)

package Klava ;

import java.io.* ;

public class NodeWScreen extends Node {
  protected KlavaFrame nodeFrame ;
  protected NodeScreen screenNode ;
  protected LogicalLocality screen = new LogicalLocality( "screen" ) ;

  public NodeWScreen( String Name, String Here, String NetHostName, int NetPort )
        throws IOException, KlavaException
  {
    super( Name, Here, NetHostName, NetPort ) ;
    nodeFrame = new KlavaFrame( Name ) ;
    nodeFrame.setNode( this ) ;
    screenNode = new NodeScreen( Name + " screen",
                Here + "Screen", NetHostName, NetPort ) ;
    nodeFrame.add( screenNode.getPanel() ) ;

    addSubNode (screenNode);

    screenNode.start() ;
  }

  protected void show() {
    nodeFrame.pack() ;
    nodeFrame.show() ;
  }

  public static void main( String args[] ) throws IOException, KlavaException {
    if ( args.length < 4 || args.length > 5 )
      throw new IOException( "Syntax : Node <name> <physLocHere> <hostname> <port> {DirConnect}" ) ;

    NodeWScreen n = new NodeWScreen( args[0], args[1], args[2], Integer.parseInt( args[3] ) ) ;
    if ( args.length == 5 )
      n.setDirectConnections() ;
    n.addToEnv( "screen", "ProcessorNodeScreen" ) ;
    n.start() ;
  }
}
