/**
 * Base class for a generic NodeCoordinator that waits for subscriptions
 */

package Klava;

public class RegisterNodeCoordinator extends NodeCoordinator {
  protected boolean one_time;

  public RegisterNodeCoordinator() {
    this (false);
  }

  public RegisterNodeCoordinator(boolean one_time) {
    this.one_time = one_time;
  }

  public void execute() throws Klava.KlavaException {
    PhysicalLocality phy_loc;
    LogicalLocality log_loc;
    while (true) {
      phy_loc = new PhysicalLocality();
      log_loc = new LogicalLocality();
      if (register(phy_loc, log_loc)) {
        registration_succeeded(phy_loc, log_loc);
      } else {
        registration_failed(phy_loc, log_loc);
      }
      if (one_time)
        break;
    }
  }

  protected void registration_succeeded(PhysicalLocality phy_loc,
                                        LogicalLocality log_loc) {
    Print("Registered ( " + log_loc + " ~ " + phy_loc + " )");
  }

  protected void registration_failed(PhysicalLocality phy_loc,
                                     LogicalLocality log_loc) {
    Print("Registration failed for ( " + log_loc + " ~ " + phy_loc + " )");
  }
}