package Klava;

/**
 * a nodecoordinator that does nothing but subscribing the node
 * to a specific server
 */

public class SubscriberNodeCoordinator extends NodeCoordinator {
  protected LogicalLocality my_loc;
  protected PhysicalLocality server;

  public SubscriberNodeCoordinator(PhysicalLocality server,
                                   LogicalLocality my_loc) {
    this.server = server;
    this.my_loc = my_loc;
  }

  public SubscriberNodeCoordinator(PhysicalLocality server,
                                   String my_loc) {
    this(server, new LogicalLocality(my_loc));
  }

  public void execute() throws Klava.KlavaException {
    Print("Subscribing to " + server + " as " + my_loc);
    if (subscribe( server, my_loc ))
      subscribe_success(server, my_loc);
    else
      subscribe_failed(server, my_loc);
  }

  public void subscribe_success(PhysicalLocality server, LogicalLocality loc) {
    Print("Subscribing succedeed to " + server + " as " + loc);
  }

  public void subscribe_failed(PhysicalLocality server, LogicalLocality loc) {
    Print("Subscribing failed to " + server + " as " + loc);
  }
}