package Klava ;

import java.awt.* ;
import java.util.Enumeration ;

public class TupleSpaceList extends TupleSpace
    implements java.io.Serializable, withPanel {
  protected KlavaMonitorListPanelWSelection listPanel ;
  protected static final KString cmd_string = new KString("command");

  public TupleSpaceList() {
    this( "", new KlavaMonitorListPanelWSelection() ) ;
  }

  public TupleSpaceList( String title ) {
    this( title, new KlavaMonitorListPanelWSelection() ) ;
  }

  public TupleSpaceList( String title, KlavaMonitorListPanelWSelection p ) {
    listPanel = p ;
    addMonitor( p ) ;
    setMultipleMode( true ) ;
  }

  public void setMultipleMode( boolean b ) { listPanel.setMultipleMode( b ) ; }

  protected KlavaMonitorListPanelWSelection newKlavaMonitorListPanelWSelection() {
    return new KlavaMonitorListPanelWSelection() ; // factory method
  }

  // withPanel interface
  public Panel getPanel() { return listPanel ; }

    /*
  public void setNode( Node n ) {
    super.setNode( n ) ;
    if ( screenFrame != null )
      screenFrame.setNode( n ) ;
  }
    */

  public void out( Tuple t ) {
    boolean done = false;

    if ( t.length() > 1 ) { // request ?
      Object string = t.getItem(0);
      if (isString (string) && isCommand ((KString)string)) {
        Object command = t.getItem(1) ;
        if (isString (command)) {
          KString request = (KString)command ;
          if ( t.length() > 2 ) { // there's a parameter {
            Object param = t.getItem(2) ;
            if (param instanceof KString ) {
              KString requesterID = (KString)param ;
              done = true; // maybe we're done :-)
              if ( request.equals( "getSelectedItem" ) ) {
                String s = cleanString((String)listPanel.getSelectedItem());
                Tuple newTuple = new Tuple( cmd_string, request, requesterID ) ;
                if ( s == null )
                  newTuple.add( new KString("") ) ;
                else
                  newTuple.add( new KString(s) ) ;
                _out( newTuple ) ;
              } else if ( request.equals( "getSelectedItems" ) ) {
                Enumeration en = listPanel.getSelectedItems() ;
                TupleSpace ts = new TupleSpace() ;
                while ( en.hasMoreElements() )
                  ts.add
                  ( new Tuple
                  ( new KString( cleanString((String)(en.nextElement() )) ) ) ) ;
                _out( new Tuple( cmd_string, request, requesterID, ts ) ) ;
              } else
                done = false; // OK false alarm :-)
            }
          } else { // no parameter
            done = true;
            if (request.equals ("removeAll")) {
              removeAllTuples();
            } else
              done = false;
          }
        }
      }
    }

    if (! done)
      _out (t);
  }

  protected String cleanString(String s) {
    // if it's a tuple representation remove ( and )
    if (s == null)
      return s;

    s = s.trim();
    if (s != null && s.startsWith("(") && s.endsWith(")")) {
      String n = s.substring(1, s.length()-1).trim();
      return n;
    } else
      return s;
  }

  protected boolean isString(Object o) {
    return (o instanceof KString);
  }

  protected boolean isCommand(KString s) {
    return s.equalsIgnoreCase("COMMAND");
  }

  public boolean ReadIn( Tuple t, boolean removeTuple, boolean blocking ) {
      boolean result = super.ReadIn( t, removeTuple, blocking ) ;
      if ( result && removeTuple && _oneStringTuple( t ) )
          notifyRemoveElement( t.getItem(0).toString() ) ;
      return result ;
  }

  public boolean ReadIn( Tuple t, boolean removeTuple, long TimeOut )
      throws KlavaTimeOutException{
      boolean result = super.ReadIn( t, removeTuple, TimeOut ) ;
      if ( result && removeTuple && _oneStringTuple( t ) )
          notifyRemoveElement( t.getItem(0).toString() ) ;
      return result ;
  }

  protected boolean _oneStringTuple( Tuple t ) {
      if ( t.length() == 0 || t.length() > 1 )
          return false ;
      else {
          Object o = t.getItem( 0 ) ;
          return ( o instanceof String || o instanceof KString ) ;
      }
  }
}
