package Klava ;

import java.awt.* ;

public class TupleSpaceScreen extends TupleSpace
    implements java.io.Serializable, withPanel {
  protected KlavaFrame screenFrame ;
  protected KlavaMonitorPanel screenPanel ;

  public TupleSpaceScreen() {
    this( "",
      new KlavaMonitorPanel ("screen", new KlavaMonitorTextAreaPanel ())) ;
  }

  public TupleSpaceScreen( String title ) {
    this( title,
      new KlavaMonitorPanel (title, new KlavaMonitorTextAreaPanel ())) ;
  }

  public TupleSpaceScreen( String title, KlavaMonitorPanel p ) {
    screenPanel = p ;
    addMonitor( p ) ;
  }

  // withPanel interface
  public Panel getPanel() { return screenPanel ; }

  public void setNode( Node n ) {
    super.setNode( n ) ;
    if ( screenFrame != null )
      screenFrame.setNode( n ) ;
  }

  public void out( Tuple t ) {
    if ( t != null && t.length() > 0 ) {
      Object string = t.getItem(0) ;
      if ( t.length() == 1 &&
	      ( string instanceof String || string instanceof KString ) )
	        notifyAddElement( string ) ;
      else
	        notifyAddElement( t + "\n" ) ;
    }
  }

  public boolean ReadIn( Tuple t, boolean removeTuple, boolean blocking ) {
    return true ; // always return true
  }

  public boolean ReadIn( Tuple t, boolean removeTuple, long TimeOut )
    throws KlavaTimeOutException {
    return true ; // always return true
  }
}
