package Klava;

/**
 * a nodecoordinator that does nothing but unsubscribing the node
 * to a specific server
 */


public class UnsubscriberNodeCoordinator extends NodeCoordinator {
  protected LogicalLocality my_loc;
  protected PhysicalLocality server;

  public UnsubscriberNodeCoordinator(PhysicalLocality server,
                                     LogicalLocality my_loc) {
    this.server = server;
    this.my_loc = my_loc;
  }

  public UnsubscriberNodeCoordinator(PhysicalLocality server,
                                     String my_loc) {
    this(server, new LogicalLocality(my_loc));
  }

  public void execute() throws Klava.KlavaException {
    Print("Unsubscribing to " + server + " as " + my_loc);
    try {
      unsubscribe( server, my_loc );
      unsubscribe_success();
    } catch (KlavaException e) {
      unsubscribe_failed();
    }
  }

  public void unsubscribe_success() {
    Print("Unsubscribing succedeed");
  }

  public void unsubscribe_failed() {
    Print("Unsubscribing failed");
  }
}