package Klava;

/**
 * wait for specific processes to terminate
 */

import java.util.Enumeration;

public class WaitForProcesses extends Thread {
  protected Node parent_node;
  protected Enumeration processes_to_wait;

  public WaitForProcesses(Node parent_node, Enumeration processes_to_wait) {
    super("WaitForProcesses:" + parent_node.ThisLocality());
    this.parent_node = parent_node;
    this.processes_to_wait = processes_to_wait;
    System.err.println("WaitForProcesses created...");
  }

  public void run() {
    parent_node.Print("WaitForProcesses started...");
    while (processes_to_wait.hasMoreElements())
      try {
        ((KlavaProcess)(processes_to_wait.nextElement())).join();
      } catch (InterruptedException ie) {
        ie.printStackTrace();
        break;
      }

    parent_node.Print("All processes to wait for terminated.");
    parent_node.Print("Stopping node.");
    parent_node.Close();
  }
}