package Klava.crypto;

import java.awt.*;
import java.awt.event.*;

import java.util.Enumeration;


/**
 * The frame with the dialog for requesting keystore and key and passwords
 *
 * @author $author$
 * @version $Revision: 1.1.2.1 $
 */
public class KStoreRequestFrame extends Frame {
    /** DOCUMENT ME! */
    private KStoreDialogAccess kstore_access;

    /** DOCUMENT ME! */
    Panel key_panel = new Panel();

    /** DOCUMENT ME! */
    BorderLayout borderLayout1 = new BorderLayout();

    /** DOCUMENT ME! */
    Panel button_panel = new Panel();

    /** DOCUMENT ME! */
    Button ok_button = new Button();

    /** DOCUMENT ME! */
    Button abort_button = new Button();

    /** DOCUMENT ME! */
    Panel input_panel = new Panel();

    /** DOCUMENT ME! */
    GridLayout gridLayout1 = new GridLayout();

    /** DOCUMENT ME! */
    Label keypass_label = new Label();

    /** DOCUMENT ME! */
    Label key_label = new Label();

    /** DOCUMENT ME! */
    TextField key_text = new TextField();

    /** DOCUMENT ME! */
    TextField keypass_text = new TextField();

    /** DOCUMENT ME! */
    Label keylist_label = new Label();

    /** DOCUMENT ME! */
    List key_list = new List();

    /** DOCUMENT ME! */
    BorderLayout borderLayout2 = new BorderLayout();

    /** DOCUMENT ME! */
    Panel keystore_panel = new Panel();

    /** DOCUMENT ME! */
    BorderLayout borderLayout3 = new BorderLayout();

    /** DOCUMENT ME! */
    Panel keystore_button_panel = new Panel();

    /** DOCUMENT ME! */
    Button openkeystore_button = new Button();

    /** DOCUMENT ME! */
    Panel keystoreinput_panel = new Panel();

    /** DOCUMENT ME! */
    GridLayout gridLayout2 = new GridLayout();

    /** DOCUMENT ME! */
    Label keystore_label = new Label();

    /** DOCUMENT ME! */
    TextField keystore_text = new TextField();

    /** DOCUMENT ME! */
    TextField keystorepass_text = new TextField();

    /** DOCUMENT ME! */
    Label keystorepass_label = new Label();

    /** DOCUMENT ME! */
    Button choose_button = new Button();

    /** DOCUMENT ME! */
    Label explain_label = new Label();

    /** DOCUMENT ME! */
    private BorderLayout borderLayout4 = new BorderLayout();

    /** DOCUMENT ME! */
    private Panel wrong_panel = new Panel();

    /** DOCUMENT ME! */
    private Label label_wrong_password = new Label();

    /** DOCUMENT ME! */
    private Panel open_button_panel = new Panel();

    /**
     * Create a new KStoreRequestFrame object.
     *
     * @param kstore_access the KStoreDialogAccess for accessing the keystore
     */
    public KStoreRequestFrame(KStoreDialogAccess kstore_access) {
        this.kstore_access = kstore_access;

        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * Return the key alias chosen by the user
     *
     * @return The key alias chosen by the user
     */
    public String getKeyAlias() {
        return key_text.getText();
    }

    /**
     * Return the key passphrase inserted by the user
     *
     * @return the key passphrase inserted by the user
     */
    public String getKeyPassword() {
        return keypass_text.getText();
    }

    /**
     * Initialize the frame
     *
     * @throws Exception
     */
    private void jbInit() throws Exception {
        this.addWindowListener(new java.awt.event.WindowAdapter() {
                public void windowClosing(WindowEvent e) {
                    this_windowClosing(e);
                }
            });
        key_panel.setLayout(borderLayout2);
        ok_button.setLabel("OK");
        ok_button.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    ok_button_actionPerformed(e);
                }
            });
        abort_button.setLabel("Abort");
        abort_button.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    abort_button_actionPerformed(e);
                }
            });
        gridLayout1.setRows(4);
        gridLayout1.setColumns(2);
        keypass_label.setText("Key Password");
        key_label.setText("Key");
        keylist_label.setText("Key List");
        openkeystore_button.setLabel("Open Keystore");
        openkeystore_button.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    openkeystore_button_actionPerformed(e);
                }
            });
        gridLayout2.setRows(2);
        gridLayout2.setColumns(2);
        keystore_label.setText("Keystore");
        keystorepass_text.setEchoChar('*');
        keystorepass_label.setText("Keystore Password");
        choose_button.setLabel("Choose...");
        choose_button.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    choose_button_actionPerformed(e);
                }
            });
        keystoreinput_panel.setLayout(gridLayout2);
        keystore_panel.setLayout(borderLayout3);
        key_list.addActionListener(new java.awt.event.ActionListener() {
                public void actionPerformed(ActionEvent e) {
                    key_list_actionPerformed(e);
                }
            });
        input_panel.setLayout(gridLayout1);
        keystore_button_panel.setLayout(borderLayout4);
        label_wrong_password.setText("Wrong password, retry");
        label_wrong_password.setVisible(false);
        this.add(key_panel, BorderLayout.EAST);
        key_panel.add(keylist_label, BorderLayout.NORTH);
        key_panel.add(key_list, BorderLayout.CENTER);
        this.add(button_panel, BorderLayout.SOUTH);
        button_panel.add(ok_button, null);
        button_panel.add(abort_button, null);
        this.add(input_panel, BorderLayout.CENTER);
        input_panel.add(key_label, null);
        input_panel.add(key_text, null);
        input_panel.add(keypass_label, null);
        input_panel.add(keypass_text, null);
        this.add(keystore_panel, BorderLayout.NORTH);
        keystore_panel.add(keystore_button_panel, BorderLayout.EAST);
        keystore_button_panel.add(wrong_panel, BorderLayout.SOUTH);
        wrong_panel.add(label_wrong_password, null);
        keystore_button_panel.add(open_button_panel, BorderLayout.NORTH);
        open_button_panel.add(openkeystore_button, null);
        open_button_panel.add(choose_button, null);
        keystore_panel.add(keystoreinput_panel,  BorderLayout.CENTER);
        keystoreinput_panel.add(keystore_label, null);
        keystoreinput_panel.add(keystore_text, null);
        keystoreinput_panel.add(keystorepass_label, null);
        keystoreinput_panel.add(keystorepass_text, null);

        keypass_text.setEchoChar('*');

        keystore_panel.add(explain_label, BorderLayout.NORTH);
    }

    /**
     * DOCUMENT ME!
     *
     * @param e DOCUMENT ME!
     */
    void this_windowClosing(WindowEvent e) {
        notify_access(false);
    }

    /**
     * DOCUMENT ME!
     *
     * @param want_to_confirm DOCUMENT ME!
     */
    void notify_access(boolean want_to_confirm) {
        if (!want_to_confirm) {
            key_text.setText("");
            keypass_text.setText("");

            // so that the kstore_access realizes that no key
            // was specified
        }

        synchronized (kstore_access) {
            kstore_access.notify();
            dispose();
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param e DOCUMENT ME!
     */
    void ok_button_actionPerformed(ActionEvent e) {
        notify_access(true);
    }

    /**
     * DOCUMENT ME!
     *
     * @param e DOCUMENT ME!
     */
    void abort_button_actionPerformed(ActionEvent e) {
        notify_access(false);
    }

    /**
     * DOCUMENT ME!
     *
     * @param e DOCUMENT ME!
     */
    void key_list_actionPerformed(ActionEvent e) {
        key_text.setText(key_list.getSelectedItem());
    }

    /**
     * DOCUMENT ME!
     *
     * @param e DOCUMENT ME!
     */
    void openkeystore_button_actionPerformed(ActionEvent e) {
        try {
            kstore_access.openStore(keystore_text.getText(),
                keystorepass_text.getText());
            fill_key_list();
            label_wrong_password.setVisible(false);
            pack();
        } catch (Exception ex) {
            ex.printStackTrace();
            label_wrong_password.setVisible(true);
            pack();
        }
    }

    /**
     * DOCUMENT ME!
     */
    protected void fill_key_list() {
        try {
            Enumeration aliases = kstore_access.getKeyAliases();
            key_list.removeAll();

            while (aliases.hasMoreElements())
                key_list.add((String) (aliases.nextElement()));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * DOCUMENT ME!
     *
     * @param e DOCUMENT ME!
     */
    void choose_button_actionPerformed(ActionEvent e) {
        FileDialog file_dialog = new FileDialog(this, "Choose a keystore",
                FileDialog.LOAD);

        file_dialog.show();

        String directory = file_dialog.getDirectory();
        String file = file_dialog.getFile();

        if ((directory == null) || (file == null)) {
            return;
        }

        System.out.println("Chosen " + directory + file);
        keystore_text.setText(directory + file);
    }
}
