package Klava.crypto;

/**
 * Information about a key in the keystore: key name and its password
 *
 * @author $author$
 * @version $Revision: 1.1.2.1 $
 */
public class KeyInfo {
    /** The name (alias) of the key */
    private String keyName;

    /** The password for the key. */
    private String keyPassword;

    /**
     * Constructor.
     *
     * @param name the alias for the key
     * @param password the password for the key
     */
    KeyInfo(String name, String password) {
        keyName = name;
        keyPassword = password;
    }

    /**
     * Get the alias for the key.
     *
     * @return the alias for the key
     */
    public String getKeyName() {
        return keyName;
    }

    /**
     * Get the password for the key.
     *
     * @return the password for the key
     */
    public String getKeyPassword() {
        return keyPassword;
    }
}
