package Klava.debug;

public interface DebugEngine {

  // Execution control
  public void resume( String agentId ) throws DebugException ;
  public void kill( String agentId ) throws DebugException ;

  // State inspection
  public KlavaProcessInstance getCurrentProcess( String agentId ) throws DebugException ;
  public boolean getStatus( String agentId ) throws DebugException ;

  // Breakpoints
  public void addBreakpoint( Breakpoint b, String agentId ) throws DebugException ;
  public void removeBreakpoint( int bId, String agentId ) throws DebugException ;
  public Breakpoint[] getBreakpoints( String agentId ) throws DebugException ;

  // Close session
  public void exit() ;
  public void dispose() ;

  public void printMessage( String s ) ;

}