// A point in process source code
package Klava.debug ;

import java.io.Serializable ;

public class Location implements Serializable {

  public final String processName ;
  public final int line ;
  public final int column ;

  public Location( String processName, int line, int column ) {
    this.processName = processName ;
    this.line = line ;
    this.column = column ;
  }

  public boolean equals( Object obj ) {
    if ( obj != null && obj instanceof Location ) {
      Location other = ( Location )obj ;
      return ( processName.equals( other.processName ) &&
               line == other.line &&
               column == other.column ) ;
    }
    return false ;
  }

  public int hashCode() {
    return ( processName.hashCode() ^ line ^ column ) ;
  }

  public String toString() {
    StringBuffer sb = new StringBuffer() ;
    sb.append( '(' ) ;
    sb.append( processName ) ;
    sb.append( ':' ) ;
    sb.append( line ) ;
    sb.append( ',' ) ;
    sb.append( column ) ;
    sb.append( ')' ) ;
    return sb.toString() ;
  }

}