package Klava.debug;

import Klava.debug.event.BreakpointEvent;
import Klava.debug.event.LocationBreakpointEvent;

public class LocationBreakpoint extends Breakpoint {

  public LocationBreakpoint( int id ) {
    super( id ) ;
  }

  public LocationBreakpoint( LocationBreakpoint b ) {
    super( b ) ;
  }

  // A LocationBreakpoint is hit at any location,
  // effective hit actually depends on its conditions.
  protected boolean isHitBy( KlavaAgent a ) {
    return true ;
  }

  protected BreakpointEvent newBreakpointEvent( KlavaAgent a )
    throws DebugException
  {
    return new LocationBreakpointEvent
      ( this.getId(), a.getId(), a.getLocality(),
        a.getCurrentProcess().getLocation(), isSuspendEnabled() ) ;
  }

  public Breakpoint duplicate() {
    return new LocationBreakpoint( this ) ;
  }

}