package Klava.debug;

import Klava.debug.event.BreakpointEvent;
import Klava.debug.event.TSActionBreakpointEvent;

public class TSActionBreakpoint extends Breakpoint {

  protected TSAction tsActionTemplate = null ;

  public TSActionBreakpoint( int id ) {
    this( id, null ) ;
  }

  public TSActionBreakpoint( int id, TSAction tsActionTemplate ) {
    super( id ) ;
    this.tsActionTemplate = tsActionTemplate ;
  }

  public TSActionBreakpoint( TSActionBreakpoint b ) {
    super( b ) ;
    tsActionTemplate = b.tsActionTemplate ;
  }

  protected boolean isHitBy( KlavaAgent a ) throws DebugException {
    TSAction performedAction = a.getCurrentProcess().getCurrentAction() ;

    if ( performedAction == null )
      return false ;

    if ( tsActionTemplate == null )
      return true ;

    return performedAction.matches( tsActionTemplate ) ;
  }

  protected BreakpointEvent newBreakpointEvent( KlavaAgent a ) throws DebugException
  {
    KlavaProcessInstance currP = a.getCurrentProcess() ;
    return new TSActionBreakpointEvent
    ( this.getId(), a.getId(), a.getLocality(), currP.getLocation(),
      currP.getCurrentAction(), this.isSuspendEnabled()  ) ;
  }

  public Breakpoint duplicate() {
    return new TSActionBreakpoint( this ) ;
  }

}