package klavatest;

import Klava.* ;

class __fn1_1 extends KlavaProcess {
  // variables
  protected Tuple __tuple_1;
  protected Locality l2 = new LogicalLocality( "l2" ) ;
  // used processes

  public __fn1_1() {}

  public void execute() throws KlavaException {
    __tuple_1 = new Tuple() ;
    __tuple_1.add( new KString( "foo" ) ) ;
    in_t( __tuple_1, self, 2000 ) ;
    Print("Sending \"test\" to " + l2);
    out( new KString( "test" ), l2 ) ;
    Print("Retrieving from " + self);
    in( new KString( "result" ), self ) ;
    Print("Retrieved!");
  }
}
class __fn2_1 extends KlavaProcess {
  // variables
  protected Locality l1 = new LogicalLocality( "l1" ) ;
  // used processes

  public __fn2_1() {}

  public void execute() throws KlavaException {
    Print("Waiting for \"test\" at " + self);
    in( new KString( "test" ), self ) ;
    out( new KString( "result" ), l1 ) ;
    Print("Sending \"result\" to " + l1);
  }
}
// main class
public class TestFailDirect extends KlavaTestApplication {
  public TestFailDirect(String name, String suffix,
                        boolean log_to_file)
                        throws java.io.IOException, InterruptedException,
                               KlavaException {
    super(name, suffix, log_to_file);

    PhysicalLocality _fn1 = NetUtils.createLocalPhyLocAddress(9998);
    PhysicalLocality _fn2 = NetUtils.createLocalPhyLocAddress(9997);

    Node fn1 = new Node( "fn1", _fn1, "localhost", 9999 );
    fn1.setDirectConnections() ;
    fn1.addToEnv( "l2", _fn2.toString() ) ;
    fn1.start();
    fn1.waitToBeConnected();

    Node fn2 = new Node( "fn2", _fn2, "localhost", 9999 );
    fn2.addToEnv( "l1", _fn1.toString() ) ;
    fn2.start();
    fn2.waitToBeConnected();

    addProcessToNode( new __fn2_1(), fn2 ) ;
    addProcessToNode( new __fn1_1(), fn1 ) ;
  }

  static public void main( String args[] ) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new TestFailDirect
      ("TestFailDirect", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.waitForProcessesAndTerminate();

    System.exit(0);
  }
}
