/**
 * test direct communication with a node in the same computer
 */

package klavatest;

import java.io.* ;
import Klava.* ;

class __n1_1 extends KlavaProcess {
  // variables
  protected Tuple __tuple_1;
  protected Locality l2 = new LogicalLocality( "l2" ) ;
  // used processes

  public __n1_1() {}

  public void execute() throws KlavaException {
    __tuple_1 = new Tuple() ;
    __tuple_1.add( new KString( "foo" ) ) ;
    in_t( __tuple_1, self, 2000 ) ;
    Print("Sending \"test\" to " + l2);
    out( new KString( "test" ), l2 ) ;
    Print("Retrieving from " + self);
    in( new KString( "result" ), self ) ;
    Print("Retrieved!");
  }
}
class __n2_1 extends KlavaProcess {
  // variables
  protected Locality l1 = new LogicalLocality( "l1" ) ;
  // used processes

  public __n2_1() {}

  public void execute() throws KlavaException {
    Print("Waiting for \"test\" at " + self);
    in( new KString( "test" ), self ) ;
    out( new KString( "result" ), l1 ) ;
    Print("Sending \"result\" to " + l1);
  }
}
// main class
public class TestLocalDirect extends KlavaTestApplication {
  public TestLocalDirect(String name, String suffix,
                         boolean log_to_file)
                         throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    Node n1 = new Node( "n1", "127.0.0.1:9998", "localhost", 9999 );
    n1.setDirectConnections() ;
    n1.addToEnv( "l2", "127.0.0.1:9997" ) ;
    addProcessToNode( new __n1_1(), n1 ) ;

    Node n2 = new Node( "n2", "127.0.0.1:9997", "localhost", 9999 );
    n2.setDirectConnections() ;
    n2.addToEnv( "l1", "127.0.0.1:9998" ) ;
    addProcessToNode( new __n2_1(), n2 ) ;
  }

  static public void main( String args[] ) throws IOException, KlavaException {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new TestLocalDirect
      ("TestLocalDirect", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.start();
    app.waitForProcessesAndTerminate();

    System.exit(0);
  }
}
