package klavatest;

import Klava.*;
import java.io.*;

/**
 * test sending and loading of remote classes
 */

public class testClassLoading extends KlavaTestApplication {
  public testClassLoading(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode server = new AcceptNetNode("server", 9999);
    server.start();
    addNode(server);
    server.logLoadedClasses();
    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createLocalNodeAddress(9999));
    addProcessToNode(new ReceiveRemoteProcess(), server);
  }

  public static void main(String args[]) throws Exception, KlavaException {
    KlavaTestApplication app = new testClassLoading
      ("testClassLoading", (args.length > 1 ? args[1] : "cl_msgout"),
        args.length > 0 && ! args[0].equals("0"));

    System.out.println("starting the sender application...");
    String envp[] = new String[1];
    envp[0] = "CLASSPATH=" + System.getProperty("java.class.path") +
      System.getProperty( "path.separator" ).charAt(0) + "..";

    System.out.println("CLASSPATH = " + envp[0]);

    Process P = Runtime.getRuntime().exec
      ("java classloading.sendRemoteProcess " +
        (args.length > 0 ? "1" : "") +
        (args.length > 1 ? " " + args[1] : ""), envp);
    System.out.println("sender application started");

    OutputGrabber outGrab = new OutputGrabber(P.getInputStream());
    OutputGrabber errGrab = new OutputGrabber(P.getErrorStream());
    outGrab.start();
    errGrab.start();

    int exit_value = P.waitFor();

    app.waitForProcessesAndTerminate();
  }
}

// wait for a process coming from outside, eval it, and wait for it
// to terminate.
class ReceiveRemoteProcess extends KlavaProcess {
  public void execute() throws KlavaException {
    KlavaProcessVar P = new KlavaProcessVar();
    in(P, self);
    Print("Received a remote process");
    procCall(P);
    Print("Remote process started");
    Print("Remote process terminated");
  }
}

class OutputGrabber extends Thread {
  private InputStream in;

  public OutputGrabber(InputStream in) {
    this.in = in;
    setDaemon(true);
  }
  public void run() {
    String s;
    byte b[] = new byte[1024];
    int len;
    try {
      while((len = in.read(b))>=0)
        System.out.print(new String(b,0,len));
    }
    catch(Exception e)
    {}
  } // public void run()
} // class outputGrabber





