package klavatest;

import Klava.*;

/**
 * test sending and loading of remote classes. The remote process is then
 * in turn sent to another site.
 */

public class testClassLoadingEval extends KlavaTestApplication {
  public testClassLoadingEval(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode server = new AcceptNetNode("server", 9999);
    server.start();
    addNode(server);
    server.logLoadedClasses();
    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createLocalNodeAddress(9999));
    addProcessToNode(new StandbyProcess(), server);
  }

  public static void main(String args[]) throws Exception, KlavaException {
    KlavaTestApplication app = new testClassLoadingEval
      ("testClassLoadingEval", (args.length > 1 ? args[1] : "cl_msgout"),
        args.length > 0 && ! args[0].equals("0"));

    if (! (args.length > 0 && args[0].equals("0"))) {
      System.out.println("starting the sender application...");
      String envp[] = new String[1];

      envp[0] = "CLASSPATH=" + System.getProperty("java.class.path") +
                System.getProperty( "path.separator" ).charAt(0) + "..";

      System.out.println("CLASSPATH = " + envp[0]);

      Process P = Runtime.getRuntime().exec
        ("java classloading.sendRemoteProcessEval " +
          (args.length > 0 ? "1" : "") +
          (args.length > 1 ? " " + args[1] : ""), envp);
      System.out.println("sender application started");

      OutputGrabber outGrab = new OutputGrabber(P.getInputStream());
      OutputGrabber errGrab = new OutputGrabber(P.getErrorStream());
      outGrab.start();
      errGrab.start();

      int exit_value = P.waitFor();
    }

    app.waitForProcessesAndTerminate();
  }
}

class StandbyProcess extends KlavaProcess {
  public void execute() throws KlavaException {
    Print("Waiting for signal");
    in(new KString("done"), self);
    Print("Signal received, terminating.");
  }
}