package klavatest;

import Klava.*;

/**
 * test sending and loading of remote classes. The remote process uses
 * momi stuff
 */

public class testClassLoadingMoMi extends KlavaTestApplication {
  public testClassLoadingMoMi(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file, false);
    // we disable security manager, since the remote process uses
    // procCall that needs to write on the disk

    NetNode server = new AcceptNetNode("server", 9999);
    server.start();
    addNode(server);
    server.logLoadedClasses();
    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createLocalNodeAddress(9999));
    addProcessToNode(new StandbyProcess(), server);
  }

  public static void main(String args[]) throws Exception, KlavaException {
    KlavaTestApplication app = new testClassLoadingMoMi
      ("testClassLoadingMoMi", (args.length > 1 ? args[1] : "cl_msgout"),
        args.length > 0 && ! args[0].equals("0"));

    if (! (args.length > 0 && args[0].equals("0"))) {
      System.out.println("starting the sender application...");
      String envp[] = new String[1];
      envp[0] = "CLASSPATH=" + System.getProperty("java.class.path") +
                System.getProperty( "path.separator" ).charAt(0) + "..";

      String other_app_command =
          "java classloading.sendRemoteProcessMoMi " +
          (args.length > 0 ? "1" : "") +
          (args.length > 1 ? " " + args[1] : "");

      System.out.println("### executing: " + other_app_command);
      System.out.println("### with environment: " + envp[0]);

      Process P = Runtime.getRuntime().exec(other_app_command, envp);
      System.out.println("sender application started");

      OutputGrabber outGrab = new OutputGrabber(P.getInputStream());
      OutputGrabber errGrab = new OutputGrabber(P.getErrorStream());
      outGrab.start();
      errGrab.start();

      int exit_value = P.waitFor();
    }

    app.waitForProcessesAndTerminate();
  }
}
