package klavatest;

import Klava.*;
import java.io.*;

/**
 * test sending a remote process without code delivering
 */

public class testClassLoadingNo extends KlavaTestApplication {
  public testClassLoadingNo(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode server = new AcceptNetNode("server", 9999);
    server.start();
    addNode(server);
    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createLocalNodeAddress(9999));

    NetNode client = new NetNode("client2", 12000);
    client.setAckNonBlocking(false); // to avoid blocking
    client.start();
    addNode(client);
    addProcessToNode(new LoginNodeCoordinator(server_loc), client);
    try {
      client.waitToBeConnected();
      PToSend P = new PToSend(client.ThisLocality());
      addProcessToNode(
        new PSender(P, server_loc), client);
    } catch (InterruptedException ie) {
      ie.printStackTrace();
    }
  }

  public static void main(String args[]) throws Exception, KlavaException {
    KlavaTestApplication app = new testClassLoadingNo
      ("testClassLoadingNo", (args.length > 1 ? args[1] : "cl_msgout"),
        args.length > 0 && ! args[0].equals("0"));

    app.waitForProcessesAndTerminate();
  }
}

class SomeStuffToBring implements Serializable {
  Integer i = new Integer(10);
  String s = new String("foo");

  public String toString() {
    return "i: " + i + ",  s: " + s;
  }
}

class PToSend extends KlavaProcess {
  SomeStuffToBring stuff = new SomeStuffToBring();
  Locality home;

  PToSend(Locality home) {
    this.home = home;
    setMessages(true);
  }

  public void execute() throws KlavaException {
    Print("here's my stuff: " + stuff);
    out(new KString("done"), home);
    Print("Bye");
  }
}

class PSender extends KlavaProcess {
  KlavaProcess P;
  Locality remote;

  PSender(KlavaProcess P, Locality remote) {
    this.P = P;
    this.remote = remote;
  }

  public void execute() throws KlavaException {
    P.setDeliverCode(false);
    Print("Sending process to " + remote);
    eval(P, remote);
    in(new KString("done"), self);
    Print("remote process terminated");
  }
}