package klavatest;

import Klava.*;

/**
 * test automatic direct connections
 */

public class testDirectConnections extends KlavaTestApplication {
  public testDirectConnections(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode server = new RegisterNetNode("server", 9999);
    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createLocalNodeAddress(9999));
    addNode(server);

    NetNode client1 = new NetNode("client1", 11000);
    NetNode client2 = new NetNode("client2", 12000);

    client1.addProcess(new SubscriberNodeCoordinator(server_loc, "client1"));
    client2.addProcess(new SubscriberNodeCoordinator(server_loc, "client2"));

    try {
      client1.waitToBeConnected();
      client2.waitToBeConnected();

      client1.setDirectConnections();
      client2.setDirectConnections();

      addNode(client1);
      addNode(client2);

      addProcessToNode(
        new SendDirectProcess(
          new PhysicalLocality(NetUtils.createLocalNodeAddress(12000))),
        client1);

      KlavaProcess send_proc = new SendDirectProcess(
          new PhysicalLocality(NetUtils.createLocalNodeAddress(11000)));
      send_proc.setKlavaProcName(send_proc.KlavaProcName() + "2");

      addProcessToNode(
        send_proc,
        client2);
    } catch (InterruptedException ie) {
      ie.printStackTrace();
    }
  }

  public static void main(String args[]) throws Exception {
    KlavaTestApplication app = new testDirectConnections
      ("testDirectConnections", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.start();
    app.waitForProcessesAndTerminate();
  }
}

class SendDirectProcess extends KlavaProcess {
  Locality remote;

  public SendDirectProcess(Locality l) {
    remote = l;
  }

  public void execute() throws KlavaException {
    Print("Sending to " + remote);
    out(new KString("TEST"), remote);
    Print("Sent.");
  }
}