package klavatest;

/**
 * test disconnection notifications.
 * Two clients connect via a subscribe
 */

import Klava.*;

public class testDisconnected extends KlavaTestApplication {
  public testDisconnected(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException,
                                 InterruptedException, KlavaException {
    super(name, suffix, log_to_file);

    RegisterNetNode server = new RegisterNetNode("server", 9999);
    server.setNoLogonServer(true); // this way it does not forward messages
    // to any other server

    NetNode client1 = new NetNode("client1", 10001);
    NetNode client2 = new NetNode("client2", 10002);

    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createNodeAddress
        (NetUtils.getLocalIPAddress(), 9999));

    addNode(server);
    server.start();

    server.logDisconnected();

    client1.start();
    client2.start();

    client1.addProcess(new SubscriberNodeCoordinator(server_loc,
        new LogicalLocality("client1")));
    client1.waitToBeConnected();

    client2.addProcess(new SubscriberNodeCoordinator(server_loc,
        new LogicalLocality("client2")));
    client2.waitToBeConnected();

    System.out.println("*** now disconnecting clients");

    client1.Close();

    Thread.sleep(2000); // be sure that the DisconnectedNodeCoordinator
    // wrote everything

    client2.Close();

    Thread.sleep(2000); // be sure that the DisconnectedNodeCoordinator
    // wrote everything
  }

  public static void main(String args[]) throws Exception {
    KlavaTestApplication app = new testDisconnected
      ("testDisconnected", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    //app.start();
    app.waitForProcessesAndTerminate();
  }
}