package klavatest;

/**
 * test disconnection notifications.
 * Two clients connect via a login
 */

import Klava.*;

public class testDisconnectedLogin extends KlavaTestApplication {
  public testDisconnectedLogin(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException,
                                 InterruptedException, KlavaException {
    super(name, suffix, log_to_file);

    AcceptNetNode server = new AcceptNetNode("server", 9999);
    server.setNoLogonServer(true); // this way it does not forward messages
    // to any other server

    NetNode client1 = new NetNode("client1", 10001);
    NetNode client2 = new NetNode("client2", 10002);

    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createNodeAddress
        (NetUtils.getLocalIPAddress(), 9999));

    addNode(server);
    server.start();

    server.logDisconnected();

    client1.start();
    client2.start();

    client1.addProcess(new LoginNodeCoordinator(server_loc));
    client1.waitToBeConnected();

    client2.addProcess(new LoginNodeCoordinator(server_loc));
    client2.waitToBeConnected();

    System.out.println("*** now disconnecting clients");

    client1.Close();

    Thread.sleep(2000); // be sure that the DisconnectedNodeCoordinator
    // wrote everything

    client2.Close();

    Thread.sleep(2000); // be sure that the DisconnectedNodeCoordinator
    // wrote everything
  }

  public static void main(String args[]) throws Exception {
    KlavaTestApplication app = new testDisconnectedLogin
      ("testDisconnectedLogin", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    //app.start();
    app.waitForProcessesAndTerminate();
  }
}