package klavatest;

import Klava.*;

/**
 * test send and retrieve from/to local remote and newcreated locality
 */

class testInProcess1 extends KlavaProcess {

  public void execute() throws KlavaException {
      Tuple t1 = new Tuple(new KInteger(10), new KInteger(20));

      Print( "Inserting " + t1 + " at " + self);
      out( t1, self ) ;
      Print( "Inserting true at " + self);
      out( new KBoolean(true), self ) ;
      Print( "Inserting \"hi\" at " + self);
      out( new KString("hi"), self ) ;

      Print ( "testInProcess1 DONE ! :-)" ) ;
  }
}

class testInProcess2 extends NodeCoordinator {

    protected PhysicalLocality n1;

    public testInProcess2() {
        try {
            n1 = new PhysicalLocality ("127.0.0.1:9998");
        } catch (KlavaException ke) {
            ke.printStackTrace();
        }
    }

  public void execute() throws KlavaException {
      KString s = new KString() ;
      KInteger i1 = new KInteger ();
      KInteger i2 = new KInteger ();
      KBoolean b = new KBoolean ();

      Print ("Remote Test...");

      in( i1, i2, n1 ) ;
      in( b, n1 ) ;
      in( s, n1 ) ;

      Print( "i1 = " + i1 ) ;
      Print( "i2 = " + i2 ) ;
      Print( "b  = " + b ) ;
      Print( "s  = " + s ) ;

      Print ("Local Test...");

      out( i1, i2, self ) ;
      out( b, self ) ;
      out( s, self ) ;

      s = new KString() ;
      i1 = new KInteger ();
      i2 = new KInteger ();
      b = new KBoolean ();

      in( i1, i2, self ) ;
      in( b, self ) ;
      in( s, self ) ;

      Print( "i1 = " + i1 ) ;
      Print( "i2 = " + i2 ) ;
      Print( "b  = " + b ) ;
      Print( "s  = " + s ) ;

      Print ("Local Locality Test...");

      Locality l = newloc (9996);

      out( i1, i2, l ) ;
      out( b, l ) ;
      out( s, l ) ;

      s = new KString() ;
      i1 = new KInteger ();
      i2 = new KInteger ();
      b = new KBoolean ();

      in( i1, i2, l ) ;
      in( b, l ) ;
      in( s, l ) ;

      Print( "i1 = " + i1 ) ;
      Print( "i2 = " + i2 ) ;
      Print( "b  = " + b ) ;
      Print( "s  = " + s ) ;

      Print( "testInProcess2 DONE ! :-)" ) ;
  }
}

public class testIn extends KlavaTestApplication {
  public testIn(String name, String suffix,
                        boolean log_to_file)
                        throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    Node n1 = new Node( "n1", "127.0.0.1:9998", "localhost", 9999 ) ;
    Node n2 = new Node( "n2", "127.0.0.1:9997", "localhost", 9999 ) ;

    addProcessToNode( new testInProcess1 (), n1 ) ;
    addProcessToNode( new testInProcess2 (), n2 ) ;
  }

  public static void main( String args[] ) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new testIn
      ("testIn", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.start();
    app.waitForProcessesAndTerminate();

    System.exit(0);
  }
}
