package klavatest;

import Klava.*;

/**
 * Test the retrieval of both logical and physical localities
 */

public class testLocalityRetrieval extends KlavaTestApplication {
  public static void main(String args[]) throws Exception {
    KlavaTestApplication app = new testLocalityRetrieval
      ("testLocalityRetrieval", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.start();
    app.waitForProcessesAndTerminate();
  }

  public testLocalityRetrieval(String name, String suffix,
                                    boolean log_to_file)
                                    throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode n1 = new NetNode("n", 9999);
    addProcessToNode(new PutLocProcess(), n1);
    addProcessToNode(new GetLocProcess(), n1);
  }
}

class PutLocProcess extends KlavaProcess {
  public void execute() throws KlavaException {
    PhysicalLocality foo = new PhysicalLocality("127.0.0.1:9998");
    PhysicalLocality bar = new PhysicalLocality("127.0.0.1:9997");
    LogicalLocality loc_foo = new LogicalLocality("loc_foo");

    Print("Inserting physical localities " + foo + ", " + bar);
    out(foo, self);
    out(bar, self);

    Print("Inserting logical locality " + loc_foo);
    out(loc_foo, self);
  }
}

class GetLocProcess extends KlavaProcess {
  public void execute() throws KlavaException {
    LogicalLocality loc = new LogicalLocality();
    Print("Retrieving a logical locality...");
    read(loc, self);
    Print("Retrieved " + loc);

    PhysicalLocality ploc = new PhysicalLocality();
    Print("Retrieving a physical locality...");
    read(ploc, self);
    Print("Retrieved " + ploc);
  }
}