package klavatest;

/**
 * test the logging of processes in a node
 */

import Klava.*;

public class testLogProcesses extends KlavaTestApplication {
  public testLogProcesses(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException,
                                 InterruptedException, KlavaException {
    super(name, suffix, log_to_file);

    Node node = new Node("log_node", "127.0.0.1:9998", "localhost", 9999);
    addNode(node);
    node.start();

    KlavaProcess Ptolog = new ProcessToLog ();
    KlavaProcess Ptolog2 = new ProcessToLog2 ();
    KlavaProcess Pnottolog = new ProcessNotToLog ();
    KlavaProcess Pnottolog2 = new ProcessNotToLog2 ();

    node.logForName("ProcessToLog2");

    node.addProcess(Ptolog);
    node.addProcess(Ptolog2, false); // it will be logged anyway
    node.addProcess(Pnottolog, false);
    node.addProcess(Pnottolog2, false);

    Ptolog.join();
    Ptolog2.join();
    Pnottolog.join();
    Pnottolog2.join();
  }

  public static void main(String args[]) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new testLogProcesses
      ("testLogProcesses", (args.length > 1 ? args[1] : ""),
        args.length > 0);

    app.waitForProcessesAndTerminate();
  }
}

class ProcessToLog extends KlavaProcess {
  public void execute() throws KlavaException {
    Print("I'm process " + KlavaProcName() );
    Print("I should be logged...");
    Print("So you should see this :-)");
  }
}

class ProcessToLog2 extends KlavaProcess {
  public void execute() throws KlavaException {
    Print("I'm process " + KlavaProcName() );
    Print("I should be logged...");
    Print("So you should see this :-)");
  }
}

class ProcessNotToLog extends KlavaProcess {
  public void execute() throws KlavaException {
    Print("I'm process " + KlavaProcName() );
    Print("I shouldn't be logged...");
    Print("So you'll never see this in a file :-(");
  }
}

class ProcessNotToLog2 extends KlavaProcess {
  public void execute() throws KlavaException {
    Print("I'm process " + KlavaProcName() );
    Print("I shouldn't be logged...");
    Print("So you'll never see this in a file :-(");
  }
}