package klavatest;

import Klava.*;

/**
 * Test login and logout according to entered keystrokes
 * Meanwhile a process outs an incremented number to the remote server
 * and tries to retrieve it.  When the client is not connected this
 * process is blocked, until the client reconnects.
 */

public class testLoginAndLogout {
  private String server;

  public testLoginAndLogout(String server) {
    this.server = server;
  }

  public static void main(String args[]) throws Exception {
    String server = null;

    if (args.length > 0)
      server = args[0];

    (new testLoginAndLogout(server)).start();
  }

  void start() throws Exception {
    NetNode n = new NetNode("testLoginAndLogout", 11000);
    n.addProcess(new LoginAndLogoutProcess(server));
    n.addProcess(new CommunicateWithServerThatDisconnect(server));
    n.start();
  }
}

class LoginAndLogoutProcess extends NodeCoordinator {
  PhysicalLocality server;

  public LoginAndLogoutProcess(String server) throws KlavaException {
    if (server != null)
      this.server =
        new PhysicalLocality(NetUtils.createNodeAddress
          (server, 9999));
    else
      this.server =
      new PhysicalLocality(NetUtils.createNodeAddress
    (NetUtils.getLocalIPAddress(), 9999));
  }

  public void execute() throws KlavaException {
    boolean result;
    int command;

    Print("PRESS: L for login, O for logout to/from " + server);

    while (true) {
      try {
        command = System.in.read();
        if (command == 'L') {
          Print("Trying to login to " + server);
          result = login(server);
          Print("Login result: " + result);
        } else if (command == 'O') {
          Print("logout from " + server);
          logout(server);
          Print("Logged off.");
        } else if (command != '\n' && command != '\r')
          Print("Unrecognized command " + command);
      } catch(java.io.IOException ioe) {
      }
    }
  }
}