package klavatest;

/**
 * test automatic closure of nodes that lose connection to the server
 */

import Klava.*;

public class testLostNetConnection extends KlavaTestApplication {
  public testLostNetConnection(String name, String suffix,
                       boolean log_to_file)
                       throws java.io.IOException, InterruptedException,
                              KlavaException {
    super(name, suffix, log_to_file);

    NetNode server = new NetNode("server", 9999);
    server.start();
    addProcessToNode(new AcceptNodeCoordinator(false), server);

    NetNode client1 = new Node("client1", 9998, "localhost", 9999);
    NetNode client2 = new Node("client2", 9997, "localhost", 9999);
    NetNode client3 = new Node("client3", 9996, "localhost", 9999);

    addNode(client1);
    client1.start();
    client1.waitToBeConnected();
    addNode(client2);
    client2.start();
    client2.waitToBeConnected();
    client3.start();
    addNode(client3);
    client3.waitToBeConnected();

    server.Close();
  }

  public static void main(String[] args) throws Exception {
    boolean log_to_file = args.length > 0;

    KlavaTestApplication app = new testLostNetConnection
      ("testLostNetConnection", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.waitForNodesAndTerminate();

    System.exit(0);
  }
}

