/*
 * testMalformedPhyLoc.java
 *
 * test correct physical localities
 */

package klavatest;

import Klava.*;

class testMalformedPhyLocProc extends KlavaProcess {
  public void execute() throws KlavaException {
    Print("testing 127.0.0.1:9999... " + testLoc("127.0.0.1:9999"));
    Print("testing 127.0.0.1:9999:10000... " + testLoc("127.0.0.1:9999:10000"));
    Print("testing :9999... " + testLoc(":9999"));
    Print("testing 127.0.0.1... " + testLoc("127.0.0.1"));
    Print("testing foo:9999... " + testLoc("foo:9999"));
    Print("testing foo... " + testLoc("foo"));
  }

  boolean testLoc(String s) {
    try {
      PhysicalLocality l = new PhysicalLocality(s);
      return true;
    } catch (KlavaMalformedPhyLocalityException e) {
      //e.printStackTrace();
      return false;
    }
  }
}

public class testMalformedPhyLoc extends KlavaTestApplication {
  public testMalformedPhyLoc(String name, String suffix,
                    boolean log_to_file)
                    throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode n1 = new NetNode("127.0.0.1", 9999);

    n1.start();

    addProcessToNode( new testMalformedPhyLocProc (), n1 ) ;
  }

  static public void main( String args[] ) throws Exception {
    boolean log_to_file = args.length > 0;

    KlavaTestApplication app = new testMalformedPhyLoc
      ("testMalformedPhyLoc", (args.length > 1 ? args[1] : ""),
        args.length > 0);

    app.waitForProcessesAndTerminate();

    System.exit(0);
  }
}
