package klavatest;

import Klava.*;

/**
 * test manual direct connections
 */

public class testManualDirConn extends KlavaTestApplication {
  public testManualDirConn(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode server = new RegisterNetNode("server", 9999);
    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createLocalNodeAddress(9999));
    addProcessToNode(new AcceptConnNodeCoordinator(true), server);

    NetNode client1 = new NetNode("client1", 11000);
    PhysicalLocality client_loc =
      new PhysicalLocality(NetUtils.createLocalNodeAddress(11000));

    AcceptConnNodeCoordinator acc_coord = new AcceptConnNodeCoordinator(true);
    acc_coord.setKlavaProcName(acc_coord.KlavaProcName()+"-client");
    addProcessToNode(acc_coord, client1);

    DirConnNodeCoordinator server_conn =
      new DirConnNodeCoordinator(client_loc);
    server_conn.setKlavaProcName(server_conn.KlavaProcName() + "-server");

    addProcessToNode(new DirConnNodeCoordinator(server_loc), client1);
    addProcessToNode(server_conn, server);

    addProcessToNode(
        new SendDirectProcess(server_loc),
        client1);
  }

  public static void main(String args[]) throws Exception {
    KlavaTestApplication app = new testManualDirConn
      ("testManualDirConn", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.start();
    app.waitForProcessesAndTerminate();
  }
}