package klavatest;

import Klava.*;

/**
 * test a network with both subscribe and login
 */

public class testMixedNet extends KlavaTestApplication {
  public testMixedNet(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode server = new NetNode("server", 9999);
    addNode(server);
    server.addProcess(new RegisterNodeCoordinator(true));
    server.addProcess(new AcceptNodeCoordinator(true));

    PhysicalLocality server_loc = server.ThisLocality();

    NetNode log_client = new NetNode("log_client", 11000);
    NetNode sub_client = new NetNode("sub_client", 11001);

    addNode(log_client);
    addNode(sub_client);

    addProcessToNode(
      new SubscriberNodeCoordinator(server_loc,
        new LogicalLocality("sub_client")), sub_client);

    addProcessToNode(new LoginNodeCoordinator(server_loc), log_client);
  }

  public static void main(String args[]) throws Exception {
    KlavaTestApplication app = new testMixedNet
      ("testMixedNet", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.start();
    app.waitForProcessesAndTerminate();
  }
}
