package klavatest;

import Klava.*;

/**
 * Use non blocking versions of in and read
 */

class testNBProcess1 extends KlavaProcess {

  public void execute() throws KlavaException {
      Tuple t1 = new Tuple(new KInteger(10), new KInteger(20));

      Print( "Inserting " + t1 + " at " + self);
      out( t1, self ) ;
      Print( "Inserting true at " + self);
      out( new KBoolean(true), self ) ;
      Print( "Inserting \"hi\" at " + self);
      out( new KString("hi"), self ) ;

      Print ( "testNBProcess1 DONE ! :-)" ) ;
  }
}

class testNBProcess2 extends NodeCoordinator {

    protected PhysicalLocality n1;

  public void execute() throws KlavaException {
    n1 = new PhysicalLocality ("127.0.0.1:9998");

      KString s = new KString() ;
      KInteger i1 = new KInteger ();
      KInteger i2 = new KInteger ();
      KBoolean b = new KBoolean ();

      Print ("Remote Test...");

      Tuple t1 = new Tuple(s, b);
      Tuple t2 = new Tuple(i1, i2);
      Tuple t3 = new Tuple(i1, i2);

      if (! read_nb(t1, n1))
        Print ("Tuple " + t1 + " not found!");

      if (read_nb(t2, n1))
        Print ("Tuple " + t2 + " found!");

      if (in_nb( t3, n1 ))
        Print ("Tuple " + t2 + " found!");

      Print( "i1 = " + i1 ) ;
      Print( "i2 = " + i2 ) ;
      Print( "b  = " + b ) ;
      Print( "s  = " + s ) ;

      t3.resetOriginalTemplate();
      if (in_nb( t3, n1 )) // this must fail now!
        Print ("Tuple " + t3 + " found!");
      else
        Print("Not found another " + t3);

      Print ("Local Test...");

      out( i1, i2, self ) ;

      s = new KString() ;
      i1 = new KInteger ();
      i2 = new KInteger ();
      b = new KBoolean ();

      t1 = new Tuple(s, b);
      t2 = new Tuple(i1, i2);
      t3 = new Tuple(i1, i2);

      if (! read_nb(t1, self))
        Print ("Tuple " + t1 + " not found!");

      if (read_nb(t2, self))
        Print ("Tuple " + t2 + " found!");

      if (in_nb( t3, self ))
        Print ("Tuple " + t2 + " found!");

      Print( "i1 = " + i1 ) ;
      Print( "i2 = " + i2 ) ;
      Print( "b  = " + b ) ;
      Print( "s  = " + s ) ;

      t3.resetOriginalTemplate();
      if (in_nb( t3, self )) // this must fail now!
        Print ("Tuple " + t3 + " found!");
      else
        Print("Not found another " + t3);

      Print ("Local Locality Test...");

      Locality l = newloc (9996);

      out( i1, i2, l ) ;

      s = new KString() ;
      i1 = new KInteger ();
      i2 = new KInteger ();
      b = new KBoolean ();

      t1 = new Tuple(s, b);
      t2 = new Tuple(i1, i2);
      t3 = new Tuple(i1, i2);

      if (! read_nb(t1, l))
        Print ("Tuple " + t1 + " not found!");

      if (read_nb(t2, l))
        Print ("Tuple " + t2 + " found!");

      if (in_nb( t3, l ))
        Print ("Tuple " + t2 + " found!");

      Print( "i1 = " + i1 ) ;
      Print( "i2 = " + i2 ) ;
      Print( "b  = " + b ) ;
      Print( "s  = " + s ) ;

      t3.resetOriginalTemplate();
      if (in_nb( t3, l )) // this must fail now!
        Print ("Tuple " + t3 + " found!");
      else
        Print("Not found another " + t3);

      Print( "testNBProcess2 DONE ! :-)" ) ;
  }
}

public class testNB extends KlavaTestApplication {
  public testNB(String name, String suffix,
                        boolean log_to_file)
                        throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    Node n1 = new Node( "n1", "127.0.0.1:9998", "localhost", 9999 ) ;
    Node n2 = new Node( "n2", "127.0.0.1:9997", "localhost", 9999 ) ;

    addProcessToNode( new testNBProcess1 (), n1 ) ;
    addProcessToNode( new testNBProcess2 (), n2 ) ;
  }

  public static void main( String args[] ) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new testNB
      ("testNB", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.start();
    app.waitForProcessesAndTerminate();

    System.exit(0);
  }
}
