package klavatest;

import Klava.* ;


class P extends NodeCoordinator {
  protected Locality newl;
  protected Q dummyQ ;
  protected R dummyR ;

  public P(  ) {
  }

  public void execute() throws KlavaException {
    Print("Creating new locality...");
    newl = newloc(9996) ;
    Print("Created.");
    Print("Spawning a process there");
    eval( new Q(
      new KlavaProcessVar(
        new R( new PhysicalLocality("127.0.0.1:9998") ) ) ), newl ) ;
    PhysicalLocality remote = new PhysicalLocality();
    in( remote, self );
    Print("Received response from remote process at " + remote);
  }
}

class Q extends KlavaProcess {
  static FileMessagePrinterFactory factory;
  protected KlavaProcessVar X ;

  public Q( KlavaProcessVar X ) {
    this.X = X ;
  }

  public void execute() throws KlavaException {
    if (factory != null)
      this.setMessagePrinter(factory.createMessagePrinter(getClass().getName(),
        null));
    Print("Evaluating the variable at " + self);
    eval( X, self ) ;
  }
}

class R extends KlavaProcess {
  protected Locality home;
  protected Locality l;
  static FileMessagePrinterFactory factory;

  public R( Locality home ) {
    this.home = home;
  }

  public void execute() throws KlavaException {
    if (factory != null)
      this.setMessagePrinter(factory.createMessagePrinter(getClass().getName(),
        null));
    Print("Retrieving current execution site...");
    out( self, self ) ;
    l = new PhysicalLocality() ;
    in( l, self ) ;
    Print("Executing at " + l);
    Print("Communicating " + l + " to home site " + home);
    out( l, home );
  }
}

// main class
public class testNewLoc extends KlavaTestApplication {
  public testNewLoc(String name, String suffix,
                    boolean log_to_file)
                    throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    Node n = new Node( "n", "127.0.0.1:9998", "localhost", 9999 ) ;
    addProcessToNode( new P(), n ) ;
    Q.factory = this.getFileMessagePrinterFactory();
    R.factory = this.getFileMessagePrinterFactory();
  }

  static public void main( String args[] ) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new testNewLoc
      ("testNewLoc", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.start();
    app.waitForProcessesAndTerminate();

    System.exit(0);
  }
}

// end of file testNewLoc.java
