package klavatest;

import Klava.*;

/**
 * test the newloc with a NodeCoordinator
 */

public class testNewlocP extends KlavaTestApplication {
  public testNewlocP(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode server = new RegisterNetNode("server", 9999);
    addNode(server);

    addProcessToNode(new NewlocProcess(server.ThisLocality()), server);
  }

  public static void main(String args[]) throws Exception {
    KlavaTestApplication app = new testNewlocP
      ("testNewlocP", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.start();
    app.waitForProcessesAndTerminate();
  }
}

class NewlocProcess extends NodeCoordinator {
  protected PhysicalLocality server;

  public NewlocProcess(PhysicalLocality server) {
    this.server = server;
  }

  public void execute() throws KlavaException {
    PhysicalLocality loc =
        newloc(new NewnodeProcess(server));
    Print("created new locality ");
    KString s = new KString();
    Tuple t = new Tuple(s);
    in(t, self);
    Print("Retrieved \"" + s + "\" from the new locality");
  }
}

class NewnodeProcess extends NodeCoordinator {
  PhysicalLocality server;

  public NewnodeProcess(PhysicalLocality server) {
    this.server = server;
  }

  public void execute() throws KlavaException {
    if (subscribe(server, new LogicalLocality("newloc")))
      Print("Subscribed to " + server + " as newloc");
    else
      Print("Subscription failed");

    out(new KString("TEST"), server);
  }
}