package klavatest;

import Klava.*;

/**
 * test the newloc with a NodeCoordinator, a port number and a class name
 */

public class testNewlocPortClass extends KlavaTestApplication {
  public testNewlocPortClass(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode server = new RegisterNetNode("server", 9999);
    addNode(server);

    addProcessToNode
     (new NewlocPortClassProcess(server.ThisLocality(),
        11000, "klavatest.NewlocPortClass"), server);
  }

  public static void main(String args[]) throws Exception {
    KlavaTestApplication app = new testNewlocPortClass
      ("testNewlocPortClass", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.start();
    app.waitForProcessesAndTerminate();
  }
}

class NewlocPortClassProcess extends NodeCoordinator {
  protected PhysicalLocality server;
  protected int port;
  protected String classname;

  public NewlocPortClassProcess(PhysicalLocality server, int port,
                                String classname) {
    this.server = server;
    this.port = port;
    this.classname = classname;
  }

  public void execute() throws KlavaException {
    PhysicalLocality loc = newloc(new NewnodeProcess(server), port, classname);
    Print("created new locality " + loc);
    KString s = new KString();
    Tuple t = new Tuple(s);
    in(t, self);
    Print("Retrieved \"" + s + "\" inserted by the new locality " + loc);
  }
}

