/*
 * testNoAcceptRemoteProcess.java
 *
 * test remote processes not accepted (especially by a Net)
 */

package klavatest;

import Klava.*;

class testNoAcceptRemoteProcessProc extends KlavaProcess {
  PhysicalLocality server;

  testNoAcceptRemoteProcessProc(PhysicalLocality l) {
    server = l;
  }

  public void execute() throws KlavaException {
    Print("Now I try to evaluate a process to a remote site");
    Print("In this case a Net: " + server);
    try {
      eval(new FooProcess(), server);
      Print("You should not see this.");
    } catch (KlavaRemoteProcessNotAllowed e) {
      e.printStackTrace();
      Print("I received this execption " + e.getMessage());
      Print("as expected.");
    }
  }

  boolean testLoc(String s) {
    try {
      PhysicalLocality l = new PhysicalLocality(s);
      return true;
    } catch (KlavaMalformedPhyLocalityException e) {
      //e.printStackTrace();
      return false;
    }
  }
}

class FooProcess extends KlavaProcess {
  public void execute() throws KlavaException {
    Print("You should not see this...");
  }
}

public class testNoAcceptRemoteProcess extends KlavaTestApplication {
  public testNoAcceptRemoteProcess(String name, String suffix,
                                   boolean log_to_file)
      throws java.io.IOException, InterruptedException, KlavaException {
    super(name, suffix, log_to_file);

    Net net = new Net();
    net.start();

    Node n1 = new Node("testNoRemoteProcess", 9998, "127.0.0.1", 9999);
    n1.start();
    n1.waitToBeConnected();

    addProcessToNode(
        new testNoAcceptRemoteProcessProc(net.ThisLocality()), n1 ) ;
  }

  static public void main( String args[] ) throws Exception {
    boolean log_to_file = args.length > 0;

    KlavaTestApplication app = new testNoAcceptRemoteProcess
      ("testNoAcceptRemoteProcess", (args.length > 1 ? args[1] : ""),
        args.length > 0);

    app.waitForProcessesAndTerminate();

    System.exit(0);
  }
}