
//Title:        Klava
//Version:
//Copyright:    Copyright (c) 1998
//Author:       Lorenzo Bettini
//Company:      University of Florence
//Description:  Your description


package klavatest;

import Klava.* ;
import java.io.IOException ;

public class testNodeConsole extends KlavaProcess {
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality keyb = new LogicalLocality( "keyb" ) ;

  public testNodeConsole() {}

  public void execute() throws KlavaException {
    KString s = new KString() ;
    out( "Try and type something...\n", screen ) ;
    in( s, keyb ) ;
    out( "You typed: ", screen ) ;
    out( s, screen ) ;
    out( "\nThanx an' have a good day :-)\n", screen ) ;
  }

  public static void main( String args[] ) throws Exception {
    if ( args.length < 4 || args.length > 5 )
      throw new IOException( "Syntax : Node <name> <physLocHere> <hostname> <port> {DirConnect}" ) ;

    NodeConsole n = new NodeConsole( args[0], args[1], args[2], Integer.parseInt( args[3] ) ) ;
    if ( args.length == 5 )
      n.setDirectConnections() ;
    n.addToEnv( "screen", "testNodeConsoleScreen" ) ;
    n.addToEnv( "keyb", "testNodeConsoleKeyb" ) ;
    n.start() ;
    n.addProcess( new testNodeConsole() ) ;
  }
}