package klavatest ;

import Klava.* ;

class testNodeListProc extends KlavaProcess {
    protected KString cmd_string = new KString("command");
    protected KString myID = new KString( "testNodeList" ) ;
    protected KString selItem = new KString( "getSelectedItem" ) ;
    protected KString selItems = new KString( "getSelectedItems" ) ;
    protected boolean interactive;

    public testNodeListProc(boolean interactive) {
      this.interactive = interactive;
    }

    public void execute() throws KlavaException {
        KString selected = new KString() ;
        TupleSpace selecteds = new TupleSpace() ;

        if (interactive) {
          Print( "Select one item within 5 seconds" ) ;
          try { Thread.sleep( 5000 ) ; }
          catch ( InterruptedException e ) {}
        }

        out( cmd_string, selItem, myID, self ) ;
        if (in_nb( new Tuple(cmd_string, selItem, myID, selected), self )) {
          Print( "You selected: " + selected ) ;
        } else {
          Print( "You didn't select anything.");
        }

        if (interactive) {
          System.out.println( "Select multiple items within 5 seconds" ) ;
          try { Thread.sleep( 5000 ) ; }
          catch ( InterruptedException e ) {}
        }

        out( cmd_string, selItems, myID, self ) ;
        if (in_nb( new Tuple(cmd_string, selItems, myID, selecteds), self )) {
          Print( "You selected: " + selecteds ) ;
        } else {
          Print( "You didn't select anything.");
        }
    }
}

public class testNodeList extends KlavaTestApplication {
  public testNodeList(String name, String suffix,
                    boolean log_to_file)
                    throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NodeList nlist = new NodeList("testNodeList", "127.0.0.1:9998", "localhost", 9999);

    try {
      nlist.out( new Tuple(new KString("test1" )) ) ;
      nlist.out( new Tuple(new KString("test2" )) ) ;
      nlist.out( new Tuple(new KString("test3" )) ) ;
      nlist.out( new Tuple(new KString("test4" )) ) ;
      nlist.out( new Tuple(new KString("test5" )) ) ;
    } catch (KlavaException ke) {
      ke.printStackTrace();
    }

    if (! log_to_file) {
      KlavaFrame frame = new KlavaFrame( "testNodeList", nlist ) ;
      frame.pack() ;
      frame.show() ;
    } else {
      KlavaMonitorListPanelWSelection list =
        (KlavaMonitorListPanelWSelection)nlist.getPanel();
      list.select(0);
      list.select(1);
      list.select(4);
    }

    addProcessToNode (new testNodeListProc (! log_to_file), nlist);
  }

  static public void main( String args[] ) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    testNodeList app = new testNodeList
      ("testNodeList", (args.length > 1 ? args[1] : ""),
        args.length > 0);

    app.start();
    app.waitForProcessesAndTerminate();

    System.exit(0);
  }
}
