package klavatest;

/**
 * a registered node tries to translate some localities;
 * some can be solved locally and some remotely, passing through
 * 2 servers
 */

import Klava.*;

public class testRemoteAndLocalLocTrans2 extends KlavaTestApplication {
  public testRemoteAndLocalLocTrans2(String name, String suffix,
                                    boolean log_to_file)
                                    throws java.io.IOException,
                                      InterruptedException, KlavaException {
    super(name, suffix, log_to_file);

    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createNodeAddress
        (NetUtils.getLocalIPAddress(), 9999));

    PhysicalLocality gateway_loc =
      new PhysicalLocality(NetUtils.createNodeAddress
        (NetUtils.getLocalIPAddress(), 11000));

    NetNode server = new RegisterNetNode("server", 9999);
    server.addToEnv("server", server.ThisLocality().toString());
    server.addToEnv("printer", server.ThisLocality().toString());
    server.addToEnv("screen", server.ThisLocality().toString());
    server.setLocalityPropagation(false);
    server.start();

    NetNode gateway = new RegisterNetNode("gateway", 11000);
    //n2.addToEnv("screen", n2.ThisLocality().toString());
    gateway.start();
    //gateway.setLocalityPropagation(false);
    gateway.addProcess(new SubscriberNodeCoordinator(server_loc,
        "gateway"));
    gateway.waitToBeConnected();

    NetNode n2 = new NetNode("l2", 10001);
    //n2.setLocalityPropagation(false);
    n2.start();
    //n2.addToEnv("screen", n2.ThisLocality().toString());
    n2.addProcess(new SubscriberNodeCoordinator(gateway_loc,
        "n2"));
    n2.waitToBeConnected();
    addProcessToNode(new LocSolverProcess(), n2);
  }

  public static void main(String args[]) throws Exception {
    KlavaTestApplication app = new testRemoteAndLocalLocTrans2
      ("testRemoteAndLocalLocTrans2", (args.length > 1 ? args[1] : ""),
        args.length > 0);

    app.waitForProcessesAndTerminate();
  }
}
