package klavatest;

import Klava.*;

/**
 * the client connected to the server cannot solve a logical locality
 * so it rilies on the server
 */

public class testRemoteLocalityTranslation {
  private String server;
  private boolean start_server = true;

  public testRemoteLocalityTranslation(String server, boolean start_server) {
    this.server = server;
    this.start_server = start_server;
  }

  public static void main(String args[]) throws Exception {
    String server = null;

    if (args.length > 0)
      server = args[0];

    (new testRemoteLocalityTranslation(server, !(args.length > 1))).start();
  }

  void start() throws Exception {
    LogicalLocality loc_server = new LogicalLocality("server");

    if (start_server) {
      RegisterNetNode server_node = new RegisterNetNode("server", 9999);
      server_node.addToEnv("server", server_node.ThisLocality().toString());
      server_node.start();
    }

    NetNode n = new NetNode("testRemoteLocalityTranslation", 11000);
    n.addProcess(new SubscribeAndUnsubscribeProcess(server,
      "testRemoteLocalityTranslation"));
    n.addProcess(new CommunicateWithServerThatDisconnect(loc_server));
    n.start();
  }
}