// this is to test remote timeout

package klavatest;

import Klava.*;

class RemoteTimeOutProcess extends KlavaProcess {
    public void execute() throws KlavaException {
        KString s = new KString ();
        Locality l = new PhysicalLocality("127.0.0.1:9997");

        try {
            Print("Trying to retrieve a string from " + l);
            read( s, l, 10 );
            Print ("Retrieved String: " + s);
        } catch (KlavaTimeOutException e) {
            Print ("T I M E O U T :-(");
        }

        Tuple t = new Tuple();
        t.add(s);
        Print("Trying to retrieve a string from " + l);
        boolean res = read_t( t, l, 1 );
        KBoolean b = new KBoolean(res);
        if (b.booleanValue ())
            Print ("Retrieved String: " + s);
        else
            Print ("T I M E O U T :-(");
    }
}

public class testRemoteTimeout extends KlavaTestApplication {
  public testRemoteTimeout(String name, String suffix,
                    boolean log_to_file)
                    throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    addNode(new Node("RemoteNode", "127.0.0.1:9997", "localhost", 9999));
    Node n = new Node( "n1", "127.0.0.1:9998", "localhost", 9999 ) ;
    addProcessToNode(new RemoteTimeOutProcess (), n);
  }

  static public void main( String args[] ) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new testRemoteTimeout
      ("testRemoteTimeout", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.start();
    app.waitForProcessesAndTerminate();

    System.exit(0);
  }
}
