/*
 * testSequentialLocal.java
 *
 * retrieves more tuples with the same template
 */

package klavatest;

import Klava.*;

class testSeqLocProcess1 extends KlavaProcess {

  public void execute() throws KlavaException {
    Tuple t1 = new Tuple(new KInteger(10), new KInteger(20));
    Tuple t2 = new Tuple(new KInteger(100), new KInteger(200));
    Print("Inserting " + t1 + " at " + self);
    out( t1, self ) ;
    Print("Inserting " + t2 + " at " + self);
    out( t2, self ) ;

    Print ( "DONE ! :-)" ) ;
  }
}

class testSeqLocProcess2 extends KlavaProcess {

    //protected PhysicalLocality n1 = new PhysicalLocality ("n1");
    protected Locality n1 = new LogicalLocality ("self");

  public void execute() throws KlavaException {
      KInteger i1 = new KInteger ();
      KInteger i2 = new KInteger ();

      Tuple template = new Tuple ();
      template.setHandleRetrieved (true);

      Print ("Local Test...");

      template.add (i1);
      template.add (i2);

      Print( "First retrieval...");

      read( template, n1 ) ;

      Print( "i1 = " + i1 ) ;
      Print( "i2 = " + i2 ) ;

      i1 = new KInteger ();
      i2 = new KInteger ();

      template.reset ();
      template.add (i1);
      template.add (i2);

      Print( "Second retrieval...");

      read( template, n1 ) ;

      Print( "i1 = " + i1 ) ;
      Print( "i2 = " + i2 ) ;

      Print( "DONE ! :-)" ) ;
  }
}

public class testSequentialLocal extends KlavaTestApplication {
  public testSequentialLocal(String name, String suffix,
                    boolean log_to_file)
                    throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    Node n1 = new Node( "n1", "127.0.0.1:9998", "localhost", 9999 ) ;
    addProcessToNode( new testSeqLocProcess1 (), n1 ) ;
    addProcessToNode( new testSeqLocProcess2 (), n1 ) ;
  }

  static public void main( String args[] ) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new testSequentialLocal
      ("testSequentialLocal", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.start();
    app.waitForProcessesAndTerminate();
  }
}
