package klavatest;

import Klava.*;

/**
 * Test subscribe and unsubscribe according to entered keystrokes
 * Meanwhile a process outs an incremented number to the remote server
 * and tries to retrieve it.  When the client is not connected this
 * process is blocked, until the client reconnects.
 */

public class testSubscribeAndUnsubscribe {
  private String server;

  public testSubscribeAndUnsubscribe(String server) {
    this.server = server;
  }

  public static void main(String args[]) throws Exception {
    String server = null;
    int server_port = 9999;

    if (args.length > 0)
      server = args[0];

    (new testSubscribeAndUnsubscribe(server)).start();
  }

  void start() throws Exception {
    NetNode n = new NetNode("testSubscribeAndUnsubscribe", 11000);
    //n.setMessagePrinterFactory(new FileMessagePrinterFactory ());
    n.addProcess(new SubscribeAndUnsubscribeProcess(server,
      "testSubscribeAndUnsubscribe"));
    n.addProcess(new CommunicateWithServerThatDisconnect(server));
    n.start();
  }
}

class SubscribeAndUnsubscribeProcess extends NodeCoordinator {
  PhysicalLocality server;
  LogicalLocality loc;

  public SubscribeAndUnsubscribeProcess(String server, String loc) throws KlavaException {
    if (server != null)
      this.server = new PhysicalLocality(NetUtils.createNodeAddress
        (server, 9999));
    else
      this.server =
      new PhysicalLocality(NetUtils.createNodeAddress
    (NetUtils.getLocalIPAddress(), 9999));

    this.loc = new LogicalLocality(loc);
  }

  public void execute() throws KlavaException {
    boolean result;
    int command;

    Print("PRESS: S for subscribe, U for unsubscribe to/from " + server);

    while (true) {
      try {
        command = System.in.read();
        if (command == 'S') {
          Print("Trying to subscribe to " + server + " as " + loc);
          result = subscribe(server, loc);
          Print("Subscribe result: " + result);
        } else if (command == 'U') {
          Print("Unsubscribe from " + server);
          unsubscribe(server, loc);
          Print("Unsubscribed.");
        } else if (command != '\n' && command != '\r')
          Print("Unrecognized command " + command);
      } catch(java.io.IOException ioe) {
      }
    }
  }
}