package klavatest;

/**
 * test the logging of processes in a node
 */

import Klava.*;

public class testWaitProcesses extends KlavaTestApplication {
  public testWaitProcesses(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException,
                                 InterruptedException, KlavaException {
    super(name, suffix, log_to_file);

    Node node = new Node("Wait_node", "127.0.0.1:9998", "localhost", 9999);
    addNode(node);

    Node node2 = new Node("node2", "127.0.0.1:9997", "localhost", 9999);

    KlavaProcess PtoWait = new ProcessToWait ();
    KlavaProcess PtoWait2 = new ProcessToWait2 ();
    KlavaProcess PnottoWait = new ProcessNotToWait ();

    node.waitForName("ProcessToWait2");
    node.waitForName("ProcessToWait");

    node.addProcess(PtoWait);
    node.addProcess(PtoWait2);
    node.addProcess(PnottoWait);

    node.start();
    node.waitToBeConnected();

    node2.start();
    node2.addProcess(new PutProcess
      (new PhysicalLocality("127.0.0.1:9998")));
  }

  public static void main(String args[]) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new testWaitProcesses
      ("testWaitProcesses", (args.length > 1 ? args[1] : ""),
        args.length > 0);

    app.waitForProcessesAndTerminate();
  }
}

class ProcessToWait extends KlavaProcess {
  public void execute() throws KlavaException {
    KString s = new KString();

    Print("I'm process " + KlavaProcName() );
    Print("The node will wait for me to terminate...");
    Print("So you should see this :-)");
    read(s, self);
    Print("Read " + s);
  }
}

class ProcessToWait2 extends KlavaProcess {
  public void execute() throws KlavaException {
    KString s = new KString();

    Print("I'm process " + KlavaProcName() );
    Print("The node will wait for me to terminate...");
    Print("So you should see this :-)");
    read(s, self);
    Print("Read " + s);
  }
}

class ProcessNotToWait extends KlavaProcess {
  public void execute() throws KlavaException {
    Print("I'm process " + KlavaProcName() );
    Print("The node won't wait for me...");

    try {
      Thread.sleep(5000);
    } catch (InterruptedException ie) {
      return;
    }

    Print("You should not see this!");
  }
}

class PutProcess extends KlavaProcess {
  protected Locality loc;

  public PutProcess(Locality l) {
    loc = l;
  }

  public void execute() throws KlavaException {
    out(new KString("hello"), loc);
  }
}