site orcNode = com.orcNode
site orcTuple = com.orcTuple

val client = orcNode("client",15000,"localhost",9999)
val store1 = orcNode("store1",15001,"localhost",9998)
val store2 = orcNode("store2",15002,"localhost",9997)
val store3 = orcNode("store3",15003,"localhost",9996)


val c = orcTuple()

def addLocality() = 
 	client.addEnv("lClient",14000)
        >> store1.addEnv("l",11004)
        >> store2.addEnv("l",12004)
        >> store3.addEnv("l",13004)

def moveToStore1() = 
	store1.in(c.tuple("id3",c.intFormal(),c.intFormal(),"reqId12"),c.locality("l")) 
        > x > c.get(x,1) > z > 
	client.out(c.tuple("store1","reqId12",z),c.locality("lClient")) >> moveToStore1()


def moveToStore2() = 
	store2.in(c.tuple("id3",c.intFormal(),c.intFormal(),"reqId12"),c.locality("l")) 
        > x > c.get(x,1) > z >
	client.out(c.tuple("store2","reqId12",z),c.locality("lClient")) >> moveToStore2()


def moveToStore3() = 
	store3.in(c.tuple("id3",c.intFormal(),c.intFormal(),"reqId12"),c.locality("l")) 
        > x > c.get(x,1) > z > 
	client.out(c.tuple("store3","reqId12",z),c.locality("lClient")) >> moveToStore3()

def startSearch() = 
	c.loadProcess("FindItem","id3",200,"reqId12")
        > proc > 
        store1.eval(proc,c.locality("l"))
	>> store2.eval(proc,c.locality("l")) 
        >> store3.eval(proc,c.locality("l"))

def g() =
	client.out(c.tuple("sum","store1","reqId12",0),c.locality("lClient")) 
        |
	client.out(c.tuple("sum","store2","reqId12",0),c.locality("lClient")) 
        |
	client.out(c.tuple("sum","store3","reqId12",0),c.locality("lClient")) 
	|
	(if x = "store1ok" then 
	    print("\n \n Order placed at store 1 \n \n") >> stop
         else
	    (if x = "store2ok" then
		print("\n \n Order placed at store 2 \n \n") >> stop
	     else	
		(if x = "store3ok" then
		  print("\n \n Order placed at store 3 \n \n") >> stop
	    	)
	    )	
	) < x < ( g1() | g2() | g3() )

def g1() = 
	client.in(c.tuple("store1","reqId12",c.intFormal()),c.locality("lClient"))
        > x > c.getInt(x,2) > y > 
	client.in(c.tuple("sum","store1","reqId12",c.intFormal()),c.locality("lClient"))>x>
	c.getInt(x,3) > sum > 
	(if (y + sum >= 30) then 
		let("store1ok") 
	else 
		( client.out(c.tuple("sum","store1","reqId12",y + sum),c.locality("lClient"))>> g1() )
	)
	

def g2() = 
	client.in(c.tuple("store2","reqId12",c.intFormal()),c.locality("lClient"))
        > x > c.getInt(x,2) > y > 
	client.in(c.tuple("sum","store2","reqId12",c.intFormal()),c.locality("lClient"))
        > x > c.getInt(x,3) > sum > 
	(if (y + sum >= 30) then 
		let("store2ok") 
	else 
		( client.out(c.tuple("sum","store2","reqId12",y + sum),c.locality("lClient"))>> g2() )
	)
	
def g3() = 
	client.in(c.tuple("store3","reqId12",c.intFormal()),c.locality("lClient"))
        > x > c.getInt(x,2) > y > 
	client.in(c.tuple("sum","store3","reqId12",c.intFormal()),c.locality("lClient"))>x>
	c.getInt(x,3)> sum > 
	(if (y + sum >= 30) then 
		let("store3ok") 
	else 
		( client.out(c.tuple("sum","store3","reqId12",y + sum),c.locality("lClient"))>> g3() )
	)
	

addLocality() 
>> ( startSearch() >> (moveToStore1() | moveToStore2() | moveToStore3() | g()) ) 


