package org.mikado.imc.mobility;

/**
 * A MessagePrinter specialized to simply print on the screen
 *
 * @author $author$
 * @version $Revision: 1.2 $
 */
public class DefaultMessagePrinter extends MessagePrinter {
    /**
     * Creates a new DefaultMessagePrinter object.
     */
    public DefaultMessagePrinter() {
        this("MessagePrinter", null);
    }

    /**
     * Creates a new DefaultMessagePrinter object.
     *
     * @param s name for this message printer
     */
    public DefaultMessagePrinter(String s) {
        this(s, null);
    }

    /**
     * Creates a new DefaultMessagePrinter object.
     *
     * @param name name for the message printer
     * @param decorated the message printer to decorate
     */
    public DefaultMessagePrinter(String name, MessagePrinter decorated) {
        super(name, decorated);
    }

    /**
     * print the message on the screen
     *
     * @param s the message to print
     */
    public void Print(String s) {
        super.Print(s);
        System.out.println(name + ": " + s);
    }
}
