package org.mikado.imc.mobility;

import java.io.*;

/**
 * A MessagePrinter that print the messages in a file
 *
 * @author $author$
 * @version $Revision: 1.2 $
 */
public class FileMessagePrinter extends MessagePrinter {
    /** the file output stream */
    protected FileWriter out;

    /**
     * Creates a new FileMessagePrinter object.
     *
     * @param name name for this message printer
     * @param decorated the message printer to decorate
     * @param filename the name of the output file (that will be overwritten)
     *
     * @throws IOException DOCUMENT ME!
     */
    public FileMessagePrinter(String name, MessagePrinter decorated,
        String filename) throws IOException {
        super(name, decorated);
        out = new FileWriter(filename);
    }

    /**
     * print a message to the file
     *
     * @param s the message to print
     */
    public void Print(String s) {
        super.Print(s);

        try {
            out.write(name + ": " + s + "\n");
            out.flush();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
