/**
 * TestAgentEx.
 * This is a more complex example; the agent first migrates to a remote
 * host, and then, from there, migrates to another one.
 */

package classloading.othersrc;

import Klava.KlavaProcess;
import klavatest.AdditionalStuff;

import java.io.* ;

public class TestAgentEx extends AdditionalStuff
    implements TestAgentInterface, TestAgentInterface2 {
  // Test data that will be delivered together with the agent
  protected String s1;
  protected int n1;

  protected KlavaProcess parent;

    protected TAclass1 cl1;

  public TestAgentEx(KlavaProcess P) {
      s1 = new String( "foo string" );
      n1 = 100 ;
      parent = P;
  }

  public void onArrival() {
    Print( "Hi, I am " + getClass().getName() + " and I've just arrived..." ) ;
    Print( "These are my variables: " + s1 + ", " + n1 ) ;
    Print( "I'm creating some instances..." ) ;
    cl1 = new TAclass1( "Hello everyone :-)", parent ) ;
    cl1.saySomething() ;
    Print( "I'm instantiating some classes..." ) ;

    MyInnerClass ic = new MyInnerClass();
    MyInnerInterface ii;
    MyProtectedInnerClass pic = new MyProtectedInnerClass();

    Print( "Bye bye :-)" ) ;
  }

    public class MyInnerClass {
        protected class MyInnerInnerClass {
        }
    }

    public interface MyInnerInterface {
    }

    protected class MyProtectedInnerClass {
    }

    public void Print(String s) {
        parent.Print("TestAgentEx: " + s);
    }
}

interface TestAgentInterface {
    void onArrival();
}

interface TestAgentInterface2 {
    void Print(String s);
}

class TAclassBase implements Serializable {
    String s ;
    KlavaProcess parent;

    public TAclassBase( String S, KlavaProcess P ) { 
        s = S ;
        parent = P;
    }

    public void saySomething() {
        parent.Print( s + " from class " + getClass().getName() ) ;
    }
}

class TAclass1 extends TAclassBase {

  TAclass2 cl2 ;

  public TAclass1( String S, KlavaProcess P ) {
    super( S, P ) ;
    cl2 = new TAclass2( S ) ;
  }

  public void saySomething() {
    super.saySomething() ;
    cl2.saySomething() ;
  }
}

class TAclass2 implements Serializable {
  String s ;

  public TAclass2( String S ) { s = S ; }

  public void saySomething() {
    System.out.println( s + " from class " + getClass().getName() ) ;
  }
}
