package classloading;

import Klava.*;
import classloading.othersrc.TestAgentEx;

/**
 * test sending and loading of remote classes
 */

public class sendRemoteProcess extends KlavaTestApplication {
  public sendRemoteProcess(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode client = new NetNode("client", 9995);
    client.logRecordedClasses(true);

    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createLocalNodeAddress(9999));
    addProcessToNode(new LoginNodeCoordinator(server_loc), client);
    try {
      client.waitToBeConnected();
      addProcessToNode(new SendRemP(server_loc), client);
    } catch (InterruptedException ie) {
      ie.printStackTrace();
    }
  }

  public static void main(String args[]) throws Exception {
    System.err.println("*** CLASSPATH = " +
                       System.getProperty("java.class.path"));

    KlavaTestApplication app = new sendRemoteProcess
      ("sendRemoteProcess", (args.length > 1 ? args[1] : "cl_msgout"),
        args.length > 0);
    
    app.start();
    app.waitForProcessesAndTerminate();
  }
}

class SendRemP extends KlavaProcess {
  Locality remote;
  Locality home = null;

  SendRemP(Locality remote) {
    this.remote = remote;
  }

  public void execute() throws KlavaException {
      if (home == null) // save it only the first time
        home = getPhysicalLocality(self);

    Print("Sending process to " + remote);
    out(new ProcessToSend(home, remote), remote);
    Print("Process sent");
    in(new KString("done"), home);
    Print("Remote process terminated");
  }
}

class ProcessToSend extends KlavaProcess {
    private Locality home;
    Locality remote;
    protected TestAgentEx additional_stuff;

    ProcessToSend(Locality home, Locality remote) {
        this.home = home;
        this.remote = remote;
        setMessages(true);
    }

    public void execute() throws KlavaException {
        additional_stuff = new TestAgentEx(this);
        Print("arrived at " + remote);
        additional_stuff.onArrival();
        out(new KString("done"), home);
    }
}
