package classloading;

import Klava.*;
import classloading.othersrc.TestAgentEx;

/**
 * test sending and loading of remote classes.  Use eval for remote spawn
 */

public class sendRemoteProcessEval extends KlavaTestApplication {
  public sendRemoteProcessEval(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode client = new NetNode("client", 11000);
    client.logRecordedClasses(true);

    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createLocalNodeAddress(9999));
    addProcessToNode(new LoginNodeCoordinator(server_loc), client);
    try {
      client.waitToBeConnected();
      addProcessToNode(new SendRemPEval(server_loc), client);
    } catch (InterruptedException ie) {
      ie.printStackTrace();
    }
  }

  public static void main(String args[]) throws Exception {
    System.err.println("*** CLASSPATH = " +
                       System.getProperty("java.class.path"));

    KlavaTestApplication app = new sendRemoteProcessEval
      ("sendRemoteProcessEval", (args.length > 1 ? args[1] : "cl_msgout"),
        args.length > 0);
    
    app.start();
    app.waitForProcessesAndTerminate();
  }
}

class SendRemPEval extends KlavaProcess {
  Locality remote;
  Locality home = null;

  SendRemPEval(Locality remote) {
    this.remote = remote;
  }

  public void execute() throws KlavaException {
      if (home == null) // save it only the first time
        home = getPhysicalLocality(self);

    Print("Sending process to " + remote + " for evaluation");
    ProcessToSend P = new ProcessToSend(home, remote);
    P.setKlavaProcName(P.KlavaProcName()+"_eval");
    eval(P, remote);
    Print("Process sent");
    in(new KString("done"), home);
    Print("Remote process terminated");
    out(new KString("done"), remote);
  }
}
