package classloading;

import Klava.*;
import java.io.*;
import java.util.*;
import classloading.othersrc.TestAgentEx;

/**
 * test sending and loading of remote classes
 * the process that is sent tries to perform some malicious actions
 */

public class sendRemoteProcessMalicious extends KlavaTestApplication {
  public sendRemoteProcessMalicious(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode client = new NetNode("client", 9995);
    client.logRecordedClasses(true);

    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createLocalNodeAddress(9999));
    addProcessToNode(new LoginNodeCoordinator(server_loc), client);
    try {
      client.waitToBeConnected();
      addProcessToNode(new SendRemPM(server_loc), client);
    } catch (InterruptedException ie) {
      ie.printStackTrace();
    }
  }

  public static void main(String args[]) throws Exception {
    System.err.println("*** CLASSPATH = " +
                       System.getProperty("java.class.path"));

    KlavaTestApplication app = new sendRemoteProcessMalicious
      ("sendRemoteProcessMalicious", (args.length > 1 ? args[1] : "cl_msgout"),
        args.length > 0);
    
    app.start();
    app.waitForProcessesAndTerminate();
  }
}

class SendRemPM extends KlavaProcess {
  Locality remote;
  Locality home = null;

  SendRemPM(Locality remote) {
    this.remote = remote;
  }

  public void execute() throws KlavaException {
      if (home == null) // save it only the first time
        home = getPhysicalLocality(self);

    Print("Sending process to " + remote);
    out(new MaliciousProcessToSend(home, remote, 
                                   FileUtils.getClassPathDirectories()),
        remote);
    Print("Process sent");
    in(new KString("done"), home);
    Print("Remote process terminated");
  }
}

class MaliciousProcessToSend extends KlavaProcess {
    private Locality home;
    Locality remote;
    protected TestAgentEx additional_stuff;
    private Vector class_path;

    MaliciousProcessToSend(Locality home, Locality remote,
                           Vector class_path ) {
        this.home = home;
        this.remote = remote;
        this.class_path = class_path;
        setMessages(true);
    }

    public void execute() throws KlavaException {
        additional_stuff = new TestAgentEx(this);
        Print("arrived at " + remote);
        additional_stuff.onArrival();

        Print("now I'll try to perform some malicious actions");
        
        Print("Trying to write...");
        try {
            DataOutputStream fo = 
                new DataOutputStream
                (new FileOutputStream("malicious_foo.txt"));
            fo.writeUTF("booh");
            Print("Success!"); // you should not see this
        } catch (SecurityException se) {
            se.printStackTrace();
            Print("Failed: " + se.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            Print("Failed: " + e.getMessage());
        }

        Print("Trying to read...");
        try {
            new FileInputStream("malicious_foo.txt");
            Print("Success!"); // you should not see this
        } catch (SecurityException se) {
            se.printStackTrace();
            Print("Failed: " + se.getMessage());
        } catch (Exception e) {
            e.printStackTrace();
            Print("Failed: " + e.getMessage());
        }

        Print("Trying to shutdown the application...");
        try {
            System.exit(1);
        } catch (SecurityException se) {
            se.printStackTrace();
            Print("Failed: " + se.getMessage());
        }

        Print("Trying to read the KlavaProcess.class...");
        try {
            File file = FileUtils.getClassPathFile("Klava" +
                                                   File.separatorChar +
                                                   "KlavaProcess.class",
                                                   class_path);
            Print("class file KlavaProcess.class found? " + file.exists());
            FileInputStream is = new FileInputStream(file);
            Print("Opened.");
        } catch (Exception e) {
            e.printStackTrace();
            Print("Failed: " + e.getMessage());
        }

        out(new KString("done"), home);
    }
}
