package classloading;

import Klava.*;
import classloading.othersrc.UseMixinRedef;

/**
 * test sending and loading of remote classes.  Use eval for remote spawn
 */

public class sendRemoteProcessMoMi extends KlavaTestApplication {
  public sendRemoteProcessMoMi(String name, String suffix,
                                 boolean log_to_file)
                                 throws java.io.IOException, KlavaException {
    super(name, suffix, log_to_file);

    NetNode client = new NetNode("client", 11000);
    client.logRecordedClasses(true);

    PhysicalLocality server_loc =
      new PhysicalLocality(NetUtils.createLocalNodeAddress(9999));
    addProcessToNode(new LoginNodeCoordinator(server_loc), client);
    try {
      client.waitToBeConnected();
      addProcessToNode(new SendRemPMoMi(server_loc), client);
    } catch (InterruptedException ie) {
      ie.printStackTrace();
    }
  }

  public static void main(String args[]) throws Exception {
    System.err.println("*** CLASSPATH = " +
                       System.getProperty("java.class.path"));

    KlavaTestApplication app = new sendRemoteProcessMoMi
      ("sendRemoteProcessMoMi", (args.length > 1 ? args[1] : "cl_msgout"),
        args.length > 0);
    
    app.start();
    app.waitForProcessesAndTerminate();
  }
}

class SendRemPMoMi extends KlavaProcess {
  Locality remote;
  Locality home = null;

  SendRemPMoMi(Locality remote) {
    this.remote = remote;
  }

  public void execute() throws KlavaException {
      if (home == null) // save it only the first time
        home = getPhysicalLocality(self);

    Print("Sending process to " + remote + " for evaluation");
    ProcessWithMoMiStuff P = new ProcessWithMoMiStuff(home, remote);
    P.setKlavaProcName(P.KlavaProcName()+"_eval");
    eval(P, remote);
    Print("Process sent");
    in(new KString("done"), home);
    Print("Remote process terminated");
    out(new KString("done"), remote);
  }
}

class ProcessWithMoMiStuff extends KlavaProcess {
    private Locality home;
    Locality remote;
    protected UseMixinRedef other_proc;

    ProcessWithMoMiStuff(Locality home, Locality remote) {
        this.home = home;
        this.remote = remote;
        setMessages(true);
    }

    public void execute() throws KlavaException {
        other_proc = new UseMixinRedef();
        Print("arrived at " + remote);
        procCall(other_proc);
        out(new KString("done"), home);
    }
}
