/**
 * Agentx
 *
 * retrieves tuplex with a mobile agent
 * extending from KlavaProcessx
 * It doesn't work because there are KCipherMatcher setted
 */

package test_crypto;

import java.io.* ;
import java.util.Vector ;
import Klava.* ;
import Klava.crypto.*;

class AgentxAgentHome extends KlavaProcessx {

    protected Locality dati1 = new LogicalLocality("data1");
    protected Locality dati2 = new LogicalLocality("data2");

    public AgentxAgentHome() throws Exception {
        super (new KStoreFileAccess("Agent2.answers"));
        //super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {

        PhysicalLocality myLoc = getPhysicalLocality(self);

        try {
          KlavaProcess agent = new AgentxAgent(myLoc, dati2);
          agent.setKlavaProcName(agent.KlavaProcName() + "-" + dati1);
          eval( agent, dati1 ) ;
        } catch (Exception e) {
            e.printStackTrace ();
        }
        in( new KString("DONE"), self ) ;
        TupleSpace collectedData = new TupleSpace();
        in( collectedData, self );
        while ( true ) {
            Tuplex txf1 = new Tuplex() ;
            KString s1 = new KString() ;
            txf1.add( s1 ) ;
            KString fString1 = new KString() ;
            KCipher k = new KCipher( fString1 ) ;
            txf1.add( k ) ;
           try {
                collectedData.in(txf1, 10) ;
            } catch ( KlavaTimeOutException e ) {
                Print("No more collected data" ) ;
                break ;
            }

           try {
                if ( txf1.decode() ) {
                  Print("decoded: " + txf1);
                  Print("s1 = " + s1);
                  Print("fString1 = " + fString1);
                  out( s1, self ) ;
                  out( fString1, self );
                  out( txf1 ) ;
                } else {
                  Print("decription failed for " + s1);
                  txf1.add("DECRIPTION FAILED") ;
                  out( txf1 ) ;
                }
           } catch (Exception e) {
               e.printStackTrace ();
           }
        }
    }
}

class AgentxAgent extends KlavaProcessx {

    protected Locality owner ;
    protected Locality secondStep ;
    protected boolean done = false ;
    private TupleSpace collectedData ;

    public AgentxAgent( Locality from, Locality to ) throws Exception {
        owner = from ;
        secondStep = to ;
        collectedData = new TupleSpace() ;
    }

    public void execute() throws KlavaException {
        Tuplex txf1 = new Tuplex() ;
        KString s1 = new KString() ;
        txf1.add( s1 ) ;
        KString fString1 = new KString() ;
        KCipher k = new KCipher( fString1 ) ;
        txf1.add( k ) ;
        try {
          Print("arrived at " + getPhysicalLocality(self));
          if (in_t(txf1, self, 2000)) {
            collectedData.out(txf1) ;
            Print("retrieved encrypted tuple");
          } else
            Print("couldn't retrieve an encrypted tuple");
        } catch (Exception e) {
            e.printStackTrace ();
        }
        if ( ! done ) {
            done = true ;
            Print("migration to " + secondStep);
            setKlavaProcName(KlavaProcName() + "-" + secondStep);
            eval(this, secondStep) ;
        } else {
            Print("itinerary is finished");
            out(collectedData, owner) ;
            out(new KString("DONE"), owner) ;
        }
    }
}

public class Agentx extends KlavaTestApplication {
  public Agentx(String name, String suffix,
               boolean log_to_file)
      throws Exception {
    super(name, suffix, log_to_file);

    Node Node1 = new Node ("node1", 9990, "localhost", 9999 );
    Node Node2 = new Node ("node2", 9980, "localhost", 9999 );
    Node Node3 = new Node ("node3", 9970, "localhost", 9999 );

    Node1.setLocalMatcher (new KCipherLocalMatcher ());
    Node1.setLocalTupleSpaceMatcher
        (new KCipherLocalTupleSpaceMatcher ());
    Node1.addToEnv("data2", 9980);
    Node1.start();
    Node1.waitToBeConnected();
    addProcessToNode (new AgentProc1(), Node1);

    Node2.setLocalMatcher (new KCipherLocalMatcher ());
    Node2.setLocalTupleSpaceMatcher
        (new KCipherLocalTupleSpaceMatcher ());
    Node2.start ();
    Node2.waitToBeConnected();
    addProcessToNode (new AgentProc2(), Node2);

    Node3.setLocalMatcher (new KCipherLocalMatcher ());
    Node3.setLocalTupleSpaceMatcher
        (new KCipherLocalTupleSpaceMatcher ());
    Node3.addToEnv("data1", 9990);
    Node3.start ();
    Node3.waitToBeConnected();
    addProcessToNode (new AgentxAgentHome(), Node3);
  }

  static public void main  (String args[]) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new Agentx
      ("Agentx", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.waitForProcessesAndTerminate();
  }
}