/**
 * LocalFailure
 *
 * retrieves a tuple crypted with a different key
 */

package test_crypto;

import java.io.* ;
import Klava.* ;
import Klava.crypto.*;
import javax.crypto.* ;
import javax.crypto.spec.* ;

class LocalFailureProcPut1 extends KlavaProcessx {

    public LocalFailureProcPut1() throws Exception {
	super (new KStoreFileAccess("LocalFailure1.answers"));
	//super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
	try {
	    setEncKey("1");
	    Tuplex tx1 = new Tuplex() ;
            tx1.add(new KString("daniele1")) ;
            KString s1= new KString("usata chiave1") ;
            tx1.add(new KCipher(s1)) ;
	    tx1.encode();
            out(tx1,self) ;
            Print("first tuple encoded");

	    setEncKey("2");
            Tuplex tx2 = new Tuplex() ;
            tx2.add(new KString("daniele2")) ;
            KString s2 = new KString("usata chiave1") ;
            tx2.add(new KCipher(s2)) ;
	    tx2.encode();
            Print("second tuple encoded");
            out(tx2,self) ;
	    unsetEncKey();
	} catch (Exception e1) {
            e1.printStackTrace ();
        }
    }
}

class LocalFailureProcPut2 extends KlavaProcessx {

    public LocalFailureProcPut2() throws Exception {
	super (new KStoreFileAccess("LocalFailure2.answers"));
	//super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
        try {
	   setEncKey("3");

	    Tuplex tx3 = new Tuplex() ;
            tx3.add(new KString("daniele3")) ;
            KString s3 = new KString("usata chiave1") ;
            tx3.add(new KCipher(s3)) ;
	    tx3.encode();
            Print("first tuple encoded");
            out(tx3,self) ;
	    unsetEncKey();
	} catch (Exception e1) {
          Print("failure during encoding of first tuple");
          e1.printStackTrace ();
        }
	try {
	    setEncKey("4");
	    Tuplex tx4 = new Tuplex() ;
            tx4.add(new KString("becchi")) ;
            KString s4 = new KString("usata chiave2") ;
            tx4.add(new KCipher(s4)) ;
	    tx4.encode();
            Print("second tuple encoded");
            out(tx4,self) ;

        } catch (Exception e2) {
          Print("failure during encoding of second tuple");
          e2.printStackTrace ();
	}
    }
}

class LocalFailureProc2 extends KlavaProcessx {

    protected Locality dati = new LogicalLocality("self");

    public LocalFailureProc2() throws Exception {
	super (new KStoreFileAccess("LocalFailure3.answers"));
	//super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
        try {
	    Tuplex txf1 = new Tuplex() ;
	    setDecKey("chiave decifratura1?");
            KString fString1 = new KString() ;
            KString s1 = new KString() ;
	    txf1.add( s1 ) ;
            KCipher k1 = new KCipher( fString1 ) ;
	    txf1.add( k1 ) ;

            Print("reading encoded tuple...");
            read(txf1, dati) ;
            Print("read this data " + txf1);
            Print("s1 field is " + s1);
            Print("fString field is " + fString1);

            out(s1, self) ;
            out(fString1,self);
	} catch (Exception e) {
            e.printStackTrace ();
        }

    }
}

public class LocalFailure extends KlavaTestApplication {
  public LocalFailure(String name, String suffix,
                      boolean log_to_file)
      throws Exception {
    super(name, suffix, log_to_file);

    Node Node1 = new Node ("node1", 9998, "localhost", 9999 );

    Node1.addToEnv("dati", 9998);
    Node1.setLocalMatcher (new KCipherLocalMatcher ());
    Node1.setLocalTupleSpaceMatcher
    (new KCipherLocalTupleSpaceMatcher ());
    Node1.start();
    Node1.waitToBeConnected();

    addProcessToNode(new LocalFailureProcPut1(), Node1);
    //Thread.sleep (4000); // we must be sure that Put1 executes first
    addProcessToNode(new LocalFailureProcPut2(), Node1);
    addProcessToNode(new LocalFailureProc2(), Node1);
  }

  static public void main  (String args[]) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new LocalFailure
      ("LocalFailure", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.waitForProcessesAndTerminate();
  }
}

