/**
 * LocalInFailure
 *
 * retrieves a tuple crypted with a different key, using an in
 */

package test_crypto;

import java.io.* ;
import Klava.* ;
import Klava.crypto.*;
import javax.crypto.* ;
import javax.crypto.spec.* ;

class LocalInFailureProc1 extends KlavaProcessx {

    public LocalInFailureProc1() throws Exception {
	super (new KStoreFileAccess("LocalInFailure1.answers"));
	//super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
        try {
	    setEncKey("1 2 3");

            Tuplex tx1 = new Tuplex() ;
            tx1.add(new KString("lorenzo1")) ;
            KString s = new KString("usata chiave1") ;
            tx1.add(new KCipher(s)) ;
	    tx1.encode();
            Print("first encoded tuple inserted");
            out(tx1,self) ;

            Tuplex tx3 = new Tuplex() ;
            tx3.add(new KString("lorenzo2")) ;
            KString s3 = new KString("usata chiave1") ;
            tx3.add(new KCipher(s3)) ;
	    tx3.encode();
            Print("second encoded tuple inserted");
            out(tx3,self) ;

            Tuplex tx4 = new Tuplex() ;
            tx4.add(new KString("lorenzo3")) ;
            KString s4 = new KString("usata chiave1") ;
            tx4.add(new KCipher(s4)) ;
	    tx4.encode();
            Print("third encoded tuple inserted");
            out(tx4,self) ;
	    unsetEncKey();
	} catch (Exception e1) {
          Print("problems when encoding with keys 1 2 3");
          e1.printStackTrace ();
        }
	try {
	    setEncKey("4");
	    Tuplex tx2 = new Tuplex() ;
            tx2.add(new KString("bettini")) ;
            KString s2 = new KString("usata chiave2") ;
            tx2.add(new KCipher(s2)) ;
	    tx2.encode();
            Print("fourth encoded tuple inserted");
            out(tx2,self) ;

        } catch (Exception e2) {
          Print("problems when encoding with key 4");
          e2.printStackTrace ();
        }
    }
}

class LocalInFailureProc2 extends KlavaProcessx {

    protected Locality dati = new LogicalLocality("self");

    public LocalInFailureProc2() throws Exception {
	super (new KStoreFileAccess("LocalInFailure2.answers"));
	//super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
        try {
            KString fString1 = new KString() ;
            KString s1 = new KString() ;
            Tuplex txf1 = new Tuplex() ;
            txf1.add( s1 ) ;
            KCipher k = new KCipher( fString1 ) ;
            txf1.add( k ) ;

            Print("in of an encoded tuple");
	    in(txf1, dati) ;
            Print("retrieved tuple: " + txf1) ;
            Print("s1 field is " + s1);
            Print("fString field is " + fString1);

	    out(txf1);
	    out(s1,self);
            out(fString1,self);
	} catch (Exception e) {
          Print("problems during retrieving");
          e.printStackTrace ();
        }
    }
}

public class LocalInFailure extends KlavaTestApplication {
  public LocalInFailure(String name, String suffix,
                      boolean log_to_file)
      throws Exception {
    super(name, suffix, log_to_file);

    Node Node1 = new Node ("node1", 9998, "localhost", 9999 );

    Node1.addToEnv("dati", 9998);
    Node1.setLocalMatcher (new KCipherLocalMatcher ());
    Node1.setLocalTupleSpaceMatcher
    (new KCipherLocalTupleSpaceMatcher ());
    Node1.start();
    Node1.waitToBeConnected();

    addProcessToNode(new LocalInFailureProc1(), Node1);
    addProcessToNode(new LocalInFailureProc2(), Node1);
  }

  static public void main  (String args[]) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new LocalInFailure
      ("LocalInFailure", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.waitForProcessesAndTerminate();
  }
}