/**
 * RemoteFailure
 *
 * retrieves a tuple crypted with a different key from a remote site
 */

package test_crypto;

import java.io.* ;
import Klava.* ;
import Klava.crypto.*;
import javax.crypto.* ;
import javax.crypto.spec.* ;

class RemoteFailureProc1 extends KlavaProcessx {

  public RemoteFailureProc1() throws Exception {
	super (new KStoreFileAccess("RemoteFailure1.answers"));
	//super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
        try {
	    setEncKey("1") ;
	    Tuplex tx1 = new Tuplex() ;
            tx1.add(new KString("lorenzo")) ;
            KString s1 = new KString("chiave des1") ;
            tx1.add(new KCipher(s1)) ;
	    tx1.encode();
            Print("encoded with key 1");
            out(tx1,self) ;

	    setEncKey("2");
	    Tuplex tx2 = new Tuplex() ;
            tx2.add(new KString("bettini")) ;
            KString s2 = new KString("chiave des2") ;
            tx2.add(new KCipher(s2)) ;
	    tx2.encode();
            Print("encoded with key 2");
            out(tx2,self) ;
	    unsetEncKey();
        } catch (Exception e) {
          Print("problems while encoding");
          e.printStackTrace ();
        }
    }
}

class RemoteFailureProc2 extends KlavaProcessx {

    protected Locality dati = new LogicalLocality("data");

    public RemoteFailureProc2() throws Exception {
	super (new KStoreFileAccess("RemoteFailure2.answers"));
	//super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
        try {
	    KString fString1 = new KString() ;
            KString s1 = new KString() ;
            Tuplex txf1 = new Tuplex() ;
            txf1.add( s1 ) ;
            KCipher k = new KCipher( fString1 ) ;
            txf1.add( k ) ;

            Print("read of an encoded tuple");
            read(txf1, dati) ;
            Print("retrieved tuple: " + txf1) ;
            Print("s1 field is " + s1);
            Print("fString field is " + fString1);

	    out(s1,self);
	    out(fString1,self);
	} catch (Exception e) {
            e.printStackTrace ();
        }
    }
}

public class RemoteFailure extends KlavaTestApplication {
  public RemoteFailure(String name, String suffix,
                      boolean log_to_file)
      throws Exception {
    super(name, suffix, log_to_file);

    Node Node1 = new Node ("node1", 9990, "localhost", 9999 );
    Node Node2 = new Node ("node2", 9980, "localhost", 9999 );

    Node1.setLocalMatcher (new KCipherLocalMatcher ());
    Node1.setLocalTupleSpaceMatcher
        (new KCipherLocalTupleSpaceMatcher ());
    Node1.start();
    Node1.waitToBeConnected();

    addProcessToNode (new RemoteFailureProc1(), Node1);

    Node2.setLocalMatcher (new KCipherLocalMatcher ());
    Node2.setLocalTupleSpaceMatcher
        (new KCipherLocalTupleSpaceMatcher ());
    Node2.addToEnv("data", 9990);
    Node2.start ();
    Node2.waitToBeConnected();

    addProcessToNode (new RemoteFailureProc2(), Node2);
  }

  static public void main  (String args[]) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new RemoteFailure
      ("RemoteFailure", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.waitForProcessesAndTerminate();
  }
}
