/**
 * RemoteInFailure
 *
 * retrieves a tuple crypted with a different key, using an in
 */

package test_crypto;

import java.io.* ;
import Klava.* ;
import Klava.crypto.*;
import javax.crypto.* ;
import javax.crypto.spec.* ;

class RemoteInFailureProc1 extends KlavaProcessx {

   public RemoteInFailureProc1() throws Exception {
       super (new KStoreFileAccess("RemoteInFailure1.answers"));
       //super (new KStoreDialogAccess());
   }

    public void execute() throws KlavaException {
        try {
	    setEncKey("1 3 4");
            Tuplex tx1 = new Tuplex() ;
            tx1.add(new KString("lorenzo")) ;
            KString s = new KString("chiave des1") ;
            tx1.add(new KCipher(s) ) ;
	    tx1.encode();
            out(tx1,self) ;
            Print("first encoded tuple inserted");

            Tuplex tx3 = new Tuplex() ;
            tx3.add(new KString("lorenzo 2")) ;
            KString s3 = new KString("chiave des1") ;
            tx3.add(new KCipher(s3) ) ;
	    tx3.encode();
            out(tx3,self) ;
            Print("second encoded tuple inserted");

            Tuplex tx4 = new Tuplex() ;
            tx4.add(new KString("lorenzo 3")) ;
            KString s4 = new KString("chiave des1") ;
            tx4.add(new KCipher(s4) ) ;
	    tx4.encode();
            out(tx4,self) ;
            Print("third encoded tuple inserted");
	} catch (Exception e) {
          Print("Problems while encoding with keys 1 3 4");
          e.printStackTrace ();
        }
	try {
	    setEncKey("2");
	    Tuplex tx2 = new Tuplex() ;
            tx2.add(new KString("bettini")) ;
            KString s2 = new KString("chiave des2") ;
            tx2.add(new KCipher(s2) ) ;
	    tx2.encode();
            out(tx2,self) ;
            Print("fourth encoded tuple inserted");
	    unsetEncKey();
        } catch (Exception e) {
          Print("Problems while encoding with key 2");
          e.printStackTrace ();
        }
    }
}

class RemoteInFailureProc2 extends KlavaProcessx {

    protected Locality dati = new LogicalLocality("data");

    public RemoteInFailureProc2() throws Exception {
	super (new KStoreFileAccess("RemoteInFailure2.answers"));
	//super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
	try {
	    setDecKey("decifratura1");
            KString fString1 = new KString() ;
            KString s1 = new KString() ;
            Tuplex txf1 = new Tuplex() ;
            txf1.add( s1 ) ;
	    KCipher k1 = new KCipher( fString1 ) ;
	    txf1.add( k1 ) ;

            Print("in of an encoded tuple");
            in(txf1, dati) ;
            Print("retrieved tuple: " + txf1) ;
            Print("s1 field is " + s1);
            Print("fString field is " + fString1);

            out(s1, self) ;
            out(fString1,self);
	    out(txf1,self);
	} catch (Exception e) {
            e.printStackTrace ();
        }
	/*
	try {
	    setDecKey("decifratura2");
            KString fString2 = new KString() ;
            KString s2 = new KString() ;
            Tuplex txf2 = new Tuplex() ;
            txf2.add( s2 ) ;
            KCipher k2 = new KCipher( fString2 ) ;
            txf2.add( k2 ) ;

            in(txf2, dati) ;

            out(s2, self) ;
            out(fString2,self);
	} catch (Exception e) {
            e.printStackTrace ();
	    }*/
    }
}

public class RemoteInFailure extends KlavaTestApplication {
  public RemoteInFailure(String name, String suffix,
                      boolean log_to_file)
      throws Exception {
    super(name, suffix, log_to_file);

    Node Node1 = new Node ("node1", 9990, "localhost", 9999 );
    Node Node2 = new Node ("node2", 9980, "localhost", 9999 );

    Node1.setLocalMatcher (new KCipherLocalMatcher ());
    Node1.setLocalTupleSpaceMatcher
        (new KCipherLocalTupleSpaceMatcher ());
    Node1.start();
    Node1.waitToBeConnected();

    addProcessToNode (new RemoteInFailureProc1(), Node1);

    Node2.setLocalMatcher (new KCipherLocalMatcher ());
    Node2.setLocalTupleSpaceMatcher
        (new KCipherLocalTupleSpaceMatcher ());
    Node2.addToEnv("data", 9990);
    Node2.start ();
    Node2.waitToBeConnected();

    addProcessToNode (new RemoteInFailureProc2(), Node2);
  }

  static public void main  (String args[]) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new RemoteInFailure
      ("RemoteInFailure", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.waitForProcessesAndTerminate();
  }
}
