/**
 * RemoteInkFailure
 *
 * retrieves a tuple crypted with a different key, using an ink
 * without KCipherMatcher setted.
 * DialogAccess is used for decription to highlight the exception handling
 */

package test_crypto;

import java.io.* ;
import Klava.* ;
import Klava.crypto.*;
import javax.crypto.* ;
import javax.crypto.spec.* ;

class RemoteInkFailureProc1 extends KlavaProcessx {

   public RemoteInkFailureProc1() throws Exception {
       super (new KStoreFileAccess("RemoteInFailure1.answers"));
       //super (new KStoreDialogAccess());
   }

    public void execute() throws KlavaException {
        try {
	    setEncKey("1 3 4");
            Tuplex tx1 = new Tuplex() ;
            tx1.add(new KString("daniele")) ;
            KString s = new KString("chiave des1") ;
            tx1.add(new KCipher(s) ) ;
	    tx1.encode();
            out(tx1,self) ;
            Print("first encoded tuple inserted");

            Tuplex tx3 = new Tuplex() ;
            tx3.add(new KString("daniele 2")) ;
            KString s3 = new KString("chiave des1") ;
            tx3.add(new KCipher(s3) ) ;
	    tx3.encode();
            out(tx3,self) ;
            Print("second encoded tuple inserted");

            Tuplex tx4 = new Tuplex() ;
            tx4.add(new KString("daniele 3")) ;
            KString s4 = new KString("chiave des1") ;
            tx4.add(new KCipher(s4) ) ;
	    tx4.encode();
            out(tx4,self) ;
            Print("third encoded tuple inserted");
	} catch (Exception e) {
          Print("problems while encoding with keys 1 3 4");
          e.printStackTrace ();
        }
	try {
	    setEncKey("2");
	    Tuplex tx2 = new Tuplex() ;
            tx2.add(new KString("becchi")) ;
            KString s2 = new KString("chiave des2") ;
            tx2.add(new KCipher(s2) ) ;
	    tx2.encode();
            out(tx2,self) ;
            Print("fourth encoded tuple inserted");
	    unsetEncKey();
        } catch (Exception e) {
          Print("problems while encoding with key 2");
          e.printStackTrace ();
        }
    }
}

class RemoteInkFailureProc2 extends KlavaProcessx {

    protected Locality dati = new LogicalLocality("data");

    public RemoteInkFailureProc2() throws Exception {
	super (new KStoreFileAccess("RemoteInkFailure2.answers"));
	//super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
	try {
	    //setDecKey("decifratura");
            KString fString1 = new KString() ;
            KString s1 = new KString() ;
            Tuplex txf1 = new Tuplex() ;
            txf1.add( s1 ) ;
	    KCipher k1 = new KCipher( fString1 ) ;
	    txf1.add( k1 ) ;

            Print("in of an encoded tuple");
            ink(txf1, dati ) ;
            Print("retrieved tuple: " + txf1) ;
            Print("s1 field is " + s1);
            Print("fString field is " + fString1);

            out(s1, self) ;
            out(fString1,self);
	    out(txf1,self);
	} catch (Exception e) {
            e.printStackTrace ();
        }
    }
}

public class RemoteInkFailure extends KlavaTestApplication {
  public RemoteInkFailure(String name, String suffix,
                          boolean log_to_file)
      throws Exception {
    super(name, suffix, log_to_file);

    Node Node1 = new Node ("node1", 9990, "localhost", 9999 );
    Node Node2 = new Node ("node2", 9980, "localhost", 9999 );

    Node1.start();
    Node1.waitToBeConnected();

    addProcessToNode (new RemoteInkFailureProc1(), Node1);

    Node2.addToEnv("data", 9990);
    Node2.start ();
    Node2.waitToBeConnected();

    addProcessToNode (new RemoteInkFailureProc2(), Node2);
  }

  static public void main  (String args[]) throws Exception {
    boolean log_to_file = args.length > 0;

    if (log_to_file)
      (new Net()).start();

    KlavaTestApplication app = new RemoteInkFailure
      ("RemoteInkFailure", (args.length > 1 ? args[1] : ""),
        args.length > 0);
    app.waitForProcessesAndTerminate();
  }
}
