/**
 * TryEx
 *
 * retrieves tuplex from node without KCipherMatcher
 * The tuples are decoded manually 
 * The exception handled in encoding and decoding
 */
package test_crypto;

import java.io.* ;
import Klava.* ;
import Klava.crypto.*;

class TryExProc1 extends KlavaProcessx {

    public TryExProc1() throws Exception {
	super (new KStoreFileAccess("try1.answers"));
	//super (new KStoreDialogAccess());
    }

    public void execute() throws KlavaException {
	Tuplex tx1 = new Tuplex() ;
	tx1.add(new KString("daniele1")) ;
	KString s = new KString("usata chiave1") ;
	tx1.add(new KCipher(s)) ;
	boolean badkey = true ;
	while ( badkey ) {
	    try {
		tx1.encode();
		out(tx1,self) ;
		badkey = false ;
	    } catch (java.security.InvalidKeyException e1) {
		//e1.printStackTrace ();
		System.err.println("InvalidKeyException") ;
	    } catch (java.security.UnrecoverableKeyException e2) {
		//e2.printStackTrace ();
		System.err.println("UnrecoverableKeyException") ;
	    } catch ( Exception e3 ) {
		e3.printStackTrace ();
		badkey = false ;
	    }
	}
	Tuplex tx2 = new Tuplex() ;
	tx2.add(new KString("daniele2")) ;
	KInteger i = new KInteger(2) ;
	tx2.add(new KCipher(i)) ;
	badkey = true ;
	while ( badkey ) {
	    try {
		tx2.encode();
		out(tx2,self) ;
		badkey = false ;
	    } catch (java.security.InvalidKeyException e1) {
		e1.printStackTrace ();
	    } catch (java.security.UnrecoverableKeyException e2) {
		e2.printStackTrace ();
	    } catch ( Exception e3 ) {
		e3.printStackTrace ();
		badkey = false ;
	    }
	}
    }
}

class TryExProc2 extends KlavaProcessx {

    protected Locality dati = new LogicalLocality("self");

    public TryExProc2() throws Exception {
	//super (new KStoreFileAccess("try2.answers"));
	super (new KStoreDialogAccess());
    }
    
    public void execute() throws KlavaException {
       
	Tuplex txf1 = new Tuplex() ;
	KString s1 = new KString() ;
	txf1.add( s1 ) ;
	KInteger fString1 = new KInteger() ;
	KCipher k = new KCipher( fString1 ) ;
	txf1.add( k ) ;
	in(txf1, dati) ;
	boolean done = false ;
	while ( ! done ) {
	    try {
		if ( txf1.decode() ) {
		    out( s1, self ) ;
		    out( fString1, self ); 
		    out( txf1 ) ;
		    done = true ;
		} else {
		    out( txf1 ) ;
		    txf1.resetOriginalTemplate() ;
		    in( txf1, dati ) ;
		}
	    } catch (java.security.InvalidKeyException e1) {
		e1.printStackTrace ();
	    } catch (java.security.UnrecoverableKeyException e2) {
		e2.printStackTrace ();
	    } catch (javax.crypto.BadPaddingException e3) {
		e3.printStackTrace ();
	    } catch ( Exception e ) {
		e.printStackTrace ();
		done = true ;
	    }
	}
    }
}

public class TryEx {
    static public void main  (String args[]) throws Exception {
        Node Node1 = new NodeG ("node1", "loc1", "localhost", 9999 );
    	Node1.start();
	Node1.addProcess (new TryExProc1());
	Node1.addProcess (new TryExProc2());
    }
}
