/*
	File ChatClient.java

	Originally generated by xklaim compiler
	Added private ciphered messages
	This version uses ink instead of KCipherMatcher

*/

package test_crypto.chat;

import java.io.* ;
import Klava.* ;
import Klava.crypto.* ;

class HandleServerKeyboard extends KlavaProcess {

  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality serverKeyb = new LogicalLocality( "serverKeyb" ) ;
  protected KString command ;
  protected KString nickname ;
  protected KBoolean response ;
  protected TupleSpace userList ;
  protected UpdateUserList dummyUpdateUserList ;

  public HandleServerKeyboard(  ) {
  }

  public void execute() throws KlavaException {
    while ( (true) ) {
      command = new KString() ;
      nickname = new KString() ;
      in( command, nickname, serverKeyb ) ;
      if ( (! command.equals( "ENTER" )&&! command.equals( "LEAVE" )) ) {
        out( new KString( "Unknown command: " ), screen ) ;
        out( command, screen ) ;
      } else {
        out( new KString( "SERVER" ), command, nickname, self, server ) ;
        response = new KBoolean() ;
        try {
          in( response, self, 10000 ) ;
          if ( (response.booleanValue()!=true) ) {
            out( new KString( "Failed command: " ), screen ) ;
          } else {
            out( new KString( "Succeeded command: " ), screen ) ;
            if ( (command.equals( "ENTER" )) ) {
              userList = new TupleSpace() ;
              in( userList, self ) ;
              procCall( new UpdateUserList( userList ) ) ;
            }
          }
        } catch ( KlavaTimeOutException __e1__ ) {
          out( new KString( "TimeOut for command: " ), screen ) ;
        }
        out( command, nickname, screen ) ;
      }
    }
  }
}

class HandleMessageKeyboardk extends KlavaProcessx/****/ {

  protected KString ID = new KString( "messageKeyboard" ) ;
  protected KString message ;
  protected KString selected ;
  protected TupleSpace selectedUsers ;
  protected Locality messageKeyb = new LogicalLocality( "messageKeyb" ) ;
  protected Locality usersList = new LogicalLocality( "usersList" ) ;
  protected Locality server = new LogicalLocality( "server" ) ;

    public HandleMessageKeyboardk(  ) /**/ throws Exception/**/ {
	/**/super (new KStoreDialogAccess());/**/
  }

  public void execute() throws KlavaException {
    while ( (true) ) {
      message = new KString() ;
      in( message, messageKeyb ) ;
      out( new KString( "command" ), new KString( "getSelectedItem" ),
           ID, usersList ) ;
      selected = new KString() ;
      in( new KString( "command" ), new KString( "getSelectedItem" ),
          ID, selected, usersList ) ;
      if ( (! selected.equals( "" )) ) {
        selectedUsers = new TupleSpace() ;
        Tuple _Tuple_1 = new Tuple() ;
        _Tuple_1.add( selected ) ;
        selectedUsers.out( _Tuple_1 ) ;
	/***********/
	try {
	    setEncKey("Encrypting message: "+ message) ;
	    Tuplex t = new Tuplex() ;
	    KCipher cryptMessage = new KCipher( message ) ;
	    t.add( new KString( "PERSONAL" ) );
	    t.add( cryptMessage ) ;
	    t.add( selectedUsers ) ;
	    t.add( self ) ;
	    t.encode();
	    out( t, server ) ;
	}  catch (Exception e) {
	    e.printStackTrace () ;
	} finally {
	    unsetEncKey() ;
	}
	/***********/
        //out( new KString( "PERSONAL" ), message, selectedUsers, self, server ) ;
      } else {
        out( new KString( "command" ), new KString( "getSelectedItems" ),
             ID, usersList ) ;
        selectedUsers = new TupleSpace() ;
        in( new KString( "command" ), new KString( "getSelectedItems" ),
            ID, selectedUsers, usersList ) ;
        selected = new KString() ;
        try {
          Tuple _Tuple_2 = new Tuple() ;
          _Tuple_2.add( selected ) ;
          selectedUsers.read( _Tuple_2, 0 ) ;
	  /************/
	  try {
	      Tuplex t = new Tuplex() ;
	      KCipher cryptMessage = new KCipher( message ) ;
	      t.add( new KString( "PERSONAL" ) );
	      t.add( cryptMessage ) ;
	      t.add( selectedUsers ) ;
	      t.add( self ) ;
	      t.encode() ;
	      out( t, server ) ;
	  }  catch (Exception e) {
	      e.printStackTrace ();
	  }
	  /************/
          //out( new KString( "PERSONAL" ), message, selectedUsers, self, server ) ;
        } catch ( KlavaTimeOutException __e2__ ) {
	    out( new KString( "MESSAGE" ), message, self, server ) ;
        }
      }
    }
  }
}

class HandleMessagesk extends KlavaProcessx {

  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality serverKeyb = new LogicalLocality( "serverKeyb" ) ;
  protected KString message ;
  protected KString from ;
  protected HandlePublicMessagesk dummyHandlePublicMessages ;
  protected HandlePersonalMessagesk dummyHandlePersonalMessages ;

    public HandleMessagesk(  ) /**/throws Exception/****/ {
      /**/super (new KStoreDialogAccess());/**/
  }

  public void execute() throws KlavaException {
      try {
	  /*while ( (true) ) {
	    or( new HandlePublicMessages( message, from, screen ), new HandlePersonalMessages( message, from, screen, myKeyStore ) ) ;
	    }*/
	  eval( new HandlePublicMessagesk( message, from, screen ) );
	  eval( new HandlePersonalMessagesk( message, from, screen, myKeyStore ) );
      }  catch (Exception e) {
	  e.printStackTrace ();
      }
  }

  class HandlePublicMessagesk extends KlavaProcess {

    protected KString message ;
    protected KString from ;
    protected Locality screen = new LogicalLocality( "screen" ) ;

    public HandlePublicMessagesk( KString message, KString from, Locality screen ) {
      this.message = message ;
      this.from = from ;
      this.screen = screen ;
    }

    public void execute() throws KlavaException {
	while (true) {
	    message = new KString() ;
	    from = new KString() ;
	    in( new KString( "MESSAGE" ), message, from, self ) ;
	    out( new KString( "(" ), screen ) ;
	    out( from, screen ) ;
	    out( new KString( ") " ), screen ) ;
	    out( message, screen ) ;
	    out( new KString( "\n" ), screen ) ;
	}
    }
  }

  class HandlePersonalMessagesk extends KlavaProcessx /**  **/ {

    protected KString message ;
    protected KString from ;
    protected Locality screen = new LogicalLocality( "screen" ) ;

    public HandlePersonalMessagesk( KString message, KString from, Locality screen, KStore myKeyStore)
	/**/throws Exception/**/ {

      this.message = message ;
      this.from = from ;
      this.screen = screen ;
      this.myKeyStore = myKeyStore ;
    }

    public void execute() throws KlavaException {
	while (true) {
	    message = new KString() ;
	    from = new KString() ;
	    /*********/
	    KCipher cryptMessage = new KCipher( message ) ;
	    Tuplex t = new Tuplex() ;
	    t.add(new KString( "PERSONAL" ) ) ;
	    t.add( cryptMessage ) ;
	    t.add( from ) ;
	    System.err.println("*********** ink ************");
	    ink( t, self ) ;
	    /*********/
	    //in( (new KString( "PERSONAL" ), message, from, self ) ;
	    out( new KString( "PERSONAL " ), screen ) ;
	    out( new KString( "(" ), screen ) ;
	    out( from, screen ) ;
	    out( new KString( ") " ), screen ) ;
	    out( cryptMessage, screen ) ;
	    out( new KString( "\n" ), screen ) ;
	}
    }
  }
}

class HandleServerMessages extends KlavaProcess {

  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality serverKeyb = new LogicalLocality( "serverKeyb" ) ;
  protected Locality usersList = new LogicalLocality( "usersList" ) ;
  protected KString nickname ;
  protected KString from ;
  protected ChatClient_P_n21 dummyChatClient_P_n21 ;
  protected ChatClient_P_n22 dummyChatClient_P_n22 ;

  public HandleServerMessages(  ) {
  }

  public void execute() throws KlavaException {
    while ( (true) ) {
      or( new ChatClient_P_n21( nickname, from, screen, usersList ), new ChatClient_P_n22( nickname, from, screen, usersList ) ) ;
    }
  }

  class ChatClient_P_n21 extends KlavaProcess {

    protected KString nickname ;
    protected KString from ;
    protected Locality screen = new LogicalLocality( "screen" ) ;
    protected Locality usersList = new LogicalLocality( "usersList" ) ;

    public ChatClient_P_n21( KString nickname, KString from, Locality screen, Locality usersList ) {
      this.nickname = nickname ;
      this.from = from ;
      this.screen = screen ;
      this.usersList = usersList ;
    }

    public void execute() throws KlavaException {
      nickname = new KString() ;
      from = new KString() ;
      in( new KString( "ENTER" ), nickname, from, self ) ;
      out( nickname, screen ) ;
      out( new KString( " entered chat\n" ), screen ) ;
      out( nickname, usersList ) ;
    }
  }

  class ChatClient_P_n22 extends KlavaProcess {

    protected KString nickname ;
    protected KString from ;
    protected Locality screen = new LogicalLocality( "screen" ) ;
    protected Locality usersList = new LogicalLocality( "usersList" ) ;

    public ChatClient_P_n22( KString nickname, KString from, Locality screen, Locality usersList ) {
      this.nickname = nickname ;
      this.from = from ;
      this.screen = screen ;
      this.usersList = usersList ;
    }

    public void execute() throws KlavaException {
      nickname = new KString() ;
      from = new KString() ;
      in( new KString( "LEAVE" ), nickname, from, self ) ;
      out( nickname, screen ) ;
      out( new KString( " left chat\n" ), screen ) ;
      in( nickname, usersList ) ;
    }
  }
}

class UpdateUserList extends KlavaProcess {

  protected KBoolean again ;
  protected KString nickname ;
  protected Locality usersList = new LogicalLocality( "usersList" ) ;
  protected TupleSpace list ;

  public UpdateUserList( TupleSpace list ) {
    this.list = list ;
  }

  public void execute() throws KlavaException {
    again = new KBoolean( true ) ;
    while ( (again.booleanValue()) ) {
      nickname = new KString() ;
      try {
        Tuple _Tuple_3 = new Tuple() ;
        _Tuple_3.add( nickname ) ;
        list.in( _Tuple_3, 0 ) ;
        out( nickname, usersList ) ;
      } catch ( KlavaTimeOutException __e3__ ) {
        again = new KBoolean( false ) ;
      }
    }
  }
}

class startClientk extends KlavaProcess {
  protected HandleServerKeyboard dummyHandleServerKeyboard ;
  protected HandleMessageKeyboardk dummyHandleMessageKeyboard ;
  protected HandleMessagesk dummyHandleMessages ;
  protected HandleServerMessages dummyHandleServerMessages ;

  public startClientk(  ) {
  }

    public void execute() throws KlavaException {
	/**try-catch**/
	try {
	    eval( new HandleServerKeyboard(  ), self ) ;
	    eval( new HandleMessageKeyboardk(  ), self ) ;
	    eval( new HandleMessagesk(  ), self ) ;
	    eval( new HandleServerMessages(  ), self ) ;
	} catch (Exception e) {
            e.printStackTrace ();
        }
  }
}

// processes of node ChatClient1
class ChatClientk_1 extends KlavaProcess {

  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality messageKeyb = new LogicalLocality( "messageKeyb" ) ;
  protected Locality serverKeyb = new LogicalLocality( "serverKeyb" ) ;
  protected Locality usersList = new LogicalLocality( "usersList" ) ;
  protected startClientk dummystartClient ;

  public ChatClientk_1(  ) {
  }

  public void execute() throws KlavaException {
    eval( new startClientk(  ), self ) ;
  }
}

// processes of node ChatClient2
class ChatClientk_2 extends KlavaProcess {

  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality messageKeyb = new LogicalLocality( "messageKeyb" ) ;
  protected Locality serverKeyb = new LogicalLocality( "serverKeyb" ) ;
  protected Locality usersList = new LogicalLocality( "usersList" ) ;
  protected startClientk dummystartClient ;

  public ChatClientk_2(  ) {
  }

  public void execute() throws KlavaException {
    eval( new startClientk(  ), self ) ;
  }
}

// processes of node ChatClient3
class ChatClientk_3 extends KlavaProcess {

  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality messageKeyb = new LogicalLocality( "messageKeyb" ) ;
  protected Locality serverKeyb = new LogicalLocality( "serverKeyb" ) ;
  protected Locality usersList = new LogicalLocality( "usersList" ) ;
  protected startClientk dummystartClient ;

  public ChatClientk_3(  ) {
  }

  public void execute() throws KlavaException {
    eval( new startClientk(  ), self ) ;
  }
}

// main class
public class ChatClient {
  static public void main( String args[] ) throws Exception {
    Node ChatClient1 = new ChatClientNode( "ChatClient1", "ChatClient1", args[0], Integer.parseInt( args[1] ) ) ;
    ChatClient1.addToEnv( "server", "ChatServer" ) ;
    ChatClient1.addToEnv( "screen", "ChatClient1_screen" ) ;
    ChatClient1.addToEnv( "messageKeyb", "ChatClient1_messageKeyb" ) ;
    ChatClient1.addToEnv( "serverKeyb", "ChatClient1_serverKeyb" ) ;
    ChatClient1.addToEnv( "usersList", "ChatClient1_usersList" ) ;
    ChatClient1.start() ;
    ChatClient1.addProcess( new ChatClientk_1() ) ;
    Node ChatClient2 = new ChatClientNode( "ChatClient2", "ChatClient2", args[0], Integer.parseInt( args[1] ) ) ;
    ChatClient2.addToEnv( "server", "ChatServer" ) ;
    ChatClient2.addToEnv( "screen", "ChatClient2_screen" ) ;
    ChatClient2.addToEnv( "messageKeyb", "ChatClient2_messageKeyb" ) ;
    ChatClient2.addToEnv( "serverKeyb", "ChatClient2_serverKeyb" ) ;
    ChatClient2.addToEnv( "usersList", "ChatClient2_usersList" ) ;
    ChatClient2.start() ;
    ChatClient2.addProcess( new ChatClientk_2() ) ;
    Node ChatClient3 = new ChatClientNode( "ChatClient3", "ChatClient3", args[0], Integer.parseInt( args[1] ) ) ;
    ChatClient3.addToEnv( "server", "ChatServer" ) ;
    ChatClient3.addToEnv( "screen", "ChatClient3_screen" ) ;
    ChatClient3.addToEnv( "messageKeyb", "ChatClient3_messageKeyb" ) ;
    ChatClient3.addToEnv( "serverKeyb", "ChatClient3_serverKeyb" ) ;
    ChatClient3.addToEnv( "usersList", "ChatClient3_usersList" ) ;
    ChatClient3.start() ;
    ChatClient3.addProcess( new ChatClientk_3() ) ;
  }
}

// end of file ChatClient.java
