package test_crypto.chat;

import Klava.* ;

import java.io.* ;
import java.awt.* ;

public class ChatClientNode extends Node {
    protected KlavaFrame nodeFrame ;
    protected ChatClientPanel chatPanel ;
    protected NodeScreen screenNode ;
    protected NodeKeyboard messageKeyb, serverKeyb ;
    protected NodeList usersNode ;

    public ChatClientNode( String Name, String Here, String NetHostName, int NetPort )
        throws IOException {
        super( Name, Here, NetHostName, NetPort ) ;
        nodeFrame = new KlavaFrame( Name ) ;
        nodeFrame.setNode( this ) ;
        chatPanel = new ChatClientPanel() ;

        messageKeyb = new NodeKeyboard( "message",
                                     Here + "_messageKeyb", NetHostName, NetPort ) ;
        serverKeyb = new NodeKeyboard( "server",
                                     Here + "_serverKeyb", NetHostName, NetPort ) ;

        screenNode = new NodeScreen( Name + " screen",
                                     Here + "_screen", NetHostName, NetPort ) ;
        usersNode = new NodeList( Name + " users",
                                     Here + "_usersList", NetHostName, NetPort ) ;
        chatPanel.addInputPanel( messageKeyb.getPanel() ) ;
        chatPanel.addInputPanel( serverKeyb.getPanel() ) ;
        chatPanel.addMessagePanel( screenNode.getPanel() ) ;
        chatPanel.addListPanel( usersNode.getPanel() ) ;
        nodeFrame.add( chatPanel ) ;
        screenNode.start() ;
        messageKeyb.start() ;
        serverKeyb.start() ;
        usersNode.start() ;
    }

    protected void show() {
        nodeFrame.pack() ;
        nodeFrame.show() ;
    }

    public static void main( String args[] ) throws IOException {
        if ( args.length < 4 || args.length > 5 )
            throw new IOException( "Syntax : Node <name> <physLocHere> <hostname> <port> {DirConnect}" ) ;

        ChatClientNode n = new ChatClientNode( args[0], args[1], args[2], Integer.parseInt( args[3] ) ) ;
        if ( args.length == 5 )
            n.setDirectConnections() ;
        n.addToEnv( "screen", args[1]+"_screen" ) ;
        n.addToEnv( "messageKeyb", args[1]+"_messageKeyb" ) ;
        n.addToEnv( "serverKeyb", args[1]+"_serverKeyb" ) ;
        n.addToEnv( "usersList", args[1]+"_usersList" ) ;
        n.start() ;
    }
}
