package test_crypto.chat;

import Klava.* ;
import java.io.* ;
import java.awt.BorderLayout ;

public class ChatServerNode extends Node {
    protected KlavaFrame nodeFrame ;
    protected NodeScreen screenNode ;
    protected NodeList usersNode ;
    protected LogicalLocality screen = new LogicalLocality( "screen" ) ;

    public ChatServerNode( String Name, String Here, String NetHostName, int NetPort )
	throws IOException {
	super( Name, Here, NetHostName, NetPort ) ;
	nodeFrame = new KlavaFrame( Name ) ;
	nodeFrame.setNode( this ) ;
	screenNode = new NodeScreen( Name + " screen",
				     Here + "_screen", NetHostName, NetPort ) ;
        usersNode = new NodeList( Name + " users",
				     Here + "_users", NetHostName, NetPort ) ;
	nodeFrame.add( screenNode.getPanel() ) ;
        nodeFrame.add( usersNode.getPanel(), BorderLayout.EAST ) ;
        screenNode.start() ;
        usersNode.start() ;
    }

    protected void show() {
	nodeFrame.pack() ;
	nodeFrame.show() ;
    }

    public static void main( String args[] ) throws IOException {
	if ( args.length < 4 || args.length > 5 )
	    throw new IOException( "Syntax : Node <name> <physLocHere> <hostname> <port> {DirConnect}" ) ;

	ChatServerNode n = new ChatServerNode( args[0], args[1], args[2], Integer.parseInt( args[3] ) ) ;
	if ( args.length == 5 )
	    n.setDirectConnections() ;
        n.addToEnv( "screen", "CharServer_screen" ) ;
        n.addToEnv( "users", "CharServer_users" ) ;
	n.start() ;
    }
}
