package cryptochat;

import Klava.* ;

import java.io.* ;
import java.awt.* ;

public class ChatClientNode extends Node {
    protected KlavaFrame nodeFrame ;
    protected ChatClientPanel chatPanel ;
    protected NodeScreen screenNode ;
    protected NodeKeyboard messageKeyb, serverKeyb ;
    protected NodeList usersNode ;

    public ChatClientNode( String Name, int Here, String NetHostName, int NetPort )
        throws IOException, KlavaException {
        super( Name, Here, NetHostName, NetPort ) ;
        nodeFrame = new KlavaFrame( Name ) ;
        nodeFrame.setNode( this ) ;
        chatPanel = new ChatClientPanel() ;

        screenNode =
            new NodeScreen( Name + " screen",
            NetUtils.createLocalNodeAddress(Here + 1), NetHostName, NetPort ) ;
        messageKeyb =
            new NodeKeyboard( "message",
            NetUtils.createLocalNodeAddress(Here + 2), NetHostName, NetPort ) ;
        serverKeyb =
            new NodeKeyboard( "server",
            NetUtils.createLocalNodeAddress(Here + 3), NetHostName, NetPort ) ;
        usersNode =
            new NodeList( Name + " users",
            NetUtils.createLocalNodeAddress(Here + 4), NetHostName, NetPort ) ;
        chatPanel.addInputPanel( messageKeyb.getPanel() ) ;
        chatPanel.addInputPanel( serverKeyb.getPanel() ) ;
        chatPanel.addMessagePanel( screenNode.getPanel() ) ;
        chatPanel.addListPanel( usersNode.getPanel() ) ;
        nodeFrame.add( chatPanel ) ;
        screenNode.start() ;
        messageKeyb.start() ;
        serverKeyb.start() ;
        usersNode.start() ;
    }

    protected void show() {
        nodeFrame.pack() ;
        nodeFrame.show() ;
    }

    public static void main( String args[] ) throws IOException, KlavaException {
        if ( args.length < 4 || args.length > 5 )
            throw new IOException( "Syntax : Node <name> <localport> <hostname> <port> {DirConnect}" ) ;

        int port = Integer.parseInt(args[1]);
        ChatClientNode n =
            new ChatClientNode( args[0], port, args[2],
            Integer.parseInt( args[3] ) ) ;
        if ( args.length == 5 )
            n.setDirectConnections() ;
        n.addToEnv( "screen", port + 1 ) ;
        n.addToEnv( "messageKeyb", port + 2 ) ;
        n.addToEnv( "serverKeyb", port + 3 ) ;
        n.addToEnv( "usersList", port + 4 ) ;
        n.start() ;
    }
}
