package cryptochat;

/*
        File ChatClient.java

        Originally generated by xklaim compiler
        Added private ciphered messages
        This version uses ink instead of KCipherMatcher

*/

import java.io.* ;
import Klava.* ;
import Klava.crypto.* ;

class HandleServerKeyboard extends KlavaProcess {

  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality serverKeyb = new LogicalLocality( "serverKeyb" ) ;
  protected KString command ;
  protected KString nickname ;
  protected KBoolean response ;
  protected TupleSpace userList ;
  protected UpdateUserList dummyUpdateUserList ;

  public HandleServerKeyboard(  ) {
  }

  public void execute() throws KlavaException {
    while ( (true) ) {
      command = new KString() ;
      nickname = new KString() ;
      in( command, nickname, serverKeyb ) ;
      if ( (! command.equals( "ENTER" )&&! command.equals( "LEAVE" )) ) {
        out( new KString( "Unknown command: " ), screen ) ;
        out( command, screen ) ;
      } else {
        out( new KString( "SERVER" ), command, nickname, self, server ) ;
        response = new KBoolean() ;
        try {
          in( response, self, 10000 ) ;
          if ( (response.booleanValue()!=true) ) {
            out( new KString( "Failed command: " ), screen ) ;
          } else {
            out( new KString( "Succeeded command: " ), screen ) ;
            if ( (command.equals( "ENTER" )) ) {
              userList = new TupleSpace() ;
              in( userList, self ) ;
              procCall( new UpdateUserList( userList ) ) ;
            }
          }
        } catch ( KlavaTimeOutException __e1__ ) {
          out( new KString( "TimeOut for command: " ), screen ) ;
        }
        out( command, nickname, screen ) ;
      }
    }
  }
}

class HandleMessageKeyboardk extends KlavaProcessx/****/ {

  protected KString ID = new KString( "messageKeyboard" ) ;
  protected KString message ;
  protected KString selected ;
  protected TupleSpace selectedUsers ;
  protected Locality messageKeyb = new LogicalLocality( "messageKeyb" ) ;
  protected Locality usersList = new LogicalLocality( "usersList" ) ;
  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;

  public HandleMessageKeyboardk(  ) throws Exception {
  }

  protected KCipher encrypt_message(KString message) throws KlavaException {
    KCipher cryptMessage = null;
    try {
      setEncKey("encrypting message: "+ message) ;
      cryptMessage = new KCipher( message ) ;
    } catch (Exception e) {
      out(new KString("encryption failed (wrong password?) for " + message),
          screen);
      e.printStackTrace () ;
    }
    return cryptMessage;
  }

  protected void send_encrypted(Tuplex t) throws KlavaException {
    try {
      t.encode();
    } catch (Exception e) {
      e.printStackTrace();
      out(new KString("problems while encoding: " + e.getMessage()), screen);
      return;
    } finally {
      unsetEncKey() ;
    }
    out( t, server ) ;
  }

  public void execute() throws KlavaException {
    KString command = new KString("command");

    while ( (true) ) {
      message = new KString() ;
      in( message, messageKeyb ) ;
      out( command, new KString( "getSelectedItem" ), ID, usersList ) ;
      selected = new KString() ;
      in( command, new KString( "getSelectedItem" ), ID, selected, usersList ) ;
      if ( (! selected.equals( "" )) ) {
        selectedUsers = new TupleSpace() ;
        Tuple _Tuple_1 = new Tuple() ;
        _Tuple_1.add( selected ) ;
        selectedUsers.out( _Tuple_1 ) ;
        Tuplex t = new Tuplex() ;
        KCipher cryptMessage = encrypt_message( message ) ;
        if (cryptMessage == null)
          continue; // error has already been printed
        t.add( new KString( "PERSONAL" ) );
        t.add( cryptMessage ) ;
        t.add( selectedUsers ) ;
        t.add( self ) ;
        send_encrypted(t);
      } else {
        out( command, new KString( "getSelectedItems" ), ID, usersList ) ;
        selectedUsers = new TupleSpace() ;
        in( command, new KString( "getSelectedItems" ), ID,
            selectedUsers, usersList ) ;
        selected = new KString() ;
        try {
          Tuple _Tuple_2 = new Tuple() ;
          _Tuple_2.add( selected ) ;
          selectedUsers.read( _Tuple_2, 0 ) ;
          Tuplex t = new Tuplex() ;
          KCipher cryptMessage = encrypt_message( message ) ;
          if (cryptMessage == null)
            continue;
          t.add( new KString( "PERSONAL" ) );
          t.add( cryptMessage ) ;
          t.add( selectedUsers ) ;
          t.add( self ) ;
          send_encrypted(t);
        } catch ( KlavaTimeOutException __e2__ ) {
          out( new KString( "MESSAGE" ), message, self, server ) ;
        }
      }
    }
  }
}

class HandleMessagesk extends KlavaProcessx {

  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality serverKeyb = new LogicalLocality( "serverKeyb" ) ;
  protected KString message ;
  protected KString from ;
  protected HandlePublicMessagesk dummyHandlePublicMessages ;
  protected HandlePersonalMessagesk dummyHandlePersonalMessages ;

    public HandleMessagesk(  ) /**/throws Exception/****/ {
      /**/super (new KStoreDialogAccess());/**/
  }

  public void execute() throws KlavaException {
      try {
          eval( new HandlePublicMessagesk( message, from, screen ) );
          eval( new HandlePersonalMessagesk( message, from, screen, myKeyStore ) );
      }  catch (Exception e) {
          e.printStackTrace ();
      }
  }

  class HandlePublicMessagesk extends KlavaProcess {

    protected KString message ;
    protected KString from ;
    protected Locality screen = new LogicalLocality( "screen" ) ;

    public HandlePublicMessagesk( KString message, KString from, Locality screen ) {
      this.message = message ;
      this.from = from ;
      this.screen = screen ;
    }

    public void execute() throws KlavaException {
        while (true) {
            message = new KString() ;
            from = new KString() ;
            in( new KString( "MESSAGE" ), message, from, self ) ;
            out( new KString( "(" ), screen ) ;
            out( from, screen ) ;
            out( new KString( ") " ), screen ) ;
            out( message, screen ) ;
            out( new KString( "\n" ), screen ) ;
        }
    }
  }

  class HandlePersonalMessagesk extends KlavaProcessx /**  **/ {

    protected KString message ;
    protected KString from ;
    protected Locality screen = new LogicalLocality( "screen" ) ;

    public HandlePersonalMessagesk( KString message, KString from, Locality screen, KStore myKeyStore)
        /**/throws Exception/**/ {

      this.message = message ;
      this.from = from ;
      this.screen = screen ;
      this.myKeyStore = myKeyStore ;
    }

    public void execute() throws KlavaException {
        while (true) {
            message = new KString() ;
            from = new KString() ;
            /*********/
            KCipher cryptMessage = new KCipher( message ) ;
            Tuplex t = new Tuplex() ;
            t.add(new KString( "PERSONAL" ) ) ;
            t.add( cryptMessage ) ;
            t.add( from ) ;
            System.err.println("*********** ink ************");
            ink( t, self ) ;
            /*********/
            //in( (new KString( "PERSONAL" ), message, from, self ) ;
            out( new KString( "PERSONAL " ), screen ) ;
            out( new KString( "(" ), screen ) ;
            out( from, screen ) ;
            out( new KString( ") " ), screen ) ;
            out( cryptMessage, screen ) ;
            out( new KString( "\n" ), screen ) ;
        }
    }
  }
}

class HandleServerMessages extends KlavaProcess {

  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality serverKeyb = new LogicalLocality( "serverKeyb" ) ;
  protected Locality usersList = new LogicalLocality( "usersList" ) ;
  protected KString nickname ;
  protected KString from ;
  protected ChatClient_P_n21 dummyChatClient_P_n21 ;
  protected ChatClient_P_n22 dummyChatClient_P_n22 ;

  public HandleServerMessages(  ) {
  }

  public void execute() throws KlavaException {
    while ( (true) ) {
      or( new ChatClient_P_n21( nickname, from, screen, usersList ), new ChatClient_P_n22( nickname, from, screen, usersList ) ) ;
    }
  }

  class ChatClient_P_n21 extends KlavaProcess {

    protected KString nickname ;
    protected KString from ;
    protected Locality screen = new LogicalLocality( "screen" ) ;
    protected Locality usersList = new LogicalLocality( "usersList" ) ;

    public ChatClient_P_n21( KString nickname, KString from, Locality screen, Locality usersList ) {
      this.nickname = nickname ;
      this.from = from ;
      this.screen = screen ;
      this.usersList = usersList ;
    }

    public void execute() throws KlavaException {
      nickname = new KString() ;
      from = new KString() ;
      in( new KString( "ENTER" ), nickname, from, self ) ;
      out( nickname, screen ) ;
      out( new KString( " entered chat\n" ), screen ) ;
      out( nickname, usersList ) ;
    }
  }

  class ChatClient_P_n22 extends KlavaProcess {

    protected KString nickname ;
    protected KString from ;
    protected Locality screen = new LogicalLocality( "screen" ) ;
    protected Locality usersList = new LogicalLocality( "usersList" ) ;

    public ChatClient_P_n22( KString nickname, KString from, Locality screen, Locality usersList ) {
      this.nickname = nickname ;
      this.from = from ;
      this.screen = screen ;
      this.usersList = usersList ;
    }

    public void execute() throws KlavaException {
      nickname = new KString() ;
      from = new KString() ;
      in( new KString( "LEAVE" ), nickname, from, self ) ;
      out( nickname, screen ) ;
      out( new KString( " left chat\n" ), screen ) ;
      in( nickname, usersList ) ;
    }
  }
}

class UpdateUserList extends KlavaProcess {

  protected KBoolean again ;
  protected KString nickname ;
  protected Locality usersList = new LogicalLocality( "usersList" ) ;
  protected TupleSpace list ;

  public UpdateUserList( TupleSpace list ) {
    this.list = list ;
  }

  public void execute() throws KlavaException {
    again = new KBoolean( true ) ;
    while ( (again.booleanValue()) ) {
      nickname = new KString() ;
      try {
        Tuple _Tuple_3 = new Tuple() ;
        _Tuple_3.add( nickname ) ;
        list.in( _Tuple_3, 0 ) ;
        out( nickname, usersList ) ;
      } catch ( KlavaTimeOutException __e3__ ) {
        again = new KBoolean( false ) ;
      }
    }
  }
}

class startClientk extends KlavaProcess {
  protected HandleServerKeyboard dummyHandleServerKeyboard ;
  protected HandleMessageKeyboardk dummyHandleMessageKeyboard ;
  protected HandleMessagesk dummyHandleMessages ;
  protected HandleServerMessages dummyHandleServerMessages ;

  public startClientk(  ) {
  }

    public void execute() throws KlavaException {
        /**try-catch**/
        try {
            eval( new HandleServerKeyboard(  ), self ) ;
            eval( new HandleMessageKeyboardk(  ), self ) ;
            eval( new HandleMessagesk(  ), self ) ;
            eval( new HandleServerMessages(  ), self ) ;
        } catch (Exception e) {
            e.printStackTrace ();
        }
  }
}

// processes of node ChatClient1
class ChatClientk_1 extends KlavaProcess {

  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality messageKeyb = new LogicalLocality( "messageKeyb" ) ;
  protected Locality serverKeyb = new LogicalLocality( "serverKeyb" ) ;
  protected Locality usersList = new LogicalLocality( "usersList" ) ;
  protected startClientk dummystartClient ;

  public ChatClientk_1(  ) {
  }

  public void execute() throws KlavaException {
    eval( new startClientk(  ), self ) ;
  }
}

// processes of node ChatClient2
class ChatClientk_2 extends KlavaProcess {

  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality messageKeyb = new LogicalLocality( "messageKeyb" ) ;
  protected Locality serverKeyb = new LogicalLocality( "serverKeyb" ) ;
  protected Locality usersList = new LogicalLocality( "usersList" ) ;
  protected startClientk dummystartClient ;

  public ChatClientk_2(  ) {
  }

  public void execute() throws KlavaException {
    eval( new startClientk(  ), self ) ;
  }
}

// processes of node ChatClient3
class ChatClientk_3 extends KlavaProcess {

  protected Locality server = new LogicalLocality( "server" ) ;
  protected Locality screen = new LogicalLocality( "screen" ) ;
  protected Locality messageKeyb = new LogicalLocality( "messageKeyb" ) ;
  protected Locality serverKeyb = new LogicalLocality( "serverKeyb" ) ;
  protected Locality usersList = new LogicalLocality( "usersList" ) ;
  protected startClientk dummystartClient ;

  public ChatClientk_3(  ) {
  }

  public void execute() throws KlavaException {
    eval( new startClientk(  ), self ) ;
  }
}

// main class
public class ChatClientk {
  static public void main( String args[] ) throws Exception {
    KlavaApplication app = new KlavaApplication();
    Node ChatClient1 =
        new ChatClientNode( "ChatClient1", 9990,
        args[0], Integer.parseInt( args[1] ) ) ;
    ChatClient1.addToEnv( "server", 11000 ) ;
    ChatClient1.addToEnv( "screen", 9991 ) ;
    ChatClient1.addToEnv( "messageKeyb", 9992 ) ;
    ChatClient1.addToEnv( "serverKeyb", 9993 ) ;
    ChatClient1.addToEnv( "usersList", 9994 ) ;
    app.addNode(ChatClient1);
    ChatClient1.start() ;
    ChatClient1.addProcess( new ChatClientk_1() ) ;
    Node ChatClient2 =
        new ChatClientNode( "ChatClient2", 9980,
        args[0], Integer.parseInt( args[1] ) ) ;
    ChatClient2.addToEnv( "server", 11000 ) ;
    ChatClient2.addToEnv( "screen", 9981 ) ;
    ChatClient2.addToEnv( "messageKeyb", 9982 ) ;
    ChatClient2.addToEnv( "serverKeyb", 9983 ) ;
    ChatClient2.addToEnv( "usersList", 9984 ) ;
    app.addNode(ChatClient2);
    ChatClient2.start() ;
    ChatClient2.addProcess( new ChatClientk_2() ) ;
    Node ChatClient3 =
        new ChatClientNode( "ChatClient3", 9970,
        args[0], Integer.parseInt( args[1] ) ) ;
    ChatClient3.addToEnv( "server", 11000 ) ;
    ChatClient3.addToEnv( "screen", 9971 ) ;
    ChatClient3.addToEnv( "messageKeyb", 9972 ) ;
    ChatClient3.addToEnv( "serverKeyb", 9973 ) ;
    ChatClient3.addToEnv( "usersList", 9974 ) ;
    app.addNode(ChatClient3);
    ChatClient3.start() ;
    ChatClient3.addProcess( new ChatClientk_3() ) ;
    app.waitForNodesAndTerminate();
  }
}

// end of file ChatClient.java
