package cryptochat;

import Klava.* ;
import java.io.* ;
import java.awt.BorderLayout ;

public class ChatServerNode extends Node {
    protected KlavaFrame nodeFrame ;
    protected NodeScreen screenNode ;
    protected NodeList usersNode ;
    protected LogicalLocality screen = new LogicalLocality( "screen" ) ;

    public ChatServerNode( String Name, int Here,
                           String NetHostName, int NetPort )
        throws IOException, KlavaException {
        super( Name, Here, NetHostName, NetPort ) ;
        nodeFrame = new KlavaFrame( Name ) ;
        nodeFrame.setNode( this ) ;
        screenNode =
            new NodeScreen( Name + " screen",
            NetUtils.createLocalNodeAddress(Here + 1), NetHostName, NetPort ) ;
        usersNode =
            new NodeList( Name + " users",
            NetUtils.createLocalNodeAddress(Here + 2), NetHostName, NetPort ) ;
        nodeFrame.add( screenNode.getPanel() ) ;
        nodeFrame.add( usersNode.getPanel(), BorderLayout.EAST ) ;
        screenNode.start() ;
        usersNode.start() ;
    }

    protected void show() {
        nodeFrame.pack() ;
        nodeFrame.show() ;
    }

    public static void main( String args[] ) throws IOException, KlavaException {
        if ( args.length < 4 || args.length > 5 )
          throw new
          IOException( "Syntax : Node <name> <localport> <hostname> <port> {DirConnect}" ) ;

        int port = Integer.parseInt(args[1]);
        ChatServerNode n =
            new ChatServerNode( args[0], port,
            args[2], Integer.parseInt( args[3] ) ) ;
        if ( args.length == 5 )
            n.setDirectConnections() ;
        n.addToEnv( "screen", port + 1 ) ;
        n.addToEnv( "users", port + 2 ) ;
        n.start() ;
    }
}
