package cryptomarket;

import java.io.*;
import java.util.Vector	;
import java.util.Enumeration ;

import Klava.*	;

/*
    MarketPlace:
    Args: MarketPlacePhysLoc NetHost NetPort
*/
public class MarketPlacex extends KlavaProcess	{

    class ShopStruct {
        public PhysicalLocality ShopName ;
        public Integer distance ;

        public ShopStruct( int s, int d ) {
            ShopName = NetUtils.createLocalPhyLocAddress(s) ;
            distance = new Integer(d) ;
        }
    }

    protected Vector Shops = new Vector() ;

    public MarketPlacex() {
        Shops.addElement( new ShopStruct( 9990, 3 ) ) ;
        Shops.addElement( new ShopStruct( 9980, 5 ) ) ;
        Shops.addElement( new ShopStruct( 9970, 10 ) ) ;
    }

    public void execute() throws KlavaException {
        KString cshop = new KString( "cshop" ) ;
        KInteger dist ;
        Enumeration en ;
        ShopStruct s ;
        KVector ShopList ;

        while( true ) {
            dist = new KInteger() ; // formal
            Print( "Waiting for requests..." ) ;
            in( cshop, dist, self ) ;
            Print( "Got request for distance " + dist ) ;
            ShopList = new KVector() ;
            Print( "Request cshop, dist " + dist ) ;
            en = Shops.elements() ;
            while ( en.hasMoreElements() ) {
                s = (ShopStruct)en.nextElement() ;
                if ( s.distance.intValue() < dist.intValue() ) {
                    ShopList.addElement(s.ShopName);
                }
            }
            out( cshop, ShopList, self ) ;
        }
    }


    public static void main( String args[] ) throws IOException, KlavaException {
        if ( args.length != 3 ) {
            throw new IOException( "args : MarketPort " +
                                   "nethost netport" ) ;
        }

        Node node ;
        node = new NodeG( "MarketPlace", Integer.parseInt(args[0]),
                          args[1], Integer.parseInt(args[2]) ) ;
        KlavaProcess P = new MarketPlacex() ;

        node.start() ;
        node.addProcess( P ) ;
    }

    synchronized public void Print( String s ) {
        super.Print( "MARKET PLACE : " + s ) ;
    }
}


