package cryptomarket;

import java.io.*;
import java.util.Vector	;
import java.util.Enumeration ;

import Klava.*	;
import Klava.crypto.* ;

/*
    Shop
    java Shop ShopLoc CameraXPrice CameraYPrice

    ShopName : Shop1 | Shop2 | Shop3
*/
class Shopx extends KlavaProcessx {

    class CameraStruct {
        public KString Name ;
        public KInteger Price ;
        public KCipher KPrice ;

        public CameraStruct( String s, int p ) {
            Name = new KString( s ) ;
            Price = new KInteger( p ) ;
            KPrice = new KCipher( Price ) ;
        }
    }

    protected Vector Cameras = new Vector() ;

    public Shopx( int p1, int p2 ) throws Exception {
        super (new KStoreFileAccess("Shops.answers")) ;
        Cameras.addElement( new CameraStruct("CameraX", p1) ) ;
        Cameras.addElement( new CameraStruct("CameraY", p2) ) ;
    }

    public void execute() throws KlavaException {
        Enumeration en = Cameras.elements() ;
        CameraStruct cs ;
        Tuplex t ;
        while ( en.hasMoreElements() ) {
            cs = (CameraStruct) en.nextElement() ;
            try {
                t = new Tuplex() ;
                t.add( cs.Name ) ;
                t.add( cs.KPrice ) ;
                t.encode() ;
                out( t ) ;
            } catch (Exception e) {
                e.printStackTrace ();
            }
        }
    }

    public static void main( String args[] ) throws Exception {
        Node node ;
        PhysicalLocality ShopLocality ;

        if ( args.length != 5 ) {
            throw new IOException
            ("args : shopPort price1 price2 nethost netport" ) ;
        }

        ShopLocality = new PhysicalLocality(
            NetUtils.createLocalNodeAddress
            ( Integer.parseInt(args[0]) )) ;

        node = new NodeG( "Shop_" + args[0], Integer.parseInt(args[0]), args[3],
                         Integer.parseInt(args[4]) ) ;
        KlavaProcessx P = new Shopx( Integer.parseInt(args[1]),
                                     Integer.parseInt(args[2]) );

        node.start() ;
        node.addProcess( P ) ;
    }
}
