
import java.io.* ;
import java.util.* ;
import java.security.* ;
import java.security.cert.* ;
import java.security.spec.* ;
import javax.crypto.* ;
import javax.crypto.spec.* ;

public class Store {

    private KeyStore kKeyStore ;
    public String storeName ;
    public String storePass ;

    public Store() 
	/* throws KeyStoreException, 
	NoSuchAlgorithmException,
	CertificateException,
	IOException */
    {
	try {
	    System.out.println(">ks>CREAZIONE-ACCESSO AL KEYSTORE DEL PROCESSO");
	    kKeyStore = KeyStore.getInstance("JCEKS") ;
	    BufferedReader in = new BufferedReader( new InputStreamReader( System.in ) ) ;
	    System.out.println(">ks>A quale KeyStore vuoi accedere?");
	    storeName = in.readLine() ;
	    try {
		FileInputStream storeis = new FileInputStream( storeName ) ;
		System.out.println(">ks>immetti la password");
		storePass = in.readLine() ;
		char[] pass = storePass.toCharArray() ; 
		kKeyStore.load( storeis, pass ) ;
	    } catch (Exception f) {
		System.out.println(">ks> key store inesistente");
		kKeyStore.load( null, null ) ;
		storeName = null ;
		return;
	    }
	    listKey();
	} catch (Exception e) {
	    e.printStackTrace ();
	}
    }


    public void listKey() throws KeyStoreException, NoSuchAlgorithmException, CertificateException, IOException {
	System.out.println(">ks>----- Queste sono le chiavi persenti nel KeyStore:") ;
	for ( Enumeration e = kKeyStore.aliases() ; e.hasMoreElements() ;) {
	    System.out.println("|  " + e.nextElement());
	}
	System.out.println("------------------- Fine elenco chiavi -------------") ;
    }

    public Key getKey()  throws KeyStoreException, NoSuchAlgorithmException, CertificateException, FileNotFoundException, IOException, UnrecoverableKeyException {
	this.listKey() ;
	BufferedReader in = new BufferedReader( new InputStreamReader( System.in ) ) ;
	String keyAlias ;
	System.out.println(">ks>Immetti il nome della chiave da usare");
	keyAlias = in.readLine() ;
	String keyPass ;
	System.out.println(">ks>Password che protegge la chiave?");
	keyPass = in.readLine() ;
	Key key = kKeyStore.getKey( keyAlias, keyPass.toCharArray() ) ;
	return key ;
	
    }

 
 public void genKey(String alg) throws KeyStoreException, NoSuchAlgorithmException,  IOException, InvalidKeyException, NoSuchProviderException, InvalidKeySpecException {
     /* Generate a key  */
     System.out.println(">ks>Creazione chiave "+ alg +" in corso ........");
     KeyGenerator keygen = KeyGenerator.getInstance(alg, "SunJCE");
     SecretKey desKey = keygen.generateKey();
     addKey( desKey ) ;
 }

    public void addKey(Key key) throws KeyStoreException, NoSuchAlgorithmException,  IOException, InvalidKeyException, NoSuchProviderException, InvalidKeySpecException {
	BufferedReader in = new BufferedReader( new InputStreamReader( System.in ) ) ;
	String keyAlias ;
	System.out.println(">ks>Che nome dai a questa chiave?");
	keyAlias = in.readLine() ;
	String keyPass ;
	System.out.println(">ks>Password per proteggere la chiave?");
	keyPass = in.readLine() ;
	kKeyStore.setKeyEntry( keyAlias, key, keyPass.toCharArray(), null );
    }

  public void delKey() throws KeyStoreException, CertificateException, IOException, NoSuchAlgorithmException  {
      listKey() ;
      BufferedReader in = new BufferedReader( new InputStreamReader( System.in ) ) ;
      String keyAlias ;
      System.out.println(">ks>Che chiave vuoi cancellare?");
      keyAlias = in.readLine() ;
      //String keyPass ;
      //System.out.println("Password per proteggere la chiave?");
      //keyPass = in.readLine() ;
      kKeyStore.deleteEntry( keyAlias );
  }

    public void save() throws IOException, KeyStoreException, NoSuchAlgorithmException, CertificateException {
	if ( storeName == null ) {
	    BufferedReader in = new BufferedReader( new InputStreamReader( System.in ) ) ;
	    System.out.println(">ks>Nome del file dove salvare il keystore?");
	    storeName = in.readLine() ;
	    System.out.println(">ks>Password per proteggere il keystore?");
	    storePass = in.readLine() ;
	}
	System.out.println("Salvataggio KeyStore");
	System.out.println("File name: "+ storeName);
	System.out.println("Password: "+ storePass);
	FileOutputStream storeos = new FileOutputStream(storeName);
	kKeyStore.store( storeos, storePass.toCharArray() ) ;
	storeos.close() ;
    }
   
    
}
