// Test a local retrieval using keystores

package test_crypto;

import java.io.* ;
import Klava.* ;
import Klava.crypto.*;
import javax.crypto.* ;
import javax.crypto.spec.* ;

class RetrieveLocalWKStore extends KlavaProcessx {

    public RetrieveLocalWKStore(String answer_file) throws Exception {
        super (new KStoreFileAccess (answer_file));
    }

    public void execute() throws KlavaException {
        try {
            Tuplex tx1 = new Tuplex() ;
            tx1.add(new KString("lorenzo")) ;
            KString s = new KString("secret data") ;
            tx1.add( new KCipher(s)) ;
            out(tx1,self) ;
            
            KString fString1 = new KString() ;
            KString s1 = new KString() ;
            Tuplex txf1 = new Tuplex() ;
            txf1.add( s1 ) ;
            KCipher k = new KCipher(fString1);
            txf1.add( k ) ;
            
            read(txf1, self) ;
            
            out(txf1, self) ;
            out(fString1,self);
            out(s1,self);
        } catch (Exception e) {
            e.printStackTrace ();
        }
    }
}

public class TryLocalWKStore {
    static public void main  (String args[]) throws Exception {
	Node Node2 = new NodeG ("nodo2", "localita2", "localhost", 9999);
        Node2.setLocalMatcher (new KCipherLocalMatcher ());
        Node2.setLocalTupleSpaceMatcher
            (new KCipherLocalTupleSpaceMatcher ());
	Node2.start();

        String answer_file = "TryLocalWKStore.answers";
        if (args.length > 0)
            answer_file = args[0];

	Node2.addProcess (new RetrieveLocalWKStore (answer_file));
    }
}
