// Test a remote retrieval using keystores
// it must be used together with Trystore

package test_crypto;

import java.io.* ;
import Klava.* ;
import Klava.crypto.*;
import javax.crypto.* ;
import javax.crypto.spec.* ;


class RetrieveRemoteWKStore extends KlavaProcessx {

    protected Locality dati = new LogicalLocality("dati");

    public RetrieveRemoteWKStore(String answer_file) throws Exception {
        super (new KStoreFileAccess (answer_file));
    }

    public void execute() throws KlavaException {
        try {
            KString fString1 = new KString() ;
            KString s1 = new KString() ;
            Tuplex txf1 = new Tuplex() ;
            txf1.add( s1 ) ;
            KCipher k = new KCipher(fString1);
            txf1.add( k ) ;
 
            read(txf1, dati) ;

            out(txf1, self) ;
            out(fString1,self);
            out(s1,self);
        } catch (Exception e) {
            e.printStackTrace ();
        }
    }
}

public class TryRemoteWKStore {
    static public void main  (String args[]) throws Exception {
	Node Node2 = new NodeG ("nodo2", "localita2", "localhost", 9999);
	//Node2.addToEnv("qua", "localita2");
	Node2.addToEnv("dati", "localita1");
        Node2.setLocalMatcher (new KCipherLocalMatcher ());
        Node2.setLocalTupleSpaceMatcher
            (new KCipherLocalTupleSpaceMatcher ());
	Node2.start();

        String answer_file = "Trystore.answers";
        if (args.length > 0)
            answer_file = args[0];

        // we use the same of Trystore because they use the same keys
	Node2.addProcess (new RetrieveRemoteWKStore (answer_file));
    }
}
