package Klava.debug.event;

import Klava.PhysicalLocality;
import Klava.debug.Location;

public abstract class BreakpointEvent extends LocatableEvent {

  protected int bid ;
  protected boolean triggerSuspension ;

  public BreakpointEvent( int bid, String agentId, PhysicalLocality locality,
                          Location location, boolean triggerSuspension )
  {
    super( agentId, locality, location ) ;
    this.bid = bid ;
    this.triggerSuspension = triggerSuspension ;
  }

  public BreakpointEvent( BreakpointEvent be ) {
    this( be.bid, be.agentId, be.locality, be.location, be.triggerSuspension ) ;
  }

  public int getBreakId() {
    return bid ;
  }

  public boolean triggerSuspension() {
    return triggerSuspension ;
  }

  public String paramString() {
    return "bid=" + bid + ", " + super.paramString() ;
  }

}
