// Co-located occurred breakpoint events
package Klava.debug.event;

import java.util.List;
import java.util.Iterator;

public class BreakpointEvents extends BreakpointEvent {

  protected boolean triggerSuspension ;
  protected List breakpointEvents ;

  public BreakpointEvents( BreakpointEvent be ) {
    super( be ) ;
  }

  public void addEvent( BreakpointEvent be ) {
    breakpointEvents.add( be ) ;
    this.triggerSuspension |= be.triggerSuspension ;
  }

  public boolean triggerSuspension() {
    return triggerSuspension ;
  }

  public BreakpointEvent getEvent( int index ) {
    return ( BreakpointEvent ) breakpointEvents.get( index ) ;
  }

  public int eventCount() {
    return breakpointEvents.size() ;
  }

  public Iterator eventIterator() {
    return breakpointEvents.iterator() ;
  }

  public String paramString() {
    return "suspension=" +  triggerSuspension + ", events=" + breakpointEvents ;
  }

}